package com.intuit.sbfinance.json;

import com.intuit.schema.finance.v3.BatchItemRequest;
import com.intuit.schema.finance.v3.BatchItemResponse;
import com.intuit.schema.finance.v3.IntuitResponse;
import com.intuit.schema.finance.v3.RecurringTransaction;
import com.intuit.schema.finance.v3.QueryResponse;

import org.codehaus.jackson.map.introspect.AnnotatedClass;
import org.codehaus.jackson.xc.JaxbAnnotationIntrospector;

/**
 * This custom introspector doesn't really do anything extra from the default JAXB one, we just
 * need to override it so it will use our custom filter
 * 
 * @author yujungs700
 *
 */
public class CustomJaxbAnnotationIntrospector extends JaxbAnnotationIntrospector {
    @Override
    public Object findFilterId(AnnotatedClass ac) {
        Class<?> classType = ac.getRawType();
        if (classType.equals(IntuitResponse.class) || 
            classType.equals(QueryResponse.class) ||
            classType.equals(BatchItemResponse.class) ||
            classType.equals(BatchItemRequest.class) ||
            classType.equals(RecurringTransaction.class)) {
            return "IntuitServiceV3ResponseFilter";
        }
        return super.findFilterId(ac);
    }
}
