package com.intuit.sb.payroll.ca.workerpayment;

public enum CanadaLawID 
{
	// Compensation Laws
	Regular_Hourly("1000012"),
	Regular_Salary ("1000013"),
	Overtime("1000026"),
	Bonus("1000005"),
	Piecework("1000015"),
	VacationPay("1000102"),
	
	// Taxable Benefit Laws
	CompanyPaidGroupHealth("1000060"),
	Parking("1000103"),
	TransitPass("1000104"),
	
	// Non-Taxable Benefit Laws
	RRSPMatching("1000014"),
	
	// Deduction Laws
	RRSP("1000006"),
	Alimony("1000107"),
	SocialFund("1000106"),
	LoanRepayment("1000105"),
	
	// Statutory Deduction Laws (Taxes)
	CPP_EE("22"),
	CPP_ER("23"),
	EI_EE("20"),
	EI_ER("21"),
	FED_TAX("2"),
	
	// Provincial Tax Laws
	PROV_TAX_AB("6"),
	PROV_TAX_ON("14"),
	PROV_TAX_BC("7"),
	PROV_TAX_SK("17"),
	PROV_TAX_MB("8"),
	PROV_TAX_NL("10"),
	PROV_TAX_NB("9"),
	PROV_TAX_PE("15"),
	PROV_TAX_NS("11"),
	PROV_TAX_NT("12"),
	PROV_TAX_YT("18"),
	PROV_TAX_NU("13");
	
	private final String lawId;
	
	public String getLawId() {
		return lawId;
	}

	private CanadaLawID(String lawId)
	{
		this.lawId = lawId;
	}


}
