package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.text.MessageFormat;
import java.util.Map;

import com.intuit.dataTypes.Money;
import com.intuit.payroll.types.enumtype.DatumID;
import com.intuit.sb.payroll.entity.ca.model.TD1Detail;
import com.intuit.sb.payroll.entity.model.EmployerComplianceDocDtl;
import com.intuit.sb.payroll.entity.model.PayrollItemDtl;
import com.intuit.sb.payroll.entity.model.TaxDtl;
import com.intuit.sb.payroll.entity.model.WorkerComplianceDocDtl;

public class QBOEMappedDeductionCanada extends QBOEMappedDeductionBase {

	public QBOEMappedDeductionCanada() {
		super();
	}

	public QBOEMappedDeductionCanada(PayrollItemDtl payrollItemDtl) {
		super(payrollItemDtl);
	}

	public QBOEMappedDeductionCanada(TaxDtl taxDtl,
			Map<String, EmployerComplianceDocDtl> employerComplianceDocDtlMap,
			Map<String, WorkerComplianceDocDtl> workerComplianceDocDtlMap) {
		super(taxDtl, employerComplianceDocDtlMap, workerComplianceDocDtlMap);
	}

	@Override
	protected void mapEmployerDocDtls(
			Map<String, EmployerComplianceDocDtl> employerComplianceDocDtlMap) {
		// TODO Auto-generated method stub

	}

	@Override
	protected void mapWorkerDocDtls(
			Map<String, WorkerComplianceDocDtl> workerComplianceDocDtlMap) {
		// Get the worker's withholding for this tax
		WorkerComplianceDocDtl workerComplianceDocDtl = workerComplianceDocDtlMap.get(lawId.toString());
		switch (workerComplianceDocDtl.getComplianceDocType()) {
		case TD1_CRA:
		case TD1_PROV:
			TD1Detail td1Detail = (TD1Detail)workerComplianceDocDtl;
			mapTD1(td1Detail);
			break;
		default:
			String mesg2 = MessageFormat.format("Incomplete worker compliance type ''{0}'' (LawId={1}).",
					new Object[] {workerComplianceDocDtl.getComplianceDocType(), lawId});
			throw new IllegalArgumentException(mesg2);
		}

	}

	private void mapTD1(TD1Detail detail) {
		
		Money value = new Money(detail.getTotalClaimAmount().getAmount().toString());
		
		MappedWithholding withholding = new MappedWithholding(DatumID.EXEMPTION_AMOUNT, value);
		addMappedWithholding(withholding);
	}

}
