package com.intuit.sb.payroll.capability.ca.workerpayment;

import java.math.BigDecimal;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import com.intuit.sb.payroll.entity.model.Money;
import com.intuit.sb.payroll.entity.model.PaycheckLineItem;
import com.intuit.sb.payroll.entity.model.PtdDatumType;

public class PaycheckUtils {
	private static Logger logger = LogManager.getLogger(LineItemAmount.class);

	public static boolean verifyLineItems(Set<PaycheckLineItem> computedItems, LineItemAmount [] expectedItems,
			String lineItemTypeStr) {
		boolean compareResult = (computedItems.size() == expectedItems.length);
		if (true == compareResult) {
			HashSet<LineItemAmount> computedLineItemSet = new HashSet<LineItemAmount>();
			Iterator<PaycheckLineItem> iterator = computedItems.iterator();
			while (iterator.hasNext()) {
				PaycheckLineItem paycheckLineItem = iterator.next();
				Money lineItemValue = paycheckLineItem.getValue();
				if (lineItemValue != null) {
					LineItemAmount lineItemAmount = new LineItemAmount(paycheckLineItem.getLawId(),
							lineItemValue.getAmount(), 
							getYtdAmount(paycheckLineItem),
							getIsttAmount(paycheckLineItem),
							getWagebaseAmount(paycheckLineItem));
					computedLineItemSet.add(lineItemAmount);
				}
			} 
			HashSet<LineItemAmount> expectedLineItemSet = new HashSet<LineItemAmount>();
			for(int i=0; i < expectedItems.length; i++) {
				expectedLineItemSet.add(expectedItems[i]);
			}
			compareResult = computedLineItemSet.equals(expectedLineItemSet);
		}

		if (false == compareResult) {
			logger.error("Computed " + lineItemTypeStr);            
			Iterator<PaycheckLineItem> iterator = computedItems.iterator();
			while (iterator.hasNext()) {
				PaycheckLineItem paycheckLineItem = iterator.next();
				Money lineItemValue = paycheckLineItem.getValue();
				if (lineItemValue != null) {
					logger.error(paycheckLineItem.getLawId() + " -  amount=" +
							lineItemValue.getAmount() + ",  YTD Amount=" + 
							getYtdAmount(paycheckLineItem) + ", ISTT Amount=" +
							getIsttAmount(paycheckLineItem) + ", WageBase Amount=" +
							getWagebaseAmount(paycheckLineItem));  
				}
			}            
			logger.error("Expected " + lineItemTypeStr);            
			for(int i=0; i < expectedItems.length; i++) {
				logger.error((expectedItems[i].getItemId())+
						" -  amount=" + expectedItems[i].getAmount() + ",  YTD Amount=" +
						expectedItems[i].getYtdAmount() + "  ISTT Amount=" +
						expectedItems[i].getIsttAmount() + " WageBase Amount=" +
						expectedItems[i].getWagebaseAmount());            
			}            
		}

		return compareResult;
	}

	public static BigDecimal getYtdAmount(PaycheckLineItem paycheckLineItem) {
		PtdDatumType ptdDatumType = paycheckLineItem.getYtdDatum().getDatum();
		return ptdDatumType.getMoneyValue().getAmount();
	}

	public static BigDecimal getIsttAmount(PaycheckLineItem paycheckLineItem) {
		Money isttAmt = paycheckLineItem.getIncomeSubjectToTax();
		return isttAmt.getAmount();
	}

	public static BigDecimal getWagebaseAmount(PaycheckLineItem paycheckLineItem) {
		Money wagebasetAmt = paycheckLineItem.getWageBase();
		return wagebasetAmt.getAmount();
	}
}
