package com.intuit.sb.payroll.capability.workerpayments;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.entity.model.DateRange;
import com.intuit.sb.payroll.entity.model.PayrollDistributionMethodEnum;
import com.intuit.sb.payroll.entity.model.PayrollFrequencyEnum;

/**
 * This DTO encapsulates the data required to execute a paycheck calculation.
 * 
 * $Author$ $Revision$ $DateTime$
 */
public class PaycheckCalculationRequest implements Serializable {

	private static final long serialVersionUID = -2492609929843327982L;
	
	private Date paycheckDate;
	private DateRange payPeriod;
	private List<CalculationInputs> calculationInputs;
	private Long workerId;
	private PayrollFrequencyEnum frequency;
	private PayrollDistributionMethodEnum distributionMethod;
	private boolean partialPayPeriod = false;

	public PaycheckCalculationRequest() {

	}

	public Date getPaycheckDate() {
		return paycheckDate;
	}

	public void setPaycheckDate(Date paycheckDate) {
		this.paycheckDate = paycheckDate;
	}

	public DateRange getPayPeriod() {
		return payPeriod;
	}

	public void setPayPeriod(DateRange payPeriod) {
		this.payPeriod = payPeriod;
	}

	public List<CalculationInputs> getCalculationInputs() {
		return calculationInputs;
	}

	public void setCalculationInputs(List<CalculationInputs> calculationInputs) {
		this.calculationInputs = calculationInputs;
	}

	public Long getWorkerId() {
		return workerId;
	}

	public void setWorkerId(Long workerId) {
		this.workerId = workerId;
	}

	public PayrollFrequencyEnum getFrequency() {
		return frequency;
	}

	public void setFrequency(PayrollFrequencyEnum frequency) {
		this.frequency = frequency;
	}

	public PayrollDistributionMethodEnum getDistributionMethod() {
		return distributionMethod;
	}

	public void setDistributionMethod(PayrollDistributionMethodEnum distributionMethod) {
		this.distributionMethod = distributionMethod;
	}

	public void setPartialPayPeriod(boolean partialPayPeriod) {
		this.partialPayPeriod = partialPayPeriod;
	}

	public boolean isPartialPayPeriod() {
		return partialPayPeriod;
	}
	
	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
