package com.intuit.sb.payroll.capability.workerpayments;

import java.io.Serializable;
import java.util.List;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * A DTO that encapsulates the data needed to save a payroll run. It consists of the Calculation Inputs (not calculated
 * values) and the other data that defines the PayrollRun.
 * 
 * The PayrollRun itself should not be created/modified by clients, since the key values in that entity are calculated,
 * and only the domain services should be doing that work.
 * 
 * $Author$ 
 * $Revision$ 
 * $DateTime$
 */
public class PayrollRunCommitRequest implements Serializable {

	private static final long serialVersionUID = 1370638339496803270L;

	private Long payrollRunId;
	private List<PaycheckCalculationRequest> calculationRequests;
	private PayrollRunInfo payrollRunInfo;

	public PayrollRunCommitRequest() {
	}

	public Long getPayrollRunId() {
		return payrollRunId;
	}

	public void setPayrollRunId(Long payrollRunId) {
		this.payrollRunId = payrollRunId;
	}

	public List<PaycheckCalculationRequest> getCalculationRequests() {
		return calculationRequests;
	}

	public void setCalculationRequests(List<PaycheckCalculationRequest> calculationRequests) {
		this.calculationRequests = calculationRequests;
	}

	public PayrollRunInfo getPayrollRunInfo() {
		return payrollRunInfo;
	}

	public void setPayrollRunInfo(PayrollRunInfo payrollRunInfo) {
		this.payrollRunInfo = payrollRunInfo;
	}
	
	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
