package com.intuit.sb.payroll.capability.workerpayments.impl;

import java.util.List;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.capability.workerpayments.PaycheckUpdateRequest;
import com.intuit.sb.payroll.capability.workerpayments.PayrollRunUpdateRequest;

/**
 * Validates {@link PayrollRunUpdateRequest} beans for integrity prior to processing.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
class PayrollRunUpdateRequestValidator {
	
	private PayrollRunUpdateRequestValidator(){}
	
	/**
	 * Ensures that the minimal information is present to process an update request.
	 * 
	 * @param request
	 * @throws ValidationException
	 */
    static void validatePayrollRunUpdateRequest(PayrollRunUpdateRequest request) throws ValidationException {
		if (null == request) {
			throw new ValidationException("PayrollRunUpdateRequest is null");
		}
		List<PaycheckUpdateRequest> paycheckUpdateRequests = request.getPaycheckUpdateRequests();
		if (null == paycheckUpdateRequests) {
			throw new ValidationException("PaycheckUpdateRequest list is null");
		}
		if (0 == paycheckUpdateRequests.size()) {
			throw new ValidationException("PaycheckUpdateRequest list is empty");
		}
		for (PaycheckUpdateRequest paycheckUpdateRequest : paycheckUpdateRequests) {
			if (null == paycheckUpdateRequest) {
				throw new ValidationException("PaycheckUpdateRequest is null");
			}
		}
    }
}
