package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import java.util.Collection;
import java.util.Map;

import com.intuit.payroll.j.AdjustmentIf;
import com.intuit.payroll.j.AdjustmentLineIf;
import com.intuit.payroll.j.PayrollDatumIf;
import com.intuit.payroll.types.enumtype.DatumID;
import com.intuit.sb.payroll.entity.model.EmployerAdjLineItem;
import com.intuit.sb.payroll.entity.model.EmployerAdjustment;
import com.intuit.sb.payroll.entity.model.Money;
import com.intuit.sb.payroll.entity.model.PayrollItem;

public class EmployerAdjustmentMapper {
	
	public static EmployerAdjustment mapCompanyAdjustments(Collection<AdjustmentIf> companyAdjustments, AdjustmentContext payrollRunContext, Map<String, PayrollItem> payrollItemMap) {
		EmployerAdjustment response = null;

		for (AdjustmentIf adjustmentIf : companyAdjustments) {
			Collection<AdjustmentLineIf> lines = adjustmentIf.getLines();
			if (lines.size() > 0) {
				response = new EmployerAdjustment();
			}
			for (AdjustmentLineIf adjustmentLineIf : lines) {
				PayrollDatumIf amountDatum = adjustmentLineIf.getDatum(DatumID.AMOUNT);
				Money amount = new Money(amountDatum.getValue().toString());
				EmployerAdjLineItem domainLineItem = new EmployerAdjLineItem();
				domainLineItem.setAdjustmentAmount(amount);
				String lawId = new Integer(adjustmentLineIf.getPayrollItem().getDetailType().toInt()).toString();
				domainLineItem.getLawId().setValue(lawId);
				
				PayrollItem payrollItem = payrollItemMap.get(lawId);
				domainLineItem.setPayrollItem(payrollItem);
				response.addEmployerAdjLineItem(domainLineItem);
			}
		}

		return response;
	}

}
