package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import com.intuit.payroll.types.enumtype.PaidTimeOffAccrualType;
import com.intuit.sb.payroll.entity.model.PaidTimeOffAccrualTypeEnum;

public class PaidTimeOffAccrualTypeMapper {

	public static PaidTimeOffAccrualType map(PaidTimeOffAccrualTypeEnum accrualType) {
		switch (accrualType) {
			case EACH_PAYCHECK:
				return PaidTimeOffAccrualType.PER_PAYCHECK;
				
			case HOURLY:
				return PaidTimeOffAccrualType.PER_HOUR;
				
			case PER_YEAR_FROM_HIRE_DATE:
				return PaidTimeOffAccrualType.PER_YEAR_ON_HIRE_DATE;
			
			case PER_YEAR_START_OF_YEAR:
				return PaidTimeOffAccrualType.PER_YEAR_ON_JAN_1;
				
			case PER_YEAR_PRORATED:
				return PaidTimeOffAccrualType.PER_YEAR_PRORATED;
				
			default:
				return null;
		}
	}

}
