package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import com.intuit.dataTypes.Money;
import com.intuit.dataTypes.QBDate;
import com.intuit.payroll.j.PayrollItemTotalsIf;
import com.intuit.payroll.j.TaxJurisdictionIf;
import com.intuit.payroll.types.enumtype.DatumID;
import com.intuit.payroll.types.enumtype.TotalsTransactionType;
import com.intuit.sb.payroll.entity.model.PayrollItemDtlPtdDatum;

public class PayrollItemTotalsMapper {
	
	
	/**
	 * Maps a {@link PayrollItemDtlPtdDatum} to a PayrollItemTotalsIf.
	 * @param totals
	 * @param pdtDatum
	 */
	public static void mapPayrollItemDtlPtdDatumToPayrollItemTotals(TaxJurisdictionIf live, TaxJurisdictionIf work, PayrollItemTotalsIf totals, PayrollItemDtlPtdDatum pdtDatum) {

		QBDate periodStart = new QBDate(pdtDatum.getDatum().getPeriod().getStartDate());
		QBDate periodEnd = new QBDate(pdtDatum.getDatum().getPeriod().getEndDate());
	
		Money totalValue = new Money(pdtDatum.getDatum().getMoneyValue().getAmount().toString());
		Money pckTotalValue = new Money(pdtDatum.getDatum().getMoneyValue().getAmount().toString());
		totals.setTotalFromDB(DatumID.TOTAL_AMOUNT, TotalsTransactionType.ALL, 
				totalValue, 
				periodStart, periodEnd, live, work);
		totals.setTotalFromDB(DatumID.TOTAL_AMOUNT, TotalsTransactionType.PAYCHECKS_YTDS, 
				pckTotalValue, 
				periodStart, periodEnd, live, work);
		
		Money totalWageBase = new Money(pdtDatum.getDatum().getWageBaseValue().getAmount().toString());
		Money pckTotalWageBase = new Money(pdtDatum.getDatum().getWageBaseValue().getAmount().toString());
		totals.setTotalFromDB(DatumID.TOTAL_WAGE_BASE, TotalsTransactionType.ALL, 
				totalWageBase, 
				periodStart, periodEnd, live, work);
		totals.setTotalFromDB(DatumID.TOTAL_WAGE_BASE, TotalsTransactionType.PAYCHECKS_YTDS, 
				pckTotalWageBase, 
				periodStart, periodEnd, live, work);
		
		Money totalIsst = new Money(pdtDatum.getDatum().getIncomeSubjectToTaxValue().getAmount().toString());
		Money pckTotalIsst = new Money(pdtDatum.getDatum().getIncomeSubjectToTaxValue().getAmount().toString());
		totals.setTotalFromDB(DatumID.TOTAL_INCOME_SUBJECT_TO_TAX, TotalsTransactionType.ALL, 
				totalIsst, 
				periodStart, periodEnd, live, work);
		totals.setTotalFromDB(DatumID.TOTAL_INCOME_SUBJECT_TO_TAX, TotalsTransactionType.PAYCHECKS_YTDS, 
				pckTotalIsst, 
				periodStart, periodEnd, live, work);
	}
}
