package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import com.intuit.payroll.j.LoggerIf;
import com.intuit.sb.payroll.InfrastructureException;

/**
 * Implementation of QBOE PPE logger interface. Integrates PPE logging into
 * our engine logging.
 * 
 *  To enable debug, set the following Logger setting in log4j.xml:
 *  <code>
 *  <logger name="com.intuit.payroll.qboe">
 *    	<level value="DEBUG" />
 *  </logger>
 *  </code>
 */
@SuppressWarnings("nls")
public class QBOELog implements LoggerIf {
	private static Logger logger = LogManager.getLogger("com.intuit.payroll.engine");

	public void debug (Object o, String s) {
		logger.debug(s + ": " + o.getClass().toString());
	}

	public void debug(Object o, String s, Throwable e) {
		logger.debug(s + ": " + o.getClass().toString(), e);
	}

	public void info (Object o, String s) {
		logger.info(s + ": " + o.getClass().toString());
	}

	public void info (Object o, String s, Throwable e) {
		logger.info(s + ": " + o.getClass().toString(), e);
	}

	public void error (Object o, String s) {
		logger.error(s + ": " + o.getClass().toString());
	}

	public void error (Object o, String s, Throwable e) {
		logger.error(s + ": " + o.getClass().toString(), e);
	}

	public void fatal (Object o, String s, Throwable e) {
		logger.fatal(s + ": " + o.getClass().toString(), e);
	}

	public boolean debugLevel() {
		return logger.isDebugEnabled();
	}
	
	public String findLogDir(String dir) throws Exception {
		throw new InfrastructureException();
	}
}
