package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine;

/**
 * It's the new Law.h!
 * 
 * $Author$ 
 * $Revision$ 
 * $DateTime$
 */
@SuppressWarnings("nls")
public class QboeLawIdConstants {

	/**
	 * <P>
	 * The QBOE lawId value for a salary payroll item
	 * </P>
	 */
	public static final String sSalaryLawId = "1000013";

	/**
	 * <P>
	 * The QBOE lawId value for an hourly payroll item
	 * </P>
	 */
	public static final String sHourlyLawId = "1000012";
	
	/**
	 * <P>
	 * The QBOE lawId value for an hourly overtime payroll item
	 * </P>
	 */
	public static final String sOvertimeLawId = "1000026";
	
	/**
	 * <P>
	 * The QBOE lawId value for an hourly DoubleTime payroll item
	 * </P>
	 */
	public static final String sDoubleTimeLawId = "1000003";
	
	/**
	 * <P>
	 * The QBOE lawId value for a commission payroll item
	 * </P>
	 */
	public static final String sCommissionLawId = "1000025";
	
	/**
	 * <P>
	 * The QBOE lawId value for a PaycheckTips payroll item
	 * </P>
	 */
	public static final String sPaycheckTipsLawId = "1000004";
	
	/**
	 * <P>
	 * The QBOE lawId value for a CashTips payroll item
	 * </P>
	 */
	public static final String sCashTipsLawId = "1000041";
	
	/**
	 * <P>
	 * The QBOE lawId value for a CashTipsOut payroll item
	 * </P>
	 */
	public static final String sCashTipsOutLawId = "1000042";
	
	/**
	 * <P>
	 * The QBOE lawId value for a AllocatedTips payroll item
	 * </P>
	 */
	public static final String sAllocatedTipsLawId = "1000048";
	
	/**
	 * <P>
	 * The QBOE lawId value for a bonus payroll item
	 * </P>
	 */
	// FIXME [Test] we should not have to refer to law IDs - Tim fix this.
	public static final String sBonusLawId = "1000005";
	
	/**
	 * <P>
	 * The QBOE lawId value for a Piecework payroll item
	 * </P>
	 */
	public static final String sPieceworkLawId = "1000015";
	
	/**
	 * <P>
	 * The QBOE lawId value for the Federal Income Tax payroll item
	 * </P>
	 */
	public static final String sFICALawId = "1";
	
	/**
	 * <P>
	 * The QBOE lawId value for the employee's Social Security Tax payroll item
	 * </P>
	 */
	public static final String sSST_EELawId = "61";
	
	/**
	 * <P>
	 * The QBOE lawId value for the employer's Social Security Tax payroll item
	 * </P>
	 */
	public static final String sSST_ERLawId = "62";
	
	/**
	 * <P>
	 * The QBOE lawId value for the employee's Medicare Tax payroll item
	 * </P>
	 */
	public static final String sMED_EELawId = "63";
	
	/**
	 * <P>
	 * The QBOE lawId value for the employer's Medicare Tax payroll item
	 * </P>
	 */
	public static final String sMED_ERLawId = "64";
	
	/**
	 * <P>
	 * The QBOE lawId value for the Federal Unemployment Insurance payroll item
	 * </P>
	 */
	public static final String sFUTALawId = "66";
	
	/**
	 * <P>
	 * The QBOE lawId value for the California Personal Income Tax payroll item
	 * </P>
	 */
	public static final String sCAPITLawId = "6";
	
	/**
	 * <P>
	 * The QBOE lawId value for the California State Disability Insurance payroll item
	 * </P>
	 */
	public static final String sCASDILawId = "67";
	
	/**
	 * <P>
	 * The QBOE lawId value for the California State Unemployment Insurance payroll item
	 * </P>
	 */
	public static final String sCASUILawId = "87";
	
	/**
	 * <P>
	 * The QBOE lawId value for the California Employment Training Tax payroll item
	 * </P>
	 */
	public static final String sCAETTLawId = "142";
	
	/**
	 * <P>
	 * The lawId value for the San Francisco Payroll Tax payroll item
	 * </P>
	 */
	public static final String sCASFPTLawId = "5440"; // TODO need to set a real
	// value here which is
	// unique for SF Payroll
	// tax

	/**
	 * <P>
	 * The QBOE lawId value for the Texas State Unemployment Insurance payroll item
	 * </P>
	 */
	public static final String sTXSUILawId = "127";
    
    /**
     * <P>
     * The QBOE lawId value for the Advance Income Tax Credit payroll item
     * </P>
     */
    public static final String sAeicId = "143";
    
    /**
     * <P>
     * The QBOE lawId value for the Section 125 Health payroll item
     * </P>
     */
	public static final String sSec125HealthId = "1000001";
    
    /**
     * <P>
     * The QBOE lawId value for the 401K payroll item
     * </P>
     */
	public static final String s401KId = "1000006";
    
    /**
     * <P>
     * The QBOE lawId value for the 401K Match payroll item
     * </P>
     */
    public static final String s401KMatchId = "1000014";
    
    /**
     * <P>
     * The QBOE lawId value for the Vacation accrual payroll item
     * </P>
     */
	public static final String sVacationAccrualLawId = "1000018";
    
    /**
     * <P>
     * The QBOE lawId value for the Vacation Disbursement payroll item
     * </P>
     */
	public static final String sVacationDisbursementLawId = "1000019";
    
    /**
     * <P>
     * The QBOE lawId value for the Vacation payout payroll item
     * </P>
     */
	public static final String sVacationPayoutLawId = "1000024";
    
    /**
     * <P>
     * The QBOE lawId value for the Sick time accrual payroll item
     * </P>
     */
	public static final String sSickTimeAccrualLawId = "1000020";
    
    /**
     * <P>
     * The QBOE lawId value for the Sick time disbursement payroll item
     * </P>
     */
	public static final String sSickTimeDisbursementLawId = "1000021";
    
    /**
     * <P>
     * The QBOE lawId value for the Sick time payout payroll item
     * </P>
     */
	public static final String sSickTimePayoutLawId = "1000023";
    
    /**
     * <P>
     * The QBOE lawId value for the Mileage reimbursement payroll item
     * </P>
     */
    public static final String sMileageReimbursementId = "1000002";
	
    /**
     * <P>
     * The QBOE lawId value for the other reimbursement payroll item
     * </P>
     */
    public static final String sOtherReimbursementId = "1000045";
	
    /**
     * <P>
     * The QBOE lawId value for COBRA Premium Credit
     * </P>
     */
    public static final String sCobraPremiumCredit = "196";
	
	private QboeLawIdConstants() {
	}

}
