/**
 * 
 */
package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.handlers;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Set;

import com.intuit.payroll.j.EmployeeIf;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext;
import com.intuit.sb.payroll.entity.model.HealthBenefitDtl;
import com.intuit.sb.payroll.entity.model.HealthBenefitTypeEnum;
import com.intuit.sb.payroll.entity.model.Worker;

/**
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 *
 */
public class CACompanyPaidHealthBenefitHandler extends AbstractFlatRateDeductionHandler {

	private static List<Locale> localeList = new ArrayList<Locale>();
	
	static {
		localeList.add(Locale.CANADA);
	}
	
	/**
	 * FIXME get the law id from CanadaLawId
	 */
	public String getLawId() {
		return "";
	}
	
	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollItemHandler#handle(com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext)
	 */
	public void handle(PaycheckCalculationContext context) {
		Set<HealthBenefitDtl> workerBenefits = context.getWorker().getHealthBenefitDtls();
		for (final HealthBenefitDtl healthBenefitDtl : workerBenefits) {
			if (healthBenefitDtl.getBenefitType() == HealthBenefitTypeEnum.COMPANYPAIDHEALTH) {
				handleImpl(context, healthBenefitDtl);
			}
		}
	}
	
	public void createQboPayrollItemsFromPayrollItemDtls(PayrollEngineContext context, EmployeeIf employee,
			Worker worker) {
		Set<HealthBenefitDtl> workerBenefits = worker.getHealthBenefitDtls();
		for (final HealthBenefitDtl healthBenefitDtl : workerBenefits) {
			if (healthBenefitDtl.getBenefitType() == HealthBenefitTypeEnum.COMPANYPAIDHEALTH) {
				createImpl(context, worker, employee, healthBenefitDtl);
			}
		}
	}

	public List<Locale> getLocaleList() {
		return localeList ;
	}
}
