package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.handlers;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Set;

import com.intuit.payroll.j.EmployeeIf;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext;
import com.intuit.sb.payroll.entity.model.OtherBenefitDtl;
import com.intuit.sb.payroll.entity.model.OtherBenefitTypeEnum;
import com.intuit.sb.payroll.entity.model.Worker;

/**
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 *
 */
public class CATransitBenefitHandler extends AbstractFlatRateDeductionHandler {

	private static List<Locale> localeList = new ArrayList<Locale>();
	
	//FIXME this can come from JavaConfig @ExternalValue?  Otherwise, externalize locale-to-handler collections.
	static {
		localeList.add(Locale.CANADA);
	}
	
	/**
	 * FIXME get the law id from CanadaLawId
	 */
	public String getLawId() {
		return "";
	}
	
	/* (non-Javadoc)
	 * @see com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollItemHandler#handle(com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext)
	 */
	public void handle(PaycheckCalculationContext context) {
		Set<OtherBenefitDtl> workerBenefits = context.getWorker().getOtherBenefitDtls();
		for (final OtherBenefitDtl benefitDtl : workerBenefits) {
			if (benefitDtl.getBenefitType() == OtherBenefitTypeEnum.TRANSITPASS) {
				handleImpl(context, benefitDtl);
			}
		}
	}
	
	public void createQboPayrollItemsFromPayrollItemDtls(PayrollEngineContext context, EmployeeIf employee,
			Worker worker) {
		Set<OtherBenefitDtl> workerBenefits = worker.getOtherBenefitDtls();
		for (final OtherBenefitDtl benefitDtl : workerBenefits) {
			if (benefitDtl.getBenefitType() == OtherBenefitTypeEnum.TRANSITPASS) {
				createImpl(context, worker, employee, benefitDtl);
			}
		}
	}

	public List<Locale> getLocaleList() {
		return localeList ;
	}
}
