package com.intuit.sb.payroll.capability.i18n.entities;

import java.util.Currency;
import java.util.Locale;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.cdm.basetypes.CurrencyCode;
import com.intuit.sb.payroll.common.i18n.LocaleGuru;
import com.intuit.sb.payroll.entity.model.Money;


public class MoneyTest {
	
	
	@Test public void testCurrencyCodeConversion()
	{	
		String currencyCode = LocaleGuru.getInstance().getCurrency();
		CurrencyCode cc = CurrencyCode.valueOf(currencyCode);
		Money money = new Money();
		CurrencyCode defaultCode = money.getCurrencyCode();
		AssertJUnit.assertEquals("Locale Currency Code Does not match with Default " +
				"Currency Code in Money", cc, defaultCode);
		money.setCurrencyCode(Currency.getInstance(currencyCode));
		//Try some currency codes that we require and make sure that it parses correctly
		money.setCurrencyCode(Currency.getInstance(Locale.US));
		money.setCurrencyCode(Currency.getInstance(Locale.CANADA));
		money.setCurrencyCode(Currency.getInstance(Locale.CANADA_FRENCH));
		money.setCurrencyCode(Currency.getInstance(Locale.UK));						
	}

}
