package com.intuit.sb.payroll.common;

import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

/**
 * Proxy for creating a logger in log4j.  Great Value Add.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
public class PayrollLoggerFactory { 
    /**
     * Private constructor to disable instantiation
     *
     */
    private PayrollLoggerFactory(){}
    
    /**
     * Creates a {@link Logger} for the Class passed in.
     * @param clazz the Class
     * @return a {@link Logger} instance.
     */
	public static Logger makeLogger(Class<?> clazz) {
		return LogManager.getLogger(clazz);
	}
	
	/**
	 * Creates a {@link Logger} using the name passed in.
	 * @param name the Name.
	 * @return a {@link Logger} instance.
	 */
	public static Logger makeLogger(String name) {
		return LogManager.getLogger(name);
	}
}
