package com.intuit.sb.payroll.common;

/**
 * This class creates mapping for messages between Java message keys and Resource file message keys
 * TODO Consider Generating this class from Resource File
 *
 * $Author: jzhong $
 * $Revision: #1 $
 * $DateTime: 2008/08/15 17:27:47 $
 *
 */
@SuppressWarnings("nls")
public class ResourceKeyConstants {

	/**
	 * Private constructor to prevent instantiation.
	 */
	private ResourceKeyConstants(){}

    /**
     * Exception Message for Entity ID not found.
     */
    public static final String ID_NOT_FOUND_EXCEPTION = "id.not.found";

    /**
     * Exception Message for Component Manager failing to load a component.
     */
    public static final String COMPONENT_NOT_FOUND_EXCEPTION = "component.not.found";

    /**
     * Exception Message for Classpath resource not being found.
     */
    public static final String CPRESOURCE_NOT_FOUND_EXCEPTION = "cpresource.not.found";

    /**
     * Exception Message for Invalid Age of Person.
     */
    public static final String INVALID_AGE_EXCEPTION = "invalid.age.exception";

    /**
     * Exception Message for Initialization failure for Rules Engine.
     */
    public static final String RULES_INIT_EXCEPTION = "rules.init.exception";

    /**
     * Exception Message for Rules Execution failure.
     */
    public static final String RULES_EXEC_EXCEPTION = "rules.exec.exception";

    /**
     * Exception Message for Unsupported Jurisdiction.
     */
    public static final String UNSUPPORTED_JURISDICTION_EXCEPTION = "unsupported.jurisdiction.exception";

    /**
     * Invalid party or type provided is not a party.
     */
    public static final String INVALID_PARTY_EXCEPTION = "party.invalid.exception";

     /**
	  * Leading string identifying Tax Agency property
	  */
	public static final String TAXAGENCY_DETAILS = "taxagency";

	/**
	 * Leading string identifying Tax Agency property
	 */
	public static final String TAXAGENCY_ALT_TEXT = "altText";

	/**
	 * Leading string identifying Tax Agency property
	 */
	public static final String TAXAGENCY_GHOST_TEXT = "ghostText";

	/**
	 * Leading string identifying Tax Agency property
	 */
	public static final String TAXAGENCIES = "taxagencies";

	/**
	 * Leading string identifying Tax Agency property
	 */
    public static final String TAXAGENCIES_MANDATORY = "taxagencies_mandatory";

}
