package com.intuit.sb.payroll.common.validation;

import java.util.Calendar;
import java.util.Date;

import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.DateUtil;

public class PayrollParamValidatorTest {
	
	@Test
	public void testValidDate() throws ValidationException {
		Calendar now = DateUtil.getNowCalendar();
		Date date = DateUtil.createCalendar(now.get(Calendar.YEAR), now.get(Calendar.MONTH),
		                                    now.get(Calendar.DAY_OF_MONTH)).getTime();		
		PayrollParamValidator.checkDateNotBeforeToday(date);

		Calendar tomorrow = now; tomorrow.add(Calendar.DAY_OF_MONTH, 1);
		date = DateUtil.createCalendar(tomorrow.get(Calendar.YEAR), tomorrow.get(Calendar.MONTH),
		                               tomorrow.get(Calendar.DAY_OF_MONTH)).getTime();		
		PayrollParamValidator.checkDateNotBeforeToday(date);

		Calendar oneYearFromNow = now; now.add(Calendar.YEAR, 1);
		date = DateUtil.createCalendar(oneYearFromNow.get(Calendar.YEAR), oneYearFromNow.get(Calendar.MONTH),
		                               oneYearFromNow.get(Calendar.DAY_OF_MONTH)).getTime();		
		PayrollParamValidator.checkDateNotBeforeToday(date);
	}
	
	@Test(expectedExceptions=ValidationException.class)
	public void testInvalidDate() throws ValidationException {
		Calendar yesterday = DateUtil.getNowCalendar(); yesterday.add(Calendar.DAY_OF_MONTH, -1);
		Date date = DateUtil.createCalendar(yesterday.get(Calendar.YEAR), yesterday.get(Calendar.MONTH),
		                                    yesterday.get(Calendar.DAY_OF_MONTH)).getTime();		
		PayrollParamValidator.checkDateNotBeforeToday(date);
	}
}
