package com.intuit.sb.payroll.entity.employer;

import javax.persistence.PostPersist;
import javax.persistence.PostRemove;

import org.apache.log4j.Logger;

import com.intuit.sb.payroll.common.PayrollLoggerFactory;
import com.intuit.sb.payroll.entity.domain.Identifiable;


/**
 * EntityListener for updates made on Employer Entity
 * 
 * @author amalik
 *
 */
public class EmployerEntityListener {
	static private final Logger sLogger = PayrollLoggerFactory.makeLogger(EmployerEntityListener.class);
	
	
	
	@PostPersist
	public void persist(Object entity)
	{
		sLogger.info("@PostPersist: New entity created " + entity.getClass().getName() + " " + ((Identifiable)entity).getId());
		//PayrollMessageUtil.createPayrollMessage(entity, PayrollMessageEnum.NEW_EMPLOYER_CREATION);
	}
	      
	@PostRemove
	public void remove(Object entity)
	{
		sLogger.info("@PostRemove: Entity Removed " + entity.getClass().getName());
		//PayrollMessageUtil.createPayrollMessage(null, PayrollMessageEnum.DELETE_EMPLOYER);
	}
	  

}
