package com.intuit.sb.payroll.entity.listener;

import java.util.Date;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PostLoad;

import com.intuit.sb.payroll.common.i18n.LocaleGuru;
import com.intuit.sb.payroll.entity.model.UnemploymentInsDocDtl;

public class CurrentRateSetterForSUI {

	@PersistenceContext(unitName = "payrollDB")
	private EntityManager mEntityManager;

	@PostLoad
	public void setFutureRateAsCurrentRate(
			UnemploymentInsDocDtl unemploymentInsDocDtl) {
		if (unemploymentInsDocDtl.getFutureRateStartDate() == null) {
			return;
		}

		// FIXME: Use customer's locale to get today
		Date today = LocaleGuru.getInstance().getCalendar().getTime();

		if (today.before(unemploymentInsDocDtl.getFutureRateStartDate())) {
			return;
		}

		unemploymentInsDocDtl.setPercentageRate(unemploymentInsDocDtl
				.getPercentageFutureRate());
		unemploymentInsDocDtl.setPercentageFutureRate(null);
		unemploymentInsDocDtl.setFutureRateStartDate(null);

		mEntityManager.persist(unemploymentInsDocDtl);
	}
}
