package com.intuit.sb.payroll.entity.model;

import java.util.Calendar;
import java.util.Date;

import com.intuit.sb.payroll.common.DateUtil;

public enum PtdTypeEnum {
	NOTSET, QUARTER1, QUARTER2, QUARTER3, QUARTER4, YEAR;
	
	public DateRange getDateRange(Date refDate)
	{
		Calendar cal = DateUtil.dateToCalendar(refDate);
		
		int refYear = cal.get(Calendar.YEAR);
		
		int startMonth;
		int endMonth;
		int startYear;
		int endYear;
		
		switch(this) {
		case QUARTER1:
			startMonth = Calendar.JANUARY;
			endMonth = Calendar.APRIL;
			startYear = refYear;
			endYear = refYear;
			break;
		case QUARTER2:
			startMonth = Calendar.APRIL;
			endMonth = Calendar.JULY;
			startYear = refYear;
			endYear = refYear;
			break;
		case QUARTER3:
			startMonth = Calendar.JULY;
			endMonth = Calendar.OCTOBER;
			startYear = refYear;
			endYear = refYear;
			break;
		case QUARTER4:
			startMonth = Calendar.OCTOBER;
			endMonth = Calendar.JANUARY;
			startYear = refYear;
			endYear = refYear + 1;
			break;
		case YEAR:
			startMonth = Calendar.JANUARY;
			endMonth = Calendar.JANUARY;
			startYear = refYear;
			endYear = refYear + 1;
			break;
		default:
			throw new UnsupportedOperationException("Unknown Ptd period: " + this);
		}
		
		DateRange rv = new DateRange(DateUtil.createDate(startYear, startMonth, 1), DateUtil.createDate(endYear, endMonth, 1));
		
		return rv;
	}
}