package com.intuit.sb.payroll.entity.pto;

import java.util.EnumMap;

import com.intuit.sb.payroll.entity.model.Datum;
import com.intuit.sb.payroll.entity.model.DatumType2Enum;
import com.intuit.sb.payroll.entity.model.PaidTimeOffAccrualTypeEnum;

/**
 * Class to take the pain away from creating Datums for PTOs.
 * 
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 *
 */
public class PtoDatumHelper {
	
	private static EnumMap<PaidTimeOffAccrualTypeEnum, DatumType2Enum> paidTimeOffAccrualTypeMap = new EnumMap<PaidTimeOffAccrualTypeEnum, DatumType2Enum>(
			PaidTimeOffAccrualTypeEnum.class);
	static {
		paidTimeOffAccrualTypeMap.put(PaidTimeOffAccrualTypeEnum.EACH_PAYCHECK, DatumType2Enum.PERPAYCHECK);
		paidTimeOffAccrualTypeMap.put(PaidTimeOffAccrualTypeEnum.HOURLY, DatumType2Enum.HOUR);
		paidTimeOffAccrualTypeMap.put(PaidTimeOffAccrualTypeEnum.PER_YEAR_START_OF_YEAR, DatumType2Enum.YEAR);
	}
	
	public static Datum createRateDatum(Double qty, PaidTimeOffAccrualTypeEnum paidTimeOffAccrualType) {
		Datum rate = new Datum();
		rate.setValue1AsQuantity(qty);
		rate.setType2Value2(mapToDatumType2Enum(paidTimeOffAccrualType), new Double(1));
		return rate;
	}
	
	private static DatumType2Enum mapToDatumType2Enum(PaidTimeOffAccrualTypeEnum paidTimeOffAccrualType) {
		DatumType2Enum datumType2Enum = paidTimeOffAccrualTypeMap.get(paidTimeOffAccrualType);
		return datumType2Enum == null ? DatumType2Enum.NOTSET : datumType2Enum;
	}
}
