package com.intuit.sb.payroll.entity.workerpayments;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;


import com.intuit.sb.payroll.entity.model.DateRange;
import com.intuit.sb.payroll.entity.model.PtdDatumType;

public class CompanyAdjustmentTotals {
	//For each LawId (String) a Set of Totals, one for each qtr.
	private Map<String, Set<PtdDatumType>> totalsByLawIdMap = new HashMap<String, Set<PtdDatumType>>();

	public void setTotalsByLawIdMap(Map<String, Set<PtdDatumType>> totalsByLawIdMap) {
		this.totalsByLawIdMap = totalsByLawIdMap;
	}

	public Map<String, Set<PtdDatumType>> getTotalsByLawIdMap() {
		return totalsByLawIdMap;
	}
	
	/**
	 * Returns the PtdDatum for the period and law.  Null if nothing is found.
	 * @param range
	 * @param lawId
	 * @return
	 */
	public PtdDatumType getDatumForRangeAndLaw(DateRange range, String lawId) {
		Set<PtdDatumType> datumsForLaw = this.totalsByLawIdMap.get(lawId);
		if (datumsForLaw != null) {
			for (PtdDatumType ptdDatumType : datumsForLaw) {
				if (ptdDatumType.getPeriod().equals(range)) {
					return ptdDatumType;
				}
			}
		}
		return null;
	}
}
