package com.intuit.sb.payroll.entity.workerpayments;

import javax.persistence.PostRemove;
import javax.persistence.PrePersist;

import org.apache.log4j.Logger;

import com.intuit.sb.payroll.common.PayrollLoggerFactory;

/**
 * EntityListener for PayrollSchedule entity. 
 * All the operations when a worker entity is created/updated or removed should go here
 * @author amalik
 *
 */
public class PayrollScheduleEntityListener {
	static private final Logger sLogger = PayrollLoggerFactory.makeLogger(PayrollScheduleEntityListener.class);
	
	@PrePersist
	public void persist(Object entity)
	{
		sLogger.info("@PostPersist: New entity created " + entity.getClass().getName());
//		PayrollMessageUtil.createPayrollMessage(entity, PayrollMessageEnum.NEW_PAYROLL_SCHEDULE_CREATION);
	}
	      
	@PostRemove
	public void remove(Object entity)
	{
		sLogger.info("@PostRemove: Entity Removed " + entity.getClass().getName());
	//	PayrollMessageUtil.createPayrollMessage(null, PayrollMessageEnum.DELETE_PAYROLL_SCHEDULE);
	}
}
