
    
    --
    -- VPD Twin-schema deployment - "&&1" schema
    -- 
    
	--
    -- Generated using Intuit's Oracle VPD DDL Xpand template
    --
    -- Create sequences
    
DECLARE 
	SEQUENCE_EXISTS PLS_INTEGER :=0;
BEGIN
	SELECT COUNT(*) INTO SEQUENCE_EXISTS
	FROM USER_SEQUENCES
	WHERE SEQUENCE_NAME = 'HIBERNATE_SEQUENCE';
	IF SEQUENCE_EXISTS = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE "HIBERNATE_SEQUENCE" MINVALUE 0 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 21 CACHE 20 NOORDER NOCYCLE';
	END IF;
END;
/

    -- Create tables 
    
    
    
	CREATE TABLE HEALTHBENEFIT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		BENEFITTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE ADDITION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL	)
/
    



	CREATE TABLE PAYROLLSCHEDULE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NEXTPAYPERIODENDDATE TIMESTAMP NULL,
		PAYDAYOFFSET NUMBER(10,0) NULL,
		PAYROLLRUNDAYOFFSET NUMBER(10,0) NULL,
		PAYPERIOD1ENDOFFSET NUMBER(10,0) NOT NULL,
		PAYPERIOD2ENDOFFSET NUMBER(10,0) NOT NULL,
		DISTRIBUTIONMETHOD VARCHAR2(100) NULL,
		FREQUENCY VARCHAR2(100) NULL,
		ISDEFAULT CHAR(1) NOT NULL,
		MEMO VARCHAR2(100) NULL,
		PAYPERIODENDDAYOFMONTH1 NUMBER(10,0) NOT NULL,
		PAYPERIODENDDAYOFMONTH2 NUMBER(10,0) NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE LAW (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID VARCHAR2(100) NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		SOURCEENTITY VARCHAR2(100) NULL,
		TARGETENTITY VARCHAR2(100) NULL,
		NAME VARCHAR2(100) NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		JURISDICTION NUMBER(20,0) NULL,
		AGENCY NUMBER(20,0) NULL	)
/
    



	CREATE TABLE COMPENSATIONDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		COMPENSATIONTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		FIXEDRATE CHAR(1) NOT NULL,
		QUANTITY_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_MONEY_CUR VARCHAR2(100) NULL,
		QUANTITY_MONEY_AMT NUMBER(19,4) NULL,
		QUANTITY_QUANTITY NUMBER NULL,
		QUANTITY_PERCENTAGE NUMBER NULL,
		QUANTITY_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_VALUE2 NUMBER NULL,
		PTOBASERATETYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL	)
/
    



	CREATE TABLE LEGALSTRUCTURE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ORDINALVALUE NUMBER(10,0) NULL,
		STRINGVALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE BENEFITPROVIDER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE DISABILITYINSDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PERCENTAGERATE NUMBER NULL	)
/
    



	CREATE TABLE OTHERBENEFITDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		BENEFITTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE COMPLIANCEDOC (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		COMPLIANCEDOCTYPE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		LAW NUMBER(20,0) NOT NULL	)
/
    



	CREATE TABLE DEDUCTION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DEDUCTIONTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE UNEMPLOYMENTINSDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PERCENTAGERATE NUMBER NULL,
		RATECHANGEDBYINTUIT CHAR(1) NOT NULL,
		FUTURERATESTARTDATE TIMESTAMP NULL,
		PERCENTAGEFUTURERATE NUMBER NULL,
		DEFAULTRATE CHAR(1) NOT NULL	)
/
    



	CREATE TABLE WORKER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		DATEOFBIRTH DATE NULL,
		WORKERID VARCHAR2(100) NULL,
		JOBPOSITIONNOTE VARCHAR2(100) NULL,
		PAYROLLFREQUENCY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		GENDER VARCHAR2(100) NULL,
		RELTOOWNER VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		PERSONNAME_FIRSTNAME VARCHAR2(100) NULL,
		PERSONNAME_MIDDLENAME VARCHAR2(100) NULL,
		PERSONNAME_LASTNAME VARCHAR2(100) NULL,
		PERSONNAME_TITLE VARCHAR2(100) NULL,
		PERSONNAME_SUFFIX VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEONE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETWO VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETHREE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		MAILADR_ADDRESSTYPE VARCHAR2(100) NULL,
		MAILADR_POSTTOWN VARCHAR2(100) NULL,
		MAILADR_COUNTY VARCHAR2(100) NULL,
		MAILADR_COUNTYCODE VARCHAR2(100) NULL,
		MAILADR_STATEPROV VARCHAR2(100) NULL,
		MAILADR_POSTALCODE VARCHAR2(100) NULL,
		MAILADR_POSTALCODESUFFIX VARCHAR2(100) NULL,
		MAILADR_COUNTRYNAME VARCHAR2(100) NULL,
		MAILADR_COUNTRYCODE VARCHAR2(100) NULL,
		MAILADR_GEOCODE VARCHAR2(100) NULL,
		MAILADR_LABEL VARCHAR2(100) NULL,
		MAILADR_CREATIONSOURCE VARCHAR2(100) NULL,
		MAILADR_ISSTANDARDIZED CHAR(1) NULL,
		MAILADR_ISSTREETADDRESS CHAR(1) NULL,
		MAILADR_DONOTSTAND CHAR(1) NULL,
		TAXRESADR_ADDRESSLINEONE VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINETWO VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINETHREE VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSTYPE VARCHAR2(100) NULL,
		TAXRESADR_POSTTOWN VARCHAR2(100) NULL,
		TAXRESADR_COUNTY VARCHAR2(100) NULL,
		TAXRESADR_COUNTYCODE VARCHAR2(100) NULL,
		TAXRESADR_STATEPROV VARCHAR2(100) NULL,
		TAXRESADR_POSTALCODE VARCHAR2(100) NULL,
		TAXRESADR_POSTALCODESUFFIX VARCHAR2(100) NULL,
		TAXRESADR_COUNTRYNAME VARCHAR2(100) NULL,
		TAXRESADR_COUNTRYCODE VARCHAR2(100) NULL,
		TAXRESADR_GEOCODE VARCHAR2(100) NULL,
		TAXRESADR_LABEL VARCHAR2(100) NULL,
		TAXRESADR_CREATIONSOURCE VARCHAR2(100) NULL,
		TAXRESADR_ISSTANDARDIZED CHAR(1) NULL,
		TAXRESADR_ISSTREETADDRESS CHAR(1) NULL,
		TAXRESADR_DONOTSTAND CHAR(1) NULL,
		EMAILADDRESS_ID VARCHAR2(100) NULL,
		EMAILADDRESS_ADDRESS VARCHAR2(100) NULL,
		EMAILADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		EMAILADDRESS_DEFAULTT CHAR(1) NULL,
		EMAILADDRESS_TAG VARCHAR2(100) NULL,
		HOMEPHONE_ID VARCHAR2(100) NULL,
		HOMEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		HOMEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		HOMEPHONE_AREACODE VARCHAR2(100) NULL,
		HOMEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		HOMEPHONE_EXTENSION VARCHAR2(100) NULL,
		HOMEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		HOMEPHONE_PIN VARCHAR2(100) NULL,
		HOMEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		HOMEPHONE_DEFAULTT CHAR(1) NULL,
		HOMEPHONE_TAG VARCHAR2(100) NULL,
		WORKPHONE_ID VARCHAR2(100) NULL,
		WORKPHONE_DEVICETYPE VARCHAR2(100) NULL,
		WORKPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		WORKPHONE_AREACODE VARCHAR2(100) NULL,
		WORKPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		WORKPHONE_EXTENSION VARCHAR2(100) NULL,
		WORKPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		WORKPHONE_PIN VARCHAR2(100) NULL,
		WORKPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		WORKPHONE_DEFAULTT CHAR(1) NULL,
		WORKPHONE_TAG VARCHAR2(100) NULL,
		MOBILEPHONE_ID VARCHAR2(100) NULL,
		MOBILEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		MOBILEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		MOBILEPHONE_AREACODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXTENSION VARCHAR2(100) NULL,
		MOBILEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		MOBILEPHONE_PIN VARCHAR2(100) NULL,
		MOBILEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		MOBILEPHONE_DEFAULTT CHAR(1) NULL,
		MOBILEPHONE_TAG VARCHAR2(100) NULL,
		PERSONTAXID_VALUE VARCHAR2(100) NULL,
		PERSONTAXID_LASTVERIFIEDDATE DATE NULL,
		PERSONTAXID_TYPE VARCHAR2(100) NULL,
		ISREADYFORTAX CHAR(1) NOT NULL,
		ISREADYFORPAY CHAR(1) NOT NULL,
		PAYROLLDISTRIBUTIONMETHOD VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		EMPLOYMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		ACTIVE CHAR(1) NOT NULL,
		EMPLOYMENTPERIOD_STARTDATE DATE NULL,
		EMPLOYMENTPERIOD_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		WORKLOCATION NUMBER(20,0) NULL,
		PAYROLLSCHEDULE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE PAYCHECKLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		SORTSEQUENCE VARCHAR2(100) NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		RATE_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_MONEY_CUR VARCHAR2(100) NULL,
		RATE_MONEY_AMT NUMBER(19,4) NULL,
		RATE_QUANTITY NUMBER NULL,
		RATE_PERCENTAGE NUMBER NULL,
		RATE_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_VALUE2 NUMBER NULL,
		QUANTITY_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_MONEY_CUR VARCHAR2(100) NULL,
		QUANTITY_MONEY_AMT NUMBER(19,4) NULL,
		QUANTITY_QUANTITY NUMBER NULL,
		QUANTITY_PERCENTAGE NUMBER NULL,
		QUANTITY_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_VALUE2 NUMBER NULL,
		VALUE_CUR VARCHAR2(100) NULL,
		VALUE_AMT NUMBER(19,4) NULL,
		SOURCEENTITY VARCHAR2(100) NULL,
		TARGETENTITY VARCHAR2(100) NULL,
		INCOMESUBJECTTOTAX_CUR VARCHAR2(100) NULL,
		INCOMESUBJECTTOTAX_AMT NUMBER(19,4) NULL,
		WAGEBASE_CUR VARCHAR2(100) NULL,
		WAGEBASE_AMT NUMBER(19,4) NULL,
		EXCESSAMOUNT_CUR VARCHAR2(100) NULL,
		EXCESSAMOUNT_AMT NUMBER(19,4) NULL,
		EXEMPTAMOUNT_CUR VARCHAR2(100) NULL,
		EXEMPTAMOUNT_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		SOURCEPAYROLLITEMDTL NUMBER(20,0) NOT NULL,
		PAYCHECK NUMBER(20,0) NULL	)
/
    



	CREATE TABLE DEDUCTIONDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DEDUCTIONTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL	)
/
    



	CREATE TABLE EMPLOYERADJUSTMENT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		TXNDATE TIMESTAMP NULL,
		TXNNO VARCHAR2(100) NULL,
		EFFECTIVEDATE TIMESTAMP NULL,
		PAYROLLPERIOD_STARTDATE DATE NULL,
		PAYROLLPERIOD_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE EMPLOYERCOMPLIANCEDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE WORKERLIABILITYADJUSTMENT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TXNNO VARCHAR2(100) NULL,
		LASTPAYCHECKDATE TIMESTAMP NULL,
		MEMO VARCHAR2(100) NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		GROSSAMOUNT_CUR VARCHAR2(100) NULL,
		GROSSAMOUNT_AMT NUMBER(19,4) NULL,
		NETAMOUNT_CUR VARCHAR2(100) NULL,
		NETAMOUNT_AMT NUMBER(19,4) NULL,
		DEDUCTIONAMOUNT_CUR VARCHAR2(100) NULL,
		DEDUCTIONAMOUNT_AMT NUMBER(19,4) NULL,
		WORKERPDTAXES_CUR VARCHAR2(100) NULL,
		WORKERPDTAXES_AMT NUMBER(19,4) NULL,
		EMPLOYERPDTAXES_CUR VARCHAR2(100) NULL,
		EMPLOYERPDTAXES_AMT NUMBER(19,4) NULL,
		WORKERPDBENEFITS_CUR VARCHAR2(100) NULL,
		WORKERPDBENEFITS_AMT NUMBER(19,4) NULL,
		EMPLOYERPDBENEFITS_CUR VARCHAR2(100) NULL,
		EMPLOYERPDBENEFITS_AMT NUMBER(19,4) NULL,
		LIABILITYDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		WORKER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE RETIREMENTBENEFIT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		BENEFITTYPE VARCHAR2(100) NULL,
		MAXCONTRIBUTION_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MAXCONTRIBUTION_MONEY_CUR VARCHAR2(100) NULL,
		MAXCONTRIBUTION_MONEY_AMT NUMBER(19,4) NULL,
		MAXCONTRIBUTION_QUANTITY NUMBER NULL,
		MAXCONTRIBUTION_PERCENTAGE NUMBER NULL,
		MAXCONTRIBUTION_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MAXCONTRIBUTION_VALUE2 NUMBER NULL,
		MAXCONTRIBUTIONUSEREDITED CHAR(1) NULL,
		MCUC_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MCUC_MONEY_CUR VARCHAR2(100) NULL,
		MCUC_MONEY_AMT NUMBER(19,4) NULL,
		MCUC_QUANTITY NUMBER NULL,
		MCUC_PERCENTAGE NUMBER NULL,
		MCUC_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MCUC_VALUE2 NUMBER NULL,
		MCUCUE CHAR(1) NULL	)
/
    



	CREATE TABLE RETIREMENTBENEFITDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		BENEFITTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE EMPLOYMENTPERIOD (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		EMPLOYMENTPERIOD_STARTDATE DATE NULL,
		EMPLOYMENTPERIOD_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		WORKER NUMBER(20,0) NOT NULL	)
/
    



	CREATE TABLE PAYROLLITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		SOURCEENTITY VARCHAR2(100) NULL,
		TARGETENTITY VARCHAR2(100) NULL,
		RATE_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_MONEY_CUR VARCHAR2(100) NULL,
		RATE_MONEY_AMT NUMBER(19,4) NULL,
		RATE_QUANTITY NUMBER NULL,
		RATE_PERCENTAGE NUMBER NULL,
		RATE_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_VALUE2 NUMBER NULL,
		DELETED CHAR(1)  DEFAULT '0' NOT NULL,
		COMPLIANCEDOCTYPE VARCHAR2(100) NULL,
		NAME VARCHAR2(100) NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		ACTIVE CHAR(1)  DEFAULT '1' NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		LAW NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE TAXDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TAXTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL	)
/
    



	CREATE TABLE EMPLOYERCONTACTPERSON (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ISOWNER CHAR(1) NULL,
		ROLETITLE VARCHAR2(100) NULL,
		TYPEOF VARCHAR2(100) NULL,
		EMPLOYER NUMBER(20,0) NOT NULL	)
/
    



	CREATE TABLE JURISDICTION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		MAPPINGKEY VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE EMPLOYERID (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		VALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		AGENCYIDTYPE NUMBER(20,0) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE BENEFITSVC (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		SERVICEID VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		BENEFITSPROVIDER NUMBER(20,0) NOT NULL	)
/
    



	CREATE TABLE OTHERBENEFIT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		BENEFITTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE TASK (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TYPE VARCHAR2(100)  DEFAULT 'DEADLINE' NULL,
		STATUS VARCHAR2(100)  DEFAULT 'NOTSTARTED' NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		TASKCLASS VARCHAR2(100) NULL,
		PAYLOAD NUMBER(20,0)  DEFAULT 0 NULL,
		CATEGORY VARCHAR2(100) NULL,
		COMPLETIONDATE TIMESTAMP NULL,
		DEADLINE TIMESTAMP NULL,
		EXPIRATIONDATE TIMESTAMP NULL,
		NEXTREMINDERDATE DATE NULL,
		REMINDERPERIOD NUMBER(10,0) NULL,
		MANUALLYCLOSED CHAR(1) NULL,
		NAME VARCHAR2(100) NULL,
		USERMANAGABLE CHAR(1)  DEFAULT '0' NOT NULL,
		DATERANGE_STARTDATE DATE NULL,
		DATERANGE_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE PAYROLLITEMDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		RATE_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_MONEY_CUR VARCHAR2(100) NULL,
		RATE_MONEY_AMT NUMBER(19,4) NULL,
		RATE_QUANTITY NUMBER NULL,
		RATE_PERCENTAGE NUMBER NULL,
		RATE_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_VALUE2 NUMBER NULL,
		SOURCEENTITY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		TARGETENTITY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		COMPLIANCEDOCTYPE VARCHAR2(100) NULL,
		NAME VARCHAR2(100) NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		DELETED CHAR(1)  DEFAULT '0' NOT NULL,
		ACTIVE CHAR(1)  DEFAULT '1' NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		LINKEDPAYROLLITEMDTL NUMBER(20,0) NULL,
		PAYROLLITEM NUMBER(20,0) NOT NULL,
		WORKER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE AGENCYIDTYPE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		AGENCYKEY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		IDTYPEKEY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		AGENCYIDVALIDATIONPATTERN VARCHAR2(100) NULL,
		GHOSTTEXT VARCHAR2(100) NULL,
		MANDATORY CHAR(1) NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE PAYCHECK (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TXNDATE TIMESTAMP NULL,
		TXNNO VARCHAR2(100) NULL,
		PAYDATE TIMESTAMP NULL,
		MEMO VARCHAR2(100) NULL,
		WORKFLOWSTATUS VARCHAR2(100) NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		GROSSAMOUNT_CUR VARCHAR2(100) NULL,
		GROSSAMOUNT_AMT NUMBER(19,4) NULL,
		NETAMOUNT_CUR VARCHAR2(100) NULL,
		NETAMOUNT_AMT NUMBER(19,4) NULL,
		DEDUCTIONAMOUNT_CUR VARCHAR2(100) NULL,
		DEDUCTIONAMOUNT_AMT NUMBER(19,4) NULL,
		DISTRIBUTIONMETHOD VARCHAR2(100) NULL,
		WORKERPDTAXES_CUR VARCHAR2(100) NULL,
		WORKERPDTAXES_AMT NUMBER(19,4) NULL,
		EMPLOYERPDTAXES_CUR VARCHAR2(100) NULL,
		EMPLOYERPDTAXES_AMT NUMBER(19,4) NULL,
		WORKERPDBENEFITS_CUR VARCHAR2(100) NULL,
		WORKERPDBENEFITS_AMT NUMBER(19,4) NULL,
		EMPLOYERPDBENEFITS_CUR VARCHAR2(100) NULL,
		EMPLOYERPDBENEFITS_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PAYROLLRUN NUMBER(20,0) NULL,
		WORKER NUMBER(20,0) NOT NULL	)
/
    



	CREATE TABLE AGENCY (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		SHORTNAME VARCHAR2(100) NULL,
		AGENCYKEY VARCHAR2(100) NULL,
		MAPPINGKEY VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		JURISDICTION NUMBER(20,0) NULL	)
/
    



	CREATE TABLE WORKLOCATION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		ISDEFAULT CHAR(1) NOT NULL,
		EMAILADDRESS_ID VARCHAR2(100) NULL,
		EMAILADDRESS_ADDRESS VARCHAR2(100) NULL,
		EMAILADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		EMAILADDRESS_DEFAULTT CHAR(1) NULL,
		EMAILADDRESS_TAG VARCHAR2(100) NULL,
		WEBADDRESS_ID VARCHAR2(100) NULL,
		WEBADDRESS_URI VARCHAR2(100) NULL,
		WEBADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		WEBADDRESS_DEFAULTT CHAR(1) NULL,
		WEBADDRESS_TAG VARCHAR2(100) NULL,
		TRA_ADDRESSLINEONE VARCHAR2(100) NULL,
		TRA_ADDRESSLINETWO VARCHAR2(100) NULL,
		TRA_ADDRESSLINETHREE VARCHAR2(100) NULL,
		TRA_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		TRA_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		TRA_ADDRESSTYPE VARCHAR2(100) NULL,
		TRA_POSTTOWN VARCHAR2(100) NULL,
		TRA_COUNTY VARCHAR2(100) NULL,
		TRA_COUNTYCODE VARCHAR2(100) NULL,
		TRA_STATEPROV VARCHAR2(100) NULL,
		TRA_POSTALCODE VARCHAR2(100) NULL,
		TRA_POSTALCODESUFFIX VARCHAR2(100) NULL,
		TRA_COUNTRYNAME VARCHAR2(100) NULL,
		TRA_COUNTRYCODE VARCHAR2(100) NULL,
		TRA_GEOCODE VARCHAR2(100) NULL,
		TRA_LABEL VARCHAR2(100) NULL,
		TRA_CREATIONSOURCE VARCHAR2(100) NULL,
		TRA_ISSTANDARDIZED CHAR(1) NULL,
		TRA_ISSTREETADDRESS CHAR(1) NULL,
		TRA_DONOTSTAND CHAR(1) NULL,
		MAINPHONE_ID VARCHAR2(100) NULL,
		MAINPHONE_DEVICETYPE VARCHAR2(100) NULL,
		MAINPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		MAINPHONE_AREACODE VARCHAR2(100) NULL,
		MAINPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		MAINPHONE_EXTENSION VARCHAR2(100) NULL,
		MAINPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		MAINPHONE_PIN VARCHAR2(100) NULL,
		MAINPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		MAINPHONE_DEFAULTT CHAR(1) NULL,
		MAINPHONE_TAG VARCHAR2(100) NULL,
		FAXPHONE_ID VARCHAR2(100) NULL,
		FAXPHONE_DEVICETYPE VARCHAR2(100) NULL,
		FAXPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		FAXPHONE_AREACODE VARCHAR2(100) NULL,
		FAXPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		FAXPHONE_EXTENSION VARCHAR2(100) NULL,
		FAXPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		FAXPHONE_PIN VARCHAR2(100) NULL,
		FAXPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		FAXPHONE_DEFAULTT CHAR(1) NULL,
		FAXPHONE_TAG VARCHAR2(100) NULL,
		MA_ADDRESSLINEONE VARCHAR2(100) NULL,
		MA_ADDRESSLINETWO VARCHAR2(100) NULL,
		MA_ADDRESSLINETHREE VARCHAR2(100) NULL,
		MA_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		MA_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		MA_ADDRESSTYPE VARCHAR2(100) NULL,
		MA_POSTTOWN VARCHAR2(100) NULL,
		MA_COUNTY VARCHAR2(100) NULL,
		MA_COUNTYCODE VARCHAR2(100) NULL,
		MA_STATEPROV VARCHAR2(100) NULL,
		MA_POSTALCODE VARCHAR2(100) NULL,
		MA_POSTALCODESUFFIX VARCHAR2(100) NULL,
		MA_COUNTRYNAME VARCHAR2(100) NULL,
		MA_COUNTRYCODE VARCHAR2(100) NULL,
		MA_GEOCODE VARCHAR2(100) NULL,
		MA_LABEL VARCHAR2(100) NULL,
		MA_CREATIONSOURCE VARCHAR2(100) NULL,
		MA_ISSTANDARDIZED CHAR(1) NULL,
		MA_ISSTREETADDRESS CHAR(1) NULL,
		MA_DONOTSTAND CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE CONTACTPERSON (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PERSONNAME_FIRSTNAME VARCHAR2(100) NULL,
		PERSONNAME_MIDDLENAME VARCHAR2(100) NULL,
		PERSONNAME_LASTNAME VARCHAR2(100) NULL,
		PERSONNAME_TITLE VARCHAR2(100) NULL,
		PERSONNAME_SUFFIX VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEONE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETWO VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETHREE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		MAILADR_ADDRESSTYPE VARCHAR2(100) NULL,
		MAILADR_POSTTOWN VARCHAR2(100) NULL,
		MAILADR_COUNTY VARCHAR2(100) NULL,
		MAILADR_COUNTYCODE VARCHAR2(100) NULL,
		MAILADR_STATEPROV VARCHAR2(100) NULL,
		MAILADR_POSTALCODE VARCHAR2(100) NULL,
		MAILADR_POSTALCODESUFFIX VARCHAR2(100) NULL,
		MAILADR_COUNTRYNAME VARCHAR2(100) NULL,
		MAILADR_COUNTRYCODE VARCHAR2(100) NULL,
		MAILADR_GEOCODE VARCHAR2(100) NULL,
		MAILADR_LABEL VARCHAR2(100) NULL,
		MAILADR_CREATIONSOURCE VARCHAR2(100) NULL,
		MAILADR_ISSTANDARDIZED CHAR(1) NULL,
		MAILADR_ISSTREETADDRESS CHAR(1) NULL,
		MAILADR_DONOTSTAND CHAR(1) NULL,
		EMAILADDRESS_ID VARCHAR2(100) NULL,
		EMAILADDRESS_ADDRESS VARCHAR2(100) NULL,
		EMAILADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		EMAILADDRESS_DEFAULTT CHAR(1) NULL,
		EMAILADDRESS_TAG VARCHAR2(100) NULL,
		WORKPHONE_ID VARCHAR2(100) NULL,
		WORKPHONE_DEVICETYPE VARCHAR2(100) NULL,
		WORKPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		WORKPHONE_AREACODE VARCHAR2(100) NULL,
		WORKPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		WORKPHONE_EXTENSION VARCHAR2(100) NULL,
		WORKPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		WORKPHONE_PIN VARCHAR2(100) NULL,
		WORKPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		WORKPHONE_DEFAULTT CHAR(1) NULL,
		WORKPHONE_TAG VARCHAR2(100) NULL,
		HOMEPHONE_ID VARCHAR2(100) NULL,
		HOMEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		HOMEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		HOMEPHONE_AREACODE VARCHAR2(100) NULL,
		HOMEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		HOMEPHONE_EXTENSION VARCHAR2(100) NULL,
		HOMEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		HOMEPHONE_PIN VARCHAR2(100) NULL,
		HOMEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		HOMEPHONE_DEFAULTT CHAR(1) NULL,
		HOMEPHONE_TAG VARCHAR2(100) NULL,
		MOBILEPHONE_ID VARCHAR2(100) NULL,
		MOBILEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		MOBILEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		MOBILEPHONE_AREACODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXTENSION VARCHAR2(100) NULL,
		MOBILEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		MOBILEPHONE_PIN VARCHAR2(100) NULL,
		MOBILEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		MOBILEPHONE_DEFAULTT CHAR(1) NULL,
		MOBILEPHONE_TAG VARCHAR2(100) NULL,
		FAXPHONE_ID VARCHAR2(100) NULL,
		FAXPHONE_DEVICETYPE VARCHAR2(100) NULL,
		FAXPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		FAXPHONE_AREACODE VARCHAR2(100) NULL,
		FAXPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		FAXPHONE_EXTENSION VARCHAR2(100) NULL,
		FAXPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		FAXPHONE_PIN VARCHAR2(100) NULL,
		FAXPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		FAXPHONE_DEFAULTT CHAR(1) NULL,
		FAXPHONE_TAG VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		WORKER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE PTDDATUM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		DATUM_PTDTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		DATUM_PERIOD_STARTDATE DATE NULL,
		DATUM_PERIOD_ENDDATE DATE NULL,
		DATUM_DATUMTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		DATUM_MONEY_CUR VARCHAR2(100) NULL,
		DATUM_MONEY_AMT NUMBER(19,4) NULL,
		DATUM_WAGEBASE_CUR VARCHAR2(100) NULL,
		DATUM_WAGEBASE_AMT NUMBER(19,4) NULL,
		DATUM_INCOMESUBJECTTOTAX_CUR VARCHAR2(100) NULL,
		DATUM_INCOMESUBJECTTOTAX_AMT NUMBER(19,4) NULL,
		DATUM_TOTALHOURS NUMBER NULL,
		DATUM_QUANTITY NUMBER NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PAYCHECKLINEITEM NUMBER(20,0) NULL,
		HISTORICALPAYCHECKLINEITEM NUMBER(20,0) NULL,
		PAYROLLITEMDTL NUMBER(20,0) NULL	)
/
    



	CREATE TABLE WORKERCOMPLIANCEDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		COMPLIANCEDOCTYPE VARCHAR2(100) NULL,
		ISDERIVED CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		WORKER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE PAYROLLRUN (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		PAYROLLRUNID VARCHAR2(100) NULL,
		PAYDATE TIMESTAMP NULL,
		PAYROLLRUNDATE TIMESTAMP NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		TOTALGROSSPAY_CUR VARCHAR2(100) NULL,
		TOTALGROSSPAY_AMT NUMBER(19,4) NULL,
		TOTALNETPAY_CUR VARCHAR2(100) NULL,
		TOTALNETPAY_AMT NUMBER(19,4) NULL,
		PAYROLLFREQUENCY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		WORKFLOWSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		TOTALWORKERPDTAXES_CUR VARCHAR2(100) NULL,
		TOTALWORKERPDTAXES_AMT NUMBER(19,4) NULL,
		TOTALEMPLOYERPDTAXES_CUR VARCHAR2(100) NULL,
		TOTALEMPLOYERPDTAXES_AMT NUMBER(19,4) NULL,
		DISTRIBUTIONMETHOD VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		ISSCHEDULED CHAR(1) NULL,
		TOTALWORKERPDBENEFITS_CUR VARCHAR2(100) NULL,
		TOTALWORKERPDBENEFITS_AMT NUMBER(19,4) NULL,
		TOTALEMPLOYERPDBENEFITS_CUR VARCHAR2(100) NULL,
		TOTALEMPLOYERPDBENEFITS_AMT NUMBER(19,4) NULL,
		TYPEOF VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE EMPLOYERADJLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		AMOUNT_CUR VARCHAR2(100) NULL,
		AMOUNT_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAX NUMBER(20,0) NOT NULL
,UNIQUE(TAX),
		EMPLOYERADJUSTMENT NUMBER(20,0) NULL	)
/
    



	CREATE TABLE PAIDTIMEOFFDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAIDTIMEOFFTYPE VARCHAR2(100) NULL,
		ACCRUALTYPE VARCHAR2(100) NULL,
		LIMITACCRUAL CHAR(1) NOT NULL,
		ALLOWCARRYOVER CHAR(1) NOT NULL,
		MAXIMUMACCRUAL NUMBER NULL,
		ACCRUEDHOURS NUMBER NULL,
		ACCRUALSTARTTYPE VARCHAR2(100) NULL,
		ACCRUALSTARTDATE TIMESTAMP NULL	)
/
    



	CREATE TABLE COMPENSATION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		COMPENSATIONTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE ADDITIONDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL	)
/
    



	CREATE TABLE TAX (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TAXTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE HISTORICALPAYCHECKLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		SORTSEQUENCE VARCHAR2(100) NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		RATE_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_MONEY_CUR VARCHAR2(100) NULL,
		RATE_MONEY_AMT NUMBER(19,4) NULL,
		RATE_QUANTITY NUMBER NULL,
		RATE_PERCENTAGE NUMBER NULL,
		RATE_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_VALUE2 NUMBER NULL,
		QUANTITY_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_MONEY_CUR VARCHAR2(100) NULL,
		QUANTITY_MONEY_AMT NUMBER(19,4) NULL,
		QUANTITY_QUANTITY NUMBER NULL,
		QUANTITY_PERCENTAGE NUMBER NULL,
		QUANTITY_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_VALUE2 NUMBER NULL,
		VALUE_CUR VARCHAR2(100) NULL,
		VALUE_AMT NUMBER(19,4) NULL,
		SOURCEENTITY VARCHAR2(100) NULL,
		TARGETENTITY VARCHAR2(100) NULL,
		INCOMESUBJECTTOTAX_CUR VARCHAR2(100) NULL,
		INCOMESUBJECTTOTAX_AMT NUMBER(19,4) NULL,
		WAGEBASE_CUR VARCHAR2(100) NULL,
		WAGEBASE_AMT NUMBER(19,4) NULL,
		EXCESSAMOUNT_CUR VARCHAR2(100) NULL,
		EXCESSAMOUNT_AMT NUMBER(19,4) NULL,
		EXEMPTAMOUNT_CUR VARCHAR2(100) NULL,
		EXEMPTAMOUNT_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PAYROLLITEMDTL NUMBER(20,0) NOT NULL,
		WORKERLIABILITYADJUSTMENT NUMBER(20,0) NOT NULL	)
/
    



	CREATE TABLE BENEFIT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		BENEFITSERVICE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE EMPLOYER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LEGALNAME VARCHAR2(100) NULL,
		DBANAME VARCHAR2(100) NULL,
		ISNONPROFIT CHAR(1)  DEFAULT '0' NOT NULL,
		LEGALSTRUCTURE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		INDUSTRYTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		LEGALPHONE_ID VARCHAR2(100) NULL,
		LEGALPHONE_DEVICETYPE VARCHAR2(100) NULL,
		LEGALPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		LEGALPHONE_AREACODE VARCHAR2(100) NULL,
		LEGALPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		LEGALPHONE_EXTENSION VARCHAR2(100) NULL,
		LEGALPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		LEGALPHONE_PIN VARCHAR2(100) NULL,
		LEGALPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		LEGALPHONE_DEFAULTT CHAR(1) NULL,
		LEGALPHONE_TAG VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINEONE VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINETWO VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINETHREE VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSTYPE VARCHAR2(100) NULL,
		LEGALADDRESS_POSTTOWN VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTY VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTYCODE VARCHAR2(100) NULL,
		LEGALADDRESS_STATEPROV VARCHAR2(100) NULL,
		LEGALADDRESS_POSTALCODE VARCHAR2(100) NULL,
		LEGALADDRESS_POSTALCODESUFFIX VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTRYNAME VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTRYCODE VARCHAR2(100) NULL,
		LEGALADDRESS_GEOCODE VARCHAR2(100) NULL,
		LEGALADDRESS_LABEL VARCHAR2(100) NULL,
		LEGALADDRESS_CREATIONSOURCE VARCHAR2(100) NULL,
		LEGALADDRESS_ISSTANDARDIZED CHAR(1) NULL,
		LEGALADDRESS_ISSTREETADDRESS CHAR(1) NULL,
		LEGALADDRESS_DONOTSTAND CHAR(1) NULL,
		BA_ADDRESSLINEONE VARCHAR2(100) NULL,
		BA_ADDRESSLINETWO VARCHAR2(100) NULL,
		BA_ADDRESSLINETHREE VARCHAR2(100) NULL,
		BA_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		BA_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		BA_ADDRESSTYPE VARCHAR2(100) NULL,
		BA_POSTTOWN VARCHAR2(100) NULL,
		BA_COUNTY VARCHAR2(100) NULL,
		BA_COUNTYCODE VARCHAR2(100) NULL,
		BA_STATEPROV VARCHAR2(100) NULL,
		BA_POSTALCODE VARCHAR2(100) NULL,
		BA_POSTALCODESUFFIX VARCHAR2(100) NULL,
		BA_COUNTRYNAME VARCHAR2(100) NULL,
		BA_COUNTRYCODE VARCHAR2(100) NULL,
		BA_GEOCODE VARCHAR2(100) NULL,
		BA_LABEL VARCHAR2(100) NULL,
		BA_CREATIONSOURCE VARCHAR2(100) NULL,
		BA_ISSTANDARDIZED CHAR(1) NULL,
		BA_ISSTREETADDRESS CHAR(1) NULL,
		BA_DONOTSTAND CHAR(1) NULL,
		LEGALANDBUSADDRESSSAME CHAR(1)  DEFAULT '0' NOT NULL,
		WEBADDRESS_ID VARCHAR2(100) NULL,
		WEBADDRESS_URI VARCHAR2(100) NULL,
		WEBADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		WEBADDRESS_DEFAULTT CHAR(1) NULL,
		WEBADDRESS_TAG VARCHAR2(100) NULL,
		FIRSTPAYROLLDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE BANKACCOUNT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		ACCOUNTNO VARCHAR2(100) NULL,
		ROUTINGNO VARCHAR2(100) NULL,
		BANKNAME VARCHAR2(100) NULL,
		ACCOUNTTYPE VARCHAR2(100) NULL,
		LASTVERIFIEDDATE TIMESTAMP NULL,
		BANKADDRESS_ADDRESSLINEONE VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINETWO VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINETHREE VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSTYPE VARCHAR2(100) NULL,
		BANKADDRESS_POSTTOWN VARCHAR2(100) NULL,
		BANKADDRESS_COUNTY VARCHAR2(100) NULL,
		BANKADDRESS_COUNTYCODE VARCHAR2(100) NULL,
		BANKADDRESS_STATEPROV VARCHAR2(100) NULL,
		BANKADDRESS_POSTALCODE VARCHAR2(100) NULL,
		BANKADDRESS_POSTALCODESUFFIX VARCHAR2(100) NULL,
		BANKADDRESS_COUNTRYNAME VARCHAR2(100) NULL,
		BANKADDRESS_COUNTRYCODE VARCHAR2(100) NULL,
		BANKADDRESS_GEOCODE VARCHAR2(100) NULL,
		BANKADDRESS_LABEL VARCHAR2(100) NULL,
		BANKADDRESS_CREATIONSOURCE VARCHAR2(100) NULL,
		BANKADDRESS_ISSTANDARDIZED CHAR(1) NULL,
		BANKADDRESS_ISSTREETADDRESS CHAR(1) NULL,
		BANKADDRESS_DONOTSTAND CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL,
		WORKER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE PAIDTIMEOFF (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAIDTIMEOFFTYPE VARCHAR2(100) NULL,
		LIMITACCRUAL CHAR(1) NOT NULL,
		ALLOWCARRYOVER CHAR(1) NOT NULL	)
/
    



	CREATE TABLE INDUSTRYTYPE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ORDINALVALUE NUMBER(10,0) NULL,
		STRINGVALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE HEALTHBENEFITDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		BENEFITTYPE VARCHAR2(100) NULL	)
/
    



	CREATE TABLE WORKLOCATIONBENEFITSERVICE (
		PRIMARY KEY(WORKLOCATION, BENEFITSERVICE),
		WORKLOCATION NUMBER(20,0) NOT NULL,
		BENEFITSERVICE NUMBER(20,0) NOT NULL	)
/
    



	CREATE TABLE CONTACTPERSONWORKLOCATION (
		PRIMARY KEY(CONTACTPERSON, WORKLOCATION),
		CONTACTPERSON NUMBER(20,0) NOT NULL,
		WORKLOCATION NUMBER(20,0) NOT NULL	)
/
    


    

    
    
    -- Functions
    
    
    
    
    CREATE or REPLACE TRIGGER "HEALTHBENEFIT_VT" 
    BEFORE INSERT OR UPDATE ON "HEALTHBENEFIT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "ADDITION_VT" 
    BEFORE INSERT OR UPDATE ON "ADDITION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYROLLSCHEDULE 
	ADD CONSTRAINT PAYROLLSCHEDULE_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYROLLSCHEDULE_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLSCHEDULE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE LAW 
	ADD CONSTRAINT JURCONLAW_FK_JUR 
	FOREIGN KEY (JURISDICTION) 
	REFERENCES JURISDICTION (ID)
/

ALTER TABLE LAW 
	ADD CONSTRAINT LAW_FK_AGENCY 
	FOREIGN KEY (AGENCY) 
	REFERENCES AGENCY (ID)
/

    
    CREATE or REPLACE TRIGGER "LAW_VT" 
    BEFORE INSERT OR UPDATE ON "LAW" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "COMPENSATIONDTL_VT" 
    BEFORE INSERT OR UPDATE ON "COMPENSATIONDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "LEGALSTRUCTURE_VT" 
    BEFORE INSERT OR UPDATE ON "LEGALSTRUCTURE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "BENEFITPROVIDER_VT" 
    BEFORE INSERT OR UPDATE ON "BENEFITPROVIDER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "DISABILITYINSDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "DISABILITYINSDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "OTHERBENEFITDTL_VT" 
    BEFORE INSERT OR UPDATE ON "OTHERBENEFITDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE COMPLIANCEDOC 
	ADD CONSTRAINT COMPLIANCEDOC_FK_LAW 
	FOREIGN KEY (LAW) 
	REFERENCES LAW (ID)
/

    
    CREATE or REPLACE TRIGGER "COMPLIANCEDOC_VT" 
    BEFORE INSERT OR UPDATE ON "COMPLIANCEDOC" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "DEDUCTION_VT" 
    BEFORE INSERT OR UPDATE ON "DEDUCTION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "UNEMPLOYMENTINSDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "UNEMPLOYMENTINSDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKER 
	ADD CONSTRAINT WORKER_FK_PAYROLLSCHEDULE 
	FOREIGN KEY (PAYROLLSCHEDULE) 
	REFERENCES PAYROLLSCHEDULE (ID)
/

ALTER TABLE WORKER 
	ADD CONSTRAINT WLOCWRKR_FK_WLOC 
	FOREIGN KEY (WORKLOCATION) 
	REFERENCES WORKLOCATION (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKER_VT" 
    BEFORE INSERT OR UPDATE ON "WORKER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYCHECKLINEITEM 
	ADD CONSTRAINT PCHKPCHKLITEM_FK_PCHK 
	FOREIGN KEY (PAYCHECK) 
	REFERENCES PAYCHECK (ID)
/

ALTER TABLE PAYCHECKLINEITEM 
	ADD CONSTRAINT PCLI_PID_FK_CONSTRAINT 
	FOREIGN KEY (SOURCEPAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYCHECKLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "PAYCHECKLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "DEDUCTIONDTL_VT" 
    BEFORE INSERT OR UPDATE ON "DEDUCTIONDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "EMPLOYERADJUSTMENT_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERADJUSTMENT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERCOMPLIANCEDOCDTL 
	ADD CONSTRAINT ERCOMPLDOCDTL_FK_ER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERCOMPLIANCEDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERCOMPLIANCEDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKERLIABILITYADJUSTMENT 
	ADD CONSTRAINT WORKERWKRLIABADJ_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKERLIABILITYADJUSTMENT_VT" 
    BEFORE INSERT OR UPDATE ON "WORKERLIABILITYADJUSTMENT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "RETIREMENTBENEFIT_VT" 
    BEFORE INSERT OR UPDATE ON "RETIREMENTBENEFIT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "RETIREMENTBENEFITDTL_VT" 
    BEFORE INSERT OR UPDATE ON "RETIREMENTBENEFITDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYMENTPERIOD 
	ADD CONSTRAINT EMPLOYMENTPERIOD_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYMENTPERIOD_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYMENTPERIOD" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYROLLITEM 
	ADD CONSTRAINT PAYROLLITEM_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYROLLITEM 
	ADD CONSTRAINT PAYROLLITEM_FK_LAW 
	FOREIGN KEY (LAW) 
	REFERENCES LAW (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYROLLITEM_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAXDTL_VT" 
    BEFORE INSERT OR UPDATE ON "TAXDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERCONTACTPERSON 
	ADD CONSTRAINT ERCONTACTPERSON_FK_ER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERCONTACTPERSON_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERCONTACTPERSON" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "JURISDICTION_VT" 
    BEFORE INSERT OR UPDATE ON "JURISDICTION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERID 
	ADD CONSTRAINT EMPLOYERID_FK_AGENCYIDTYPE 
	FOREIGN KEY (AGENCYIDTYPE) 
	REFERENCES AGENCYIDTYPE (ID)
/

ALTER TABLE EMPLOYERID 
	ADD CONSTRAINT EMPLOYERID_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERID_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERID" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE BENEFITSVC 
	ADD CONSTRAINT BENEFITSVC_FK_BENEFITSPROVIDER 
	FOREIGN KEY (BENEFITSPROVIDER) 
	REFERENCES BENEFITPROVIDER (ID)
/

    
    CREATE or REPLACE TRIGGER "BENEFITSVC_VT" 
    BEFORE INSERT OR UPDATE ON "BENEFITSVC" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "OTHERBENEFIT_VT" 
    BEFORE INSERT OR UPDATE ON "OTHERBENEFIT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TASK_VT" 
    BEFORE INSERT OR UPDATE ON "TASK" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYROLLITEMDTL 
	ADD CONSTRAINT PITMDTL_FK_PITMDTL 
	FOREIGN KEY (LINKEDPAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE PAYROLLITEMDTL 
	ADD CONSTRAINT PAYROLLITEMDTL_FK_PAYROLLITEM 
	FOREIGN KEY (PAYROLLITEM) 
	REFERENCES PAYROLLITEM (ID)
/

ALTER TABLE PAYROLLITEMDTL 
	ADD CONSTRAINT PAYROLLITEMDTL_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYROLLITEMDTL_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLITEMDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "AGENCYIDTYPE_VT" 
    BEFORE INSERT OR UPDATE ON "AGENCYIDTYPE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYCHECK 
	ADD CONSTRAINT PAYCHECK_FK_PAYROLLRUN 
	FOREIGN KEY (PAYROLLRUN) 
	REFERENCES PAYROLLRUN (ID)
/

ALTER TABLE PAYCHECK 
	ADD CONSTRAINT PAYCHECK_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYCHECK_VT" 
    BEFORE INSERT OR UPDATE ON "PAYCHECK" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE AGENCY 
	ADD CONSTRAINT JURCONAGENCY_FK_JUR 
	FOREIGN KEY (JURISDICTION) 
	REFERENCES JURISDICTION (ID)
/

    
    CREATE or REPLACE TRIGGER "AGENCY_VT" 
    BEFORE INSERT OR UPDATE ON "AGENCY" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKLOCATION 
	ADD CONSTRAINT WORKLOCATION_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKLOCATION_VT" 
    BEFORE INSERT OR UPDATE ON "WORKLOCATION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE CONTACTPERSON 
	ADD CONSTRAINT CONTACTPERSON_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "CONTACTPERSON_VT" 
    BEFORE INSERT OR UPDATE ON "CONTACTPERSON" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PTDDATUM 
	ADD CONSTRAINT PTDDATUMHPLITEM_FK_HPLITEM 
	FOREIGN KEY (HISTORICALPAYCHECKLINEITEM) 
	REFERENCES HISTORICALPAYCHECKLINEITEM (ID)
/

ALTER TABLE PTDDATUM 
	ADD CONSTRAINT PAYITMDTLPTDDATUM_FK_PAYITMDTL 
	FOREIGN KEY (PAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE PTDDATUM 
	ADD CONSTRAINT PCHKLITEMPTD_FK_PCHKLITEM 
	FOREIGN KEY (PAYCHECKLINEITEM) 
	REFERENCES PAYCHECKLINEITEM (ID)
/

    
    CREATE or REPLACE TRIGGER "PTDDATUM_VT" 
    BEFORE INSERT OR UPDATE ON "PTDDATUM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKERCOMPLIANCEDOCDTL 
	ADD CONSTRAINT WKRWKRCOMPDOCDTL_FK_WKR 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKERCOMPLIANCEDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "WORKERCOMPLIANCEDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "PAYROLLRUN_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLRUN" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE EMPLOYERADJLINEITEM 
	ADD CONSTRAINT LIABADJASSOC_FK_LIABADJ 
	FOREIGN KEY (EMPLOYERADJUSTMENT) 
	REFERENCES EMPLOYERADJUSTMENT (ID)
/

ALTER TABLE EMPLOYERADJLINEITEM 
	ADD CONSTRAINT EMPLOYERADJLINEITEM_FK_TAX 
	FOREIGN KEY (TAX) 
	REFERENCES TAX (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERADJLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERADJLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "PAIDTIMEOFFDTL_VT" 
    BEFORE INSERT OR UPDATE ON "PAIDTIMEOFFDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "COMPENSATION_VT" 
    BEFORE INSERT OR UPDATE ON "COMPENSATION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "ADDITIONDTL_VT" 
    BEFORE INSERT OR UPDATE ON "ADDITIONDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAX_VT" 
    BEFORE INSERT OR UPDATE ON "TAX" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE HISTORICALPAYCHECKLINEITEM 
	ADD CONSTRAINT HPLITMPITMDTL_FK_PITMDTL 
	FOREIGN KEY (PAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE HISTORICALPAYCHECKLINEITEM 
	ADD CONSTRAINT HSTPCHKLITEM_FK_HSTPCHK 
	FOREIGN KEY (WORKERLIABILITYADJUSTMENT) 
	REFERENCES WORKERLIABILITYADJUSTMENT (ID)
/

    
    CREATE or REPLACE TRIGGER "HISTORICALPAYCHECKLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "HISTORICALPAYCHECKLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE BENEFIT 
	ADD CONSTRAINT BENEFIT_FK_BENEFITSERVICE 
	FOREIGN KEY (BENEFITSERVICE) 
	REFERENCES BENEFITSVC (ID)
/

    
    CREATE or REPLACE TRIGGER "BENEFIT_VT" 
    BEFORE INSERT OR UPDATE ON "BENEFIT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "EMPLOYER_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE BANKACCOUNT 
	ADD CONSTRAINT BANKACCOUNT_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

ALTER TABLE BANKACCOUNT 
	ADD CONSTRAINT BANKACCOUNT_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "BANKACCOUNT_VT" 
    BEFORE INSERT OR UPDATE ON "BANKACCOUNT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "PAIDTIMEOFF_VT" 
    BEFORE INSERT OR UPDATE ON "PAIDTIMEOFF" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "INDUSTRYTYPE_VT" 
    BEFORE INSERT OR UPDATE ON "INDUSTRYTYPE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "HEALTHBENEFITDTL_VT" 
    BEFORE INSERT OR UPDATE ON "HEALTHBENEFITDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKLOCATIONBENEFITSERVICE 
	ADD CONSTRAINT WLOCBS_FK_WLOC 
	FOREIGN KEY (WORKLOCATION) 
	REFERENCES WORKLOCATION (ID)
/

ALTER TABLE WORKLOCATIONBENEFITSERVICE 
	ADD CONSTRAINT WLOCBS_FK_BS 
	FOREIGN KEY (BENEFITSERVICE) 
	REFERENCES BENEFITSVC (ID)
/

    

    
    
ALTER TABLE CONTACTPERSONWORKLOCATION 
	ADD CONSTRAINT CONWLOC_FK_CON 
	FOREIGN KEY (CONTACTPERSON) 
	REFERENCES CONTACTPERSON (ID)
/

ALTER TABLE CONTACTPERSONWORKLOCATION 
	ADD CONSTRAINT CONWLOC_FK_WLOC 
	FOREIGN KEY (WORKLOCATION) 
	REFERENCES WORKLOCATION (ID)
/

    

    
    

    -- Synonyms
    
    -- Grants
    
	GRANT SELECT, INSERT, UPDATE, DELETE ON HEALTHBENEFIT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON ADDITION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLSCHEDULE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON LAW TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON COMPENSATIONDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON LEGALSTRUCTURE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BENEFITPROVIDER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON DISABILITYINSDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON OTHERBENEFITDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON COMPLIANCEDOC TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON DEDUCTION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON UNEMPLOYMENTINSDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYCHECKLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON DEDUCTIONDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERADJUSTMENT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERCOMPLIANCEDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKERLIABILITYADJUSTMENT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON RETIREMENTBENEFIT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON RETIREMENTBENEFITDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYMENTPERIOD TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAXDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERCONTACTPERSON TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON JURISDICTION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERID TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BENEFITSVC TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON OTHERBENEFIT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TASK TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLITEMDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON AGENCYIDTYPE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYCHECK TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON AGENCY TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKLOCATION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON CONTACTPERSON TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTDDATUM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKERCOMPLIANCEDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLRUN TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERADJLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAIDTIMEOFFDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON COMPENSATION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON ADDITIONDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAX TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON HISTORICALPAYCHECKLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BENEFIT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BANKACCOUNT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAIDTIMEOFF TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON INDUSTRYTYPE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON HEALTHBENEFITDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKLOCATIONBENEFITSERVICE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON CONTACTPERSONWORKLOCATION TO &&2
	/


	GRANT SELECT ON HIBERNATE_SEQUENCE TO &&2
	/

  
    
	--
    -- Table permissions for the VPD internal-to-external mapping table
    --
    GRANT SELECT,INSERT,UPDATE ON SBCORE_VPD_TABLE TO &&2
    /
    --
    -- Permission for VPD SEQ
    --
    GRANT SELECT ON SBCORE_VPD_SEQ TO &&2
    /
        
 

    
DECLARE
  table_exists PLS_INTEGER;
  row_exists PLS_INTEGER;

  INSERT_CMD VARCHAR2(255);
  ROWCHECK_CMD VARCHAR2(255);
  UPDATE_CMD VARCHAR2(255);

BEGIN
  SELECT COUNT(*) INTO table_exists
  FROM "USER_TABLES"
  WHERE TABLE_NAME = 'PROJECT_VERSIONS_TABLE';
  IF table_exists = 1 THEN 
  
    SELECT 'SELECT COUNT(*)  FROM PROJECT_VERSIONS_TABLE WHERE PROJECT_ID=''_c4GAoJEkEd2zF5tDuPZkGw'''   
    INTO ROWCHECK_CMD
    FROM DUAL;
    EXECUTE IMMEDIATE ROWCHECK_CMD INTO row_exists;   
   
    IF row_exists = 1 THEN    
        SELECT 'UPDATE PROJECT_VERSIONS_TABLE SET MODEL_VERSION='''',SCHEMA_VERSION=''1.0.23'',TIMESTAMP=''2009-05-01 19:01:08.714'' WHERE PROJECT_ID=''_c4GAoJEkEd2zF5tDuPZkGw'''
        INTO UPDATE_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE UPDATE_CMD;
    ELSE
        SELECT 'INSERT INTO PROJECT_VERSIONS_TABLE (PROJECT_NAME,PROJECT_ID,MODEL_VERSION,SCHEMA_VERSION,TIMESTAMP) VALUES (''geminiintl'',''_c4GAoJEkEd2zF5tDuPZkGw'','''',''1.0.23'',''2009-05-01 19:01:08.714'')' 
        INTO INSERT_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE INSERT_CMD;
    END IF;   
  END IF;
END;
/

    