
    
    --
    -- VPD Twin-schema deployment - "&&1" schema
    -- 
    
	--
    -- Generated using Intuit's Oracle VPD DDL Xpand template
    --
    -- Create sequences
    
DECLARE 
	SEQUENCE_EXISTS PLS_INTEGER :=0;
BEGIN
	SELECT COUNT(*) INTO SEQUENCE_EXISTS
	FROM USER_SEQUENCES
	WHERE SEQUENCE_NAME = 'HIBERNATE_SEQUENCE';
	IF SEQUENCE_EXISTS = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE "HIBERNATE_SEQUENCE" MINVALUE 0 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 21 CACHE 20 NOORDER NOCYCLE';
	END IF;
END;
/

    -- Create tables 
    
    
    
	CREATE TABLE HISTPAYCHECKLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		VALUE_CUR VARCHAR2(100) NULL,
		VALUE_AMT NUMBER(19,4) NULL,
		INCOMESUBJECTTOTAX_CUR VARCHAR2(100) NULL,
		INCOMESUBJECTTOTAX_AMT NUMBER(19,4) NULL,
		WAGEBASE_CUR VARCHAR2(100) NULL,
		WAGEBASE_AMT NUMBER(19,4) NULL,
		EXCESSAMOUNT_CUR VARCHAR2(100) NULL,
		EXCESSAMOUNT_AMT NUMBER(19,4) NULL,
		EXEMPTAMOUNT_CUR VARCHAR2(100) NULL,
		EXEMPTAMOUNT_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		PAYROLLITEMDTL NUMBER(20,0) NULL,
		PAYROLLITEM NUMBER(20,0) NULL,
		HISTPAYCHECK NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "HISTPAYCHECKLINEITEM_RX" ON HISTPAYCHECKLINEITEM (REALM_ID ASC)
/	
    CREATE INDEX "HPCHKLITM_FK_PITMDTL" ON HISTPAYCHECKLINEITEM (PAYROLLITEMDTL ASC)
/	
    CREATE INDEX "HPCHK_FK_HPCHKLITM" ON HISTPAYCHECKLINEITEM (HISTPAYCHECK ASC)
/	
    CREATE INDEX "HPCHKLITM_FK_PITM" ON HISTPAYCHECKLINEITEM (PAYROLLITEM ASC)
/	
    CREATE INDEX "HSTPCHKLITM_FK_ER" ON HISTPAYCHECKLINEITEM (REALMOWNER ASC)
/	



	CREATE TABLE PAYROLLITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		SOURCEENTITY VARCHAR2(100) NULL,
		TARGETENTITY VARCHAR2(100) NULL,
		RATE_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_MONEY_CUR VARCHAR2(100) NULL,
		RATE_MONEY_AMT NUMBER(19,4) NULL,
		RATE_QUANTITY NUMBER NULL,
		RATE_PERCENTAGE NUMBER NULL,
		RATE_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_VALUE2 NUMBER NULL,
		DELETED CHAR(1)  DEFAULT '0' NOT NULL,
		COMPLIANCEDOCTYPE VARCHAR2(100) NULL,
		NAME VARCHAR2(100) NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		ACTIVE CHAR(1)  DEFAULT '1' NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		LAW NUMBER(20,0) NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL,
		DEDUCTIONTYPE VARCHAR2(100) NULL,
		BENEFITSERVICE NUMBER(20,0) NULL,
		BENEFITTYPE VARCHAR2(100) NULL,
		TAXTYPE VARCHAR2(100) NULL,
		PAIDTIMEOFFTYPE VARCHAR2(100) NULL,
		LIMITACCRUAL CHAR(1) NULL,
		ALLOWCARRYOVER CHAR(1) NULL,
		HBENEFITTYPE VARCHAR2(100) NULL,
		COMPENSATIONTYPE VARCHAR2(100) NULL,
		RBENEFITTYPE VARCHAR2(100) NULL,
		MAXCONTRIBUTION_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MAXCONTRIBUTION_MONEY_CUR VARCHAR2(100) NULL,
		MAXCONTRIBUTION_MONEY_AMT NUMBER(19,4) NULL,
		MAXCONTRIBUTION_QUANTITY NUMBER NULL,
		MAXCONTRIBUTION_PERCENTAGE NUMBER NULL,
		MAXCONTRIBUTION_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MAXCONTRIBUTION_VALUE2 NUMBER NULL,
		MAXCONTRIBUTIONUSEREDITED CHAR(1) NULL,
		MCUC_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MCUC_MONEY_CUR VARCHAR2(100) NULL,
		MCUC_MONEY_AMT NUMBER(19,4) NULL,
		MCUC_QUANTITY NUMBER NULL,
		MCUC_PERCENTAGE NUMBER NULL,
		MCUC_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		MCUC_VALUE2 NUMBER NULL,
		MCUCUE CHAR(1) NULL	)
/
    
    CREATE INDEX "PAYROLLITEM_RX" ON PAYROLLITEM (REALM_ID ASC)
/	
    CREATE INDEX "PAYROLLITEM_FK_LAW" ON PAYROLLITEM (LAW ASC)
/	
    CREATE INDEX "PAYROLLITEM_FK_REALMOWNER" ON PAYROLLITEM (REALMOWNER ASC)
/	
    CREATE INDEX "PAYROLLITEM_FK_EMPLOYER" ON PAYROLLITEM (EMPLOYER ASC)
/	
    CREATE INDEX "PAYROLLITEM_FK_BENEFITSERVICE" ON PAYROLLITEM (BENEFITSERVICE ASC)
/	



	CREATE TABLE HISTPAYCHECK (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TXNDATE TIMESTAMP NULL,
		TXNNO VARCHAR2(100) NULL,
		MEMO VARCHAR2(100) NULL,
		PAYROLLPERIOD_STARTDATE DATE NULL,
		PAYROLLPERIOD_ENDDATE DATE NULL,
		GROSSAMOUNT_CUR VARCHAR2(100) NULL,
		GROSSAMOUNT_AMT NUMBER(19,4) NULL,
		NETAMOUNT_CUR VARCHAR2(100) NULL,
		NETAMOUNT_AMT NUMBER(19,4) NULL,
		DEDUCTIONAMOUNT_CUR VARCHAR2(100) NULL,
		DEDUCTIONAMOUNT_AMT NUMBER(19,4) NULL,
		WORKERPAIDTAXES_CUR VARCHAR2(100) NULL,
		WORKERPAIDTAXES_AMT NUMBER(19,4) NULL,
		EMPLOYERPAIDTAXES_CUR VARCHAR2(100) NULL,
		EMPLOYERPAIDTAXES_AMT NUMBER(19,4) NULL,
		WORKERPAIDBENEFITS_CUR VARCHAR2(100) NULL,
		WORKERPAIDBENEFITS_AMT NUMBER(19,4) NULL,
		EMPLOYERPAIDBENEFITS_CUR VARCHAR2(100) NULL,
		EMPLOYERPAIDBENEFITS_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL,
		WORKER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "HISTPAYCHECK_RX" ON HISTPAYCHECK (REALM_ID ASC)
/	
    CREATE INDEX "HISTPAYCHECK_FK_WORKER" ON HISTPAYCHECK (WORKER ASC)
/	
    CREATE INDEX "HISTPAYCHECK_FK_EMPLOYER" ON HISTPAYCHECK (EMPLOYER ASC)
/	
    CREATE INDEX "HISTPAYCHECK_FK_REALMOWNER" ON HISTPAYCHECK (REALMOWNER ASC)
/	



	CREATE TABLE PAYROLLSCHEDULE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NEXTPAYPERIODENDDATE TIMESTAMP NULL,
		PAYDAYOFFSET NUMBER(10,0) NULL,
		PAYROLLRUNDAYOFFSET NUMBER(10,0) NULL,
		PAYPERIOD1ENDOFFSET NUMBER(10,0) NOT NULL,
		PAYPERIOD2ENDOFFSET NUMBER(10,0) NOT NULL,
		DISTRIBUTIONMETHOD VARCHAR2(100) NULL,
		FREQUENCY VARCHAR2(100) NULL,
		DEFAULTT CHAR(1) NULL,
		MEMO VARCHAR2(100) NULL,
		PAYPERIODENDDAYOFMONTH1 NUMBER(10,0) NOT NULL,
		PAYPERIODENDDAYOFMONTH2 NUMBER(10,0) NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PAYROLLSCHEDULE_RX" ON PAYROLLSCHEDULE (REALM_ID ASC)
/	
    CREATE INDEX "PAYROLLSCHEDULE_FK_REALMOWNER" ON PAYROLLSCHEDULE (REALMOWNER ASC)
/	
    CREATE INDEX "PAYROLLSCHEDULE_FK_EMPLOYER" ON PAYROLLSCHEDULE (EMPLOYER ASC)
/	



	CREATE TABLE CONTACTPERSON (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PERSONNAME_FIRSTNAME VARCHAR2(100) NULL,
		PERSONNAME_MIDDLENAME VARCHAR2(100) NULL,
		PERSONNAME_LASTNAME VARCHAR2(100) NULL,
		PERSONNAME_TITLE VARCHAR2(100) NULL,
		PERSONNAME_SUFFIX VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEONE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETWO VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETHREE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		MAILADR_ADDRESSTYPE VARCHAR2(100) NULL,
		MAILADR_POSTTOWN VARCHAR2(100) NULL,
		MAILADR_COUNTY VARCHAR2(100) NULL,
		MAILADR_COUNTYCODE VARCHAR2(100) NULL,
		MAILADR_STATEPROV VARCHAR2(100) NULL,
		MAILADR_POSTALCODE VARCHAR2(100) NULL,
		MAILADR_POSTALCODESUFFIX VARCHAR2(100) NULL,
		MAILADR_COUNTRYNAME VARCHAR2(100) NULL,
		MAILADR_COUNTRYCODE VARCHAR2(100) NULL,
		MAILADR_GEOCODE VARCHAR2(100) NULL,
		MAILADR_LABEL VARCHAR2(100) NULL,
		MAILADR_CREATIONSOURCE VARCHAR2(100) NULL,
		MAILADR_ISSTANDARDIZED CHAR(1) NULL,
		MAILADR_ISSTREETADDRESS CHAR(1) NULL,
		MAILADR_DONOTSTAND CHAR(1) NULL,
		EMAILADDRESS_ID VARCHAR2(100) NULL,
		EMAILADDRESS_ADDRESS VARCHAR2(100) NULL,
		EMAILADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		EMAILADDRESS_DEFAULTT CHAR(1) NULL,
		EMAILADDRESS_TAG VARCHAR2(100) NULL,
		WORKPHONE_ID VARCHAR2(100) NULL,
		WORKPHONE_DEVICETYPE VARCHAR2(100) NULL,
		WORKPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		WORKPHONE_AREACODE VARCHAR2(100) NULL,
		WORKPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		WORKPHONE_EXTENSION VARCHAR2(100) NULL,
		WORKPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		WORKPHONE_PIN VARCHAR2(100) NULL,
		WORKPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		WORKPHONE_DEFAULTT CHAR(1) NULL,
		WORKPHONE_TAG VARCHAR2(100) NULL,
		HOMEPHONE_ID VARCHAR2(100) NULL,
		HOMEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		HOMEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		HOMEPHONE_AREACODE VARCHAR2(100) NULL,
		HOMEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		HOMEPHONE_EXTENSION VARCHAR2(100) NULL,
		HOMEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		HOMEPHONE_PIN VARCHAR2(100) NULL,
		HOMEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		HOMEPHONE_DEFAULTT CHAR(1) NULL,
		HOMEPHONE_TAG VARCHAR2(100) NULL,
		MOBILEPHONE_ID VARCHAR2(100) NULL,
		MOBILEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		MOBILEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		MOBILEPHONE_AREACODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXTENSION VARCHAR2(100) NULL,
		MOBILEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		MOBILEPHONE_PIN VARCHAR2(100) NULL,
		MOBILEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		MOBILEPHONE_DEFAULTT CHAR(1) NULL,
		MOBILEPHONE_TAG VARCHAR2(100) NULL,
		FAXPHONE_ID VARCHAR2(100) NULL,
		FAXPHONE_DEVICETYPE VARCHAR2(100) NULL,
		FAXPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		FAXPHONE_AREACODE VARCHAR2(100) NULL,
		FAXPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		FAXPHONE_EXTENSION VARCHAR2(100) NULL,
		FAXPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		FAXPHONE_PIN VARCHAR2(100) NULL,
		FAXPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		FAXPHONE_DEFAULTT CHAR(1) NULL,
		FAXPHONE_TAG VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		WORKER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "CONTACTPERSON_RX" ON CONTACTPERSON (REALM_ID ASC)
/	
    CREATE INDEX "CONTACTPERSON_FK_REALMOWNER" ON CONTACTPERSON (REALMOWNER ASC)
/	
    CREATE INDEX "CONTACTPERSON_FK_WORKER" ON CONTACTPERSON (WORKER ASC)
/	



	CREATE TABLE PAYROLLITEMDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		RATE_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_MONEY_CUR VARCHAR2(100) NULL,
		RATE_MONEY_AMT NUMBER(19,4) NULL,
		RATE_QUANTITY NUMBER NULL,
		RATE_PERCENTAGE NUMBER NULL,
		RATE_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_VALUE2 NUMBER NULL,
		SOURCEENTITY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		TARGETENTITY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		COMPLIANCEDOCTYPE VARCHAR2(100) NULL,
		NAME VARCHAR2(100) NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		DELETED CHAR(1)  DEFAULT '0' NOT NULL,
		ACTIVE CHAR(1)  DEFAULT '1' NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		LINKEDPAYROLLITEMDTL NUMBER(20,0) NULL,
		PAYROLLITEM NUMBER(20,0) NOT NULL,
		WORKER NUMBER(20,0) NULL,
		PAIDTIMEOFFTYPE VARCHAR2(100) NULL,
		ACCRUALTYPE VARCHAR2(100) NULL,
		LIMITACCRUAL CHAR(1) NULL,
		ALLOWCARRYOVER CHAR(1) NULL,
		MAXIMUMACCRUAL NUMBER NULL,
		ACCRUEDHOURS NUMBER NULL,
		ACCRUALSTARTTYPE VARCHAR2(100) NULL,
		ACCRUALSTARTDATE TIMESTAMP NULL,
		RBENEFITTYPE VARCHAR2(100) NULL,
		HBENEFITTYPE VARCHAR2(100) NULL,
		BENEFITTYPE VARCHAR2(100) NULL,
		TAXTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		DEDUCTIONTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		COMPENSATIONTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		FIXEDRATE CHAR(1) NULL,
		QUANTITY_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_MONEY_CUR VARCHAR2(100) NULL,
		QUANTITY_MONEY_AMT NUMBER(19,4) NULL,
		QUANTITY_QUANTITY NUMBER NULL,
		QUANTITY_PERCENTAGE NUMBER NULL,
		QUANTITY_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_VALUE2 NUMBER NULL,
		PTOBASERATETYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL	)
/
    
    CREATE INDEX "PAYROLLITEMDTL_RX" ON PAYROLLITEMDTL (REALM_ID ASC)
/	
    CREATE INDEX "PAYROLLITEMDTL_FK_PAYROLLITEM" ON PAYROLLITEMDTL (PAYROLLITEM ASC)
/	
    CREATE INDEX "PITMDTL_FK_PITMDTL" ON PAYROLLITEMDTL (LINKEDPAYROLLITEMDTL ASC)
/	
    CREATE INDEX "PAYROLLITEMDTL_FK_REALMOWNER" ON PAYROLLITEMDTL (REALMOWNER ASC)
/	
    CREATE INDEX "PAYROLLITEMDTL_FK_WORKER" ON PAYROLLITEMDTL (WORKER ASC)
/	



	CREATE TABLE DISABILITYINSDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PERCENTAGERATE NUMBER NULL	)
/
    
    CREATE INDEX "DISABILITYINSDOCDTL_RX" ON DISABILITYINSDOCDTL (REALM_ID ASC)
/	



	CREATE TABLE WORKERADJLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		ADJUSTMENTAMOUNT_CUR VARCHAR2(100) NULL,
		ADJUSTMENTAMOUNT_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		PAYROLLITEMDTL NUMBER(20,0) NOT NULL,
		WORKERADJUSTMENT NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "WORKERADJLINEITEM_RX" ON WORKERADJLINEITEM (REALM_ID ASC)
/	
    CREATE INDEX "HPLITMPITMDTL_FK_PITMDTL" ON WORKERADJLINEITEM (PAYROLLITEMDTL ASC)
/	
    CREATE INDEX "HSTPCHKLITEM_FK_HSTPCHK" ON WORKERADJLINEITEM (WORKERADJUSTMENT ASC)
/	
    CREATE INDEX "WKRADJLITEM_FK_ER" ON WORKERADJLINEITEM (REALMOWNER ASC)
/	



	CREATE TABLE BANKACCOUNT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		ACCOUNTNO VARCHAR2(100) NULL,
		ROUTINGNO VARCHAR2(100) NULL,
		BANKNAME VARCHAR2(100) NULL,
		ACCOUNTTYPE VARCHAR2(100) NULL,
		LASTVERIFIEDDATE TIMESTAMP NULL,
		BANKADDRESS_ADDRESSLINEONE VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINETWO VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINETHREE VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		BANKADDRESS_ADDRESSTYPE VARCHAR2(100) NULL,
		BANKADDRESS_POSTTOWN VARCHAR2(100) NULL,
		BANKADDRESS_COUNTY VARCHAR2(100) NULL,
		BANKADDRESS_COUNTYCODE VARCHAR2(100) NULL,
		BANKADDRESS_STATEPROV VARCHAR2(100) NULL,
		BANKADDRESS_POSTALCODE VARCHAR2(100) NULL,
		BANKADDRESS_POSTALCODESUFFIX VARCHAR2(100) NULL,
		BANKADDRESS_COUNTRYNAME VARCHAR2(100) NULL,
		BANKADDRESS_COUNTRYCODE VARCHAR2(100) NULL,
		BANKADDRESS_GEOCODE VARCHAR2(100) NULL,
		BANKADDRESS_LABEL VARCHAR2(100) NULL,
		BANKADDRESS_CREATIONSOURCE VARCHAR2(100) NULL,
		BANKADDRESS_ISSTANDARDIZED CHAR(1) NULL,
		BANKADDRESS_ISSTREETADDRESS CHAR(1) NULL,
		BANKADDRESS_DONOTSTAND CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		WORKER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "BANKACCOUNT_RX" ON BANKACCOUNT (REALM_ID ASC)
/	
    CREATE INDEX "BANKACCOUNT_FK_EMPLOYER" ON BANKACCOUNT (EMPLOYER ASC)
/	
    CREATE INDEX "BANKACCOUNT_FK_REALMOWNER" ON BANKACCOUNT (REALMOWNER ASC)
/	
    CREATE INDEX "BANKACCOUNT_FK_WORKER" ON BANKACCOUNT (WORKER ASC)
/	



	CREATE TABLE EMPLOYERCOMPLIANCEDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "EMPLOYERCOMPLIANCEDOCDTL_RX" ON EMPLOYERCOMPLIANCEDOCDTL (REALM_ID ASC)
/	
    CREATE INDEX "ERCOMPLDOCDTL_FK_ER" ON EMPLOYERCOMPLIANCEDOCDTL (EMPLOYER ASC)
/	
    CREATE INDEX "ERCOMPLDOCDTL_FK_ER1" ON EMPLOYERCOMPLIANCEDOCDTL (REALMOWNER ASC)
/	



	CREATE TABLE EMPLOYMENTPERIOD (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		EMPLOYMENTPERIOD_STARTDATE DATE NULL,
		EMPLOYMENTPERIOD_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		WORKER NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "EMPLOYMENTPERIOD_RX" ON EMPLOYMENTPERIOD (REALM_ID ASC)
/	
    CREATE INDEX "EMPLOYMENTPERIOD_FK_REALMOWNER" ON EMPLOYMENTPERIOD (REALMOWNER ASC)
/	
    CREATE INDEX "EMPLOYMENTPERIOD_FK_WORKER" ON EMPLOYMENTPERIOD (WORKER ASC)
/	



	CREATE TABLE EMPLOYERADJLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		ADJUSTMENTAMOUNT_CUR VARCHAR2(100) NULL,
		ADJUSTMENTAMOUNT_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PAYROLLITEM NUMBER(20,0) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYERADJUSTMENT NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "EMPLOYERADJLINEITEM_RX" ON EMPLOYERADJLINEITEM (REALM_ID ASC)
/	
    CREATE INDEX "ERADJLITM_FK_PITEM" ON EMPLOYERADJLINEITEM (PAYROLLITEM ASC)
/	
    CREATE INDEX "LIABADJASSOC_FK_LIABADJ" ON EMPLOYERADJLINEITEM (EMPLOYERADJUSTMENT ASC)
/	
    CREATE INDEX "ERADJLITM_FK_ER" ON EMPLOYERADJLINEITEM (REALMOWNER ASC)
/	



	CREATE TABLE JURISDICTION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NOT NULL,
		MAPPINGKEY VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "JURISDICTION_RX" ON JURISDICTION (REALM_ID ASC)
/	



	CREATE TABLE COMPLIANCEDOC (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NOT NULL,
		DOCID VARCHAR2(100)  DEFAULT 'NOTSET' NOT NULL,
		DOCUSE VARCHAR2(100)  DEFAULT 'NOTSET' NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		LAW NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "COMPLIANCEDOC_RX" ON COMPLIANCEDOC (REALM_ID ASC)
/	
    CREATE INDEX "COMPLIANCEDOC_FK_LAW" ON COMPLIANCEDOC (LAW ASC)
/	



	CREATE TABLE PAYMENT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAYMENTDATE DATE NULL,
		PAYROLLPERIOD_STARTDATE DATE NULL,
		PAYROLLPERIOD_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PAYMENT_RX" ON PAYMENT (REALM_ID ASC)
/	
    CREATE INDEX "PAYMENT_FK_REALMOWNER" ON PAYMENT (REALMOWNER ASC)
/	
    CREATE INDEX "PAYMENT_FK_EMPLOYER" ON PAYMENT (EMPLOYER ASC)
/	



	CREATE TABLE INDUSTRYTYPE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ORDINALVALUE NUMBER(10,0) NULL,
		STRINGVALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "INDUSTRYTYPE_RX" ON INDUSTRYTYPE (REALM_ID ASC)
/	



	CREATE TABLE BENEFITPROVIDER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "BENEFITPROVIDER_RX" ON BENEFITPROVIDER (REALM_ID ASC)
/	



	CREATE TABLE PAYCHECKLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		SEQUENCENO NUMBER(10,0) NULL,
		SORTSEQUENCE VARCHAR2(100) NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		RATE_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_MONEY_CUR VARCHAR2(100) NULL,
		RATE_MONEY_AMT NUMBER(19,4) NULL,
		RATE_QUANTITY NUMBER NULL,
		RATE_PERCENTAGE NUMBER NULL,
		RATE_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		RATE_VALUE2 NUMBER NULL,
		QUANTITY_TYPE1 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_MONEY_CUR VARCHAR2(100) NULL,
		QUANTITY_MONEY_AMT NUMBER(19,4) NULL,
		QUANTITY_QUANTITY NUMBER NULL,
		QUANTITY_PERCENTAGE NUMBER NULL,
		QUANTITY_TYPE2 VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		QUANTITY_VALUE2 NUMBER NULL,
		VALUE_CUR VARCHAR2(100) NULL,
		VALUE_AMT NUMBER(19,4) NULL,
		SOURCEENTITY VARCHAR2(100) NULL,
		TARGETENTITY VARCHAR2(100) NULL,
		INCOMESUBJECTTOTAX_CUR VARCHAR2(100) NULL,
		INCOMESUBJECTTOTAX_AMT NUMBER(19,4) NULL,
		WAGEBASE_CUR VARCHAR2(100) NULL,
		WAGEBASE_AMT NUMBER(19,4) NULL,
		EXCESSAMOUNT_CUR VARCHAR2(100) NULL,
		EXCESSAMOUNT_AMT NUMBER(19,4) NULL,
		EXEMPTAMOUNT_CUR VARCHAR2(100) NULL,
		EXEMPTAMOUNT_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		SOURCEPAYROLLITEMDTL NUMBER(20,0) NOT NULL,
		PAYCHECK NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PAYCHECKLINEITEM_RX" ON PAYCHECKLINEITEM (REALM_ID ASC)
/	
    CREATE INDEX "PCLI_PID_FK_CONSTRAINT" ON PAYCHECKLINEITEM (SOURCEPAYROLLITEMDTL ASC)
/	
    CREATE INDEX "PAYCHECKLINEITEM_FK_REALMOWNER" ON PAYCHECKLINEITEM (REALMOWNER ASC)
/	
    CREATE INDEX "PCHKPCHKLITEM_FK_PCHK" ON PAYCHECKLINEITEM (PAYCHECK ASC)
/	



	CREATE TABLE LEGALSTRUCTURE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ORDINALVALUE NUMBER(10,0) NULL,
		STRINGVALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "LEGALSTRUCTURE_RX" ON LEGALSTRUCTURE (REALM_ID ASC)
/	



	CREATE TABLE PAYMENTLINEITEMSPLIT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		SPLITAMOUNT_CUR VARCHAR2(100) NULL,
		SPLITAMOUNT_AMT NUMBER(19,4) NULL,
		SPLITDERIVED CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PAYROLLITEM NUMBER(20,0) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		PAYMENTLINEITEM NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PAYMENTLINEITEMSPLIT_RX" ON PAYMENTLINEITEMSPLIT (REALM_ID ASC)
/	
    CREATE INDEX "PAYMNTLITMSPLT_FK_PAYITM" ON PAYMENTLINEITEMSPLIT (PAYROLLITEM ASC)
/	
    CREATE INDEX "PMTLITMSPLT_FK_ER" ON PAYMENTLINEITEMSPLIT (REALMOWNER ASC)
/	
    CREATE INDEX "PAYMNTLITM_FK_PAYMNTLITMSPLT" ON PAYMENTLINEITEMSPLIT (PAYMENTLINEITEM ASC)
/	



	CREATE TABLE PAYCHECK (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TXNDATE TIMESTAMP NULL,
		TXNNO VARCHAR2(100) NULL,
		PAYDATE DATE NULL,
		MEMO VARCHAR2(100) NULL,
		WORKFLOWSTATUS VARCHAR2(100) NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		GROSSAMOUNT_CUR VARCHAR2(100) NULL,
		GROSSAMOUNT_AMT NUMBER(19,4) NULL,
		NETAMOUNT_CUR VARCHAR2(100) NULL,
		NETAMOUNT_AMT NUMBER(19,4) NULL,
		DEDUCTIONAMOUNT_CUR VARCHAR2(100) NULL,
		DEDUCTIONAMOUNT_AMT NUMBER(19,4) NULL,
		DISTRIBUTIONMETHOD VARCHAR2(100) NULL,
		WORKERPDTAXES_CUR VARCHAR2(100) NULL,
		WORKERPDTAXES_AMT NUMBER(19,4) NULL,
		EMPLOYERPDTAXES_CUR VARCHAR2(100) NULL,
		EMPLOYERPDTAXES_AMT NUMBER(19,4) NULL,
		WORKERPDBENEFITS_CUR VARCHAR2(100) NULL,
		WORKERPDBENEFITS_AMT NUMBER(19,4) NULL,
		EMPLOYERPDBENEFITS_CUR VARCHAR2(100) NULL,
		EMPLOYERPDBENEFITS_AMT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		PAYROLLRUN NUMBER(20,0) NOT NULL,
		WORKER NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "PAYCHECK_RX" ON PAYCHECK (REALM_ID ASC)
/	
    CREATE INDEX "PAYCHK_PAYDATE_IDX" ON PAYCHECK (PAYDATE ASC)
/	
    CREATE INDEX "PAYCHECK_FK_REALMOWNER" ON PAYCHECK (REALMOWNER ASC)
/	
    CREATE INDEX "PAYCHECK_FK_PAYROLLRUN" ON PAYCHECK (PAYROLLRUN ASC)
/	
    CREATE INDEX "PAYCHECK_FK_WORKER" ON PAYCHECK (WORKER ASC)
/	



	CREATE TABLE LAW (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LAWID VARCHAR2(100) NOT NULL,
		SEQUENCENO NUMBER(10,0)  DEFAULT 0 NOT NULL,
		SOURCEENTITY VARCHAR2(100)  DEFAULT 'NOTSET' NOT NULL,
		TARGETENTITY VARCHAR2(100)  DEFAULT 'NOTSET' NOT NULL,
		NAME VARCHAR2(100) NOT NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		AGENCY NUMBER(20,0) NULL,
		JURISDICTION NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "LAW_RX" ON LAW (REALM_ID ASC)
/	
    CREATE INDEX "JURCONLAW_FK_JUR" ON LAW (JURISDICTION ASC)
/	
    CREATE INDEX "LAW_FK_AGENCY" ON LAW (AGENCY ASC)
/	



	CREATE TABLE WORKER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		DATEOFBIRTH DATE NULL,
		WORKERID VARCHAR2(100) NULL,
		JOBPOSITIONNOTE VARCHAR2(100) NULL,
		PAYROLLFREQUENCY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		GENDER VARCHAR2(100) NULL,
		RELTOOWNER VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		PERSONNAME_FIRSTNAME VARCHAR2(100) NULL,
		PERSONNAME_MIDDLENAME VARCHAR2(100) NULL,
		PERSONNAME_LASTNAME VARCHAR2(100) NULL,
		PERSONNAME_TITLE VARCHAR2(100) NULL,
		PERSONNAME_SUFFIX VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEONE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETWO VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINETHREE VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		MAILADR_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		MAILADR_ADDRESSTYPE VARCHAR2(100) NULL,
		MAILADR_POSTTOWN VARCHAR2(100) NULL,
		MAILADR_COUNTY VARCHAR2(100) NULL,
		MAILADR_COUNTYCODE VARCHAR2(100) NULL,
		MAILADR_STATEPROV VARCHAR2(100) NULL,
		MAILADR_POSTALCODE VARCHAR2(100) NULL,
		MAILADR_POSTALCODESUFFIX VARCHAR2(100) NULL,
		MAILADR_COUNTRYNAME VARCHAR2(100) NULL,
		MAILADR_COUNTRYCODE VARCHAR2(100) NULL,
		MAILADR_GEOCODE VARCHAR2(100) NULL,
		MAILADR_LABEL VARCHAR2(100) NULL,
		MAILADR_CREATIONSOURCE VARCHAR2(100) NULL,
		MAILADR_ISSTANDARDIZED CHAR(1) NULL,
		MAILADR_ISSTREETADDRESS CHAR(1) NULL,
		MAILADR_DONOTSTAND CHAR(1) NULL,
		TAXRESADR_ADDRESSLINEONE VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINETWO VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINETHREE VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		TAXRESADR_ADDRESSTYPE VARCHAR2(100) NULL,
		TAXRESADR_POSTTOWN VARCHAR2(100) NULL,
		TAXRESADR_COUNTY VARCHAR2(100) NULL,
		TAXRESADR_COUNTYCODE VARCHAR2(100) NULL,
		TAXRESADR_STATEPROV VARCHAR2(100) NULL,
		TAXRESADR_POSTALCODE VARCHAR2(100) NULL,
		TAXRESADR_POSTALCODESUFFIX VARCHAR2(100) NULL,
		TAXRESADR_COUNTRYNAME VARCHAR2(100) NULL,
		TAXRESADR_COUNTRYCODE VARCHAR2(100) NULL,
		TAXRESADR_GEOCODE VARCHAR2(100) NULL,
		TAXRESADR_LABEL VARCHAR2(100) NULL,
		TAXRESADR_CREATIONSOURCE VARCHAR2(100) NULL,
		TAXRESADR_ISSTANDARDIZED CHAR(1) NULL,
		TAXRESADR_ISSTREETADDRESS CHAR(1) NULL,
		TAXRESADR_DONOTSTAND CHAR(1) NULL,
		EMAILADDRESS_ID VARCHAR2(100) NULL,
		EMAILADDRESS_ADDRESS VARCHAR2(100) NULL,
		EMAILADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		EMAILADDRESS_DEFAULTT CHAR(1) NULL,
		EMAILADDRESS_TAG VARCHAR2(100) NULL,
		HOMEPHONE_ID VARCHAR2(100) NULL,
		HOMEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		HOMEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		HOMEPHONE_AREACODE VARCHAR2(100) NULL,
		HOMEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		HOMEPHONE_EXTENSION VARCHAR2(100) NULL,
		HOMEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		HOMEPHONE_PIN VARCHAR2(100) NULL,
		HOMEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		HOMEPHONE_DEFAULTT CHAR(1) NULL,
		HOMEPHONE_TAG VARCHAR2(100) NULL,
		WORKPHONE_ID VARCHAR2(100) NULL,
		WORKPHONE_DEVICETYPE VARCHAR2(100) NULL,
		WORKPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		WORKPHONE_AREACODE VARCHAR2(100) NULL,
		WORKPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		WORKPHONE_EXTENSION VARCHAR2(100) NULL,
		WORKPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		WORKPHONE_PIN VARCHAR2(100) NULL,
		WORKPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		WORKPHONE_DEFAULTT CHAR(1) NULL,
		WORKPHONE_TAG VARCHAR2(100) NULL,
		MOBILEPHONE_ID VARCHAR2(100) NULL,
		MOBILEPHONE_DEVICETYPE VARCHAR2(100) NULL,
		MOBILEPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		MOBILEPHONE_AREACODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		MOBILEPHONE_EXTENSION VARCHAR2(100) NULL,
		MOBILEPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		MOBILEPHONE_PIN VARCHAR2(100) NULL,
		MOBILEPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		MOBILEPHONE_DEFAULTT CHAR(1) NULL,
		MOBILEPHONE_TAG VARCHAR2(100) NULL,
		PERSONTAXID_VALUE VARCHAR2(100) NULL,
		PERSONTAXID_LASTVERIFIEDDATE DATE NULL,
		PERSONTAXID_TYPE VARCHAR2(100) NULL,
		READYFORTAX CHAR(1) NULL,
		READYFORPAY CHAR(1) NULL,
		PAYROLLDISTRIBUTIONMETHOD VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		EMPLOYMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		ACTIVE CHAR(1) NOT NULL,
		EMPLOYMENTPERIOD_STARTDATE DATE NULL,
		EMPLOYMENTPERIOD_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		WORKLOCATION NUMBER(20,0) NULL,
		REALMOWNER NUMBER(20,0) NULL
,UNIQUE(REALMOWNER),
		PAYROLLSCHEDULE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "WORKER_RX" ON WORKER (REALM_ID ASC)
/	
    CREATE INDEX "WORKER_FK_PAYROLLSCHEDULE" ON WORKER (PAYROLLSCHEDULE ASC)
/	
    CREATE INDEX "WLOCWRKR_FK_WLOC" ON WORKER (WORKLOCATION ASC)
/	



	CREATE TABLE PAYROLLRUN (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		PAYROLLRUNID VARCHAR2(100) NULL,
		PAYDATE DATE NULL,
		PAYROLLRUNDATE TIMESTAMP NULL,
		PAYPERIOD_STARTDATE DATE NULL,
		PAYPERIOD_ENDDATE DATE NULL,
		TOTALGROSSPAY_CUR VARCHAR2(100) NULL,
		TOTALGROSSPAY_AMT NUMBER(19,4) NULL,
		TOTALNETPAY_CUR VARCHAR2(100) NULL,
		TOTALNETPAY_AMT NUMBER(19,4) NULL,
		PAYROLLFREQUENCY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		WORKFLOWSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		TOTALWORKERPDTAXES_CUR VARCHAR2(100) NULL,
		TOTALWORKERPDTAXES_AMT NUMBER(19,4) NULL,
		TOTALEMPLOYERPDTAXES_CUR VARCHAR2(100) NULL,
		TOTALEMPLOYERPDTAXES_AMT NUMBER(19,4) NULL,
		DISTRIBUTIONMETHOD VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		ISSCHEDULED CHAR(1) NULL,
		TOTALWORKERPDBENEFITS_CUR VARCHAR2(100) NULL,
		TOTALWORKERPDBENEFITS_AMT NUMBER(19,4) NULL,
		TOTALEMPLOYERPDBENEFITS_CUR VARCHAR2(100) NULL,
		TOTALEMPLOYERPDBENEFITS_AMT NUMBER(19,4) NULL,
		TYPEOF VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		PARTIALPERIOD CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PAYROLLRUN_RX" ON PAYROLLRUN (REALM_ID ASC)
/	
    CREATE INDEX "PAYROLLRUN_FK_REALMOWNER" ON PAYROLLRUN (REALMOWNER ASC)
/	



	CREATE TABLE WORKERADJUSTMENT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TXNNO VARCHAR2(100) NULL,
		PAYROLLPERIOD_STARTDATE DATE NULL,
		PAYROLLPERIOD_ENDDATE DATE NULL,
		EFFECTIVEDATE TIMESTAMP NULL,
		TXNDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		PAYROLLRUN NUMBER(20,0) NOT NULL,
		WORKER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "WORKERADJUSTMENT_RX" ON WORKERADJUSTMENT (REALM_ID ASC)
/	
    CREATE INDEX "WORKERWKRLIABADJ_FK_WORKER" ON WORKERADJUSTMENT (WORKER ASC)
/	
    CREATE INDEX "WORKERADJUSTMENT_FK_PAYROLLRUN" ON WORKERADJUSTMENT (PAYROLLRUN ASC)
/	
    CREATE INDEX "WORKERADJUSTMENT_FK_REALMOWNER" ON WORKERADJUSTMENT (REALMOWNER ASC)
/	



	CREATE TABLE UNEMPLOYMENTINSDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PERCENTAGERATE NUMBER NULL,
		RATECHANGEDBYINTUIT CHAR(1) NOT NULL,
		FUTURERATESTARTDATE TIMESTAMP NULL,
		PERCENTAGEFUTURERATE NUMBER NULL,
		DEFAULTRATE CHAR(1) NOT NULL	)
/
    
    CREATE INDEX "UNEMPLOYMENTINSDOCDTL_RX" ON UNEMPLOYMENTINSDOCDTL (REALM_ID ASC)
/	



	CREATE TABLE EMPLOYERCONTACTPERSON (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		OWNER CHAR(1) NULL,
		ROLETITLE VARCHAR2(100) NULL,
		TYPEOF VARCHAR2(100) NULL,
		EMPLOYER NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "EMPLOYERCONTACTPERSON_RX" ON EMPLOYERCONTACTPERSON (REALM_ID ASC)
/	
    CREATE INDEX "ERCONTACTPERSON_FK_ER" ON EMPLOYERCONTACTPERSON (EMPLOYER ASC)
/	



	CREATE TABLE TASK (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TYPE VARCHAR2(100)  DEFAULT 'DEADLINE' NULL,
		STATUS VARCHAR2(100)  DEFAULT 'NOTSTARTED' NULL,
		DESCRIPTION VARCHAR2(100) NULL,
		TASKCLASS VARCHAR2(100) NULL,
		PAYLOAD NUMBER(20,0)  DEFAULT 0 NULL,
		CATEGORY VARCHAR2(100) NULL,
		COMPLETIONDATE TIMESTAMP NULL,
		DEADLINE TIMESTAMP NULL,
		EXPIRATIONDATE TIMESTAMP NULL,
		NEXTREMINDERDATE DATE NULL,
		REMINDERPERIOD NUMBER(10,0) NULL,
		MANUALLYCLOSED CHAR(1) NULL,
		NAME VARCHAR2(100) NULL,
		USERMANAGABLE CHAR(1)  DEFAULT '0' NOT NULL,
		DATERANGE_STARTDATE DATE NULL,
		DATERANGE_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "TASK_RX" ON TASK (REALM_ID ASC)
/	
    CREATE INDEX "TASK_FK_REALMOWNER" ON TASK (REALMOWNER ASC)
/	



	CREATE TABLE WORKLOCATION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		DEFAULTT CHAR(1)  DEFAULT '0' NOT NULL,
		EMAILADDRESS_ID VARCHAR2(100) NULL,
		EMAILADDRESS_ADDRESS VARCHAR2(100) NULL,
		EMAILADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		EMAILADDRESS_DEFAULTT CHAR(1) NULL,
		EMAILADDRESS_TAG VARCHAR2(100) NULL,
		WEBADDRESS_ID VARCHAR2(100) NULL,
		WEBADDRESS_URI VARCHAR2(100) NULL,
		WEBADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		WEBADDRESS_DEFAULTT CHAR(1) NULL,
		WEBADDRESS_TAG VARCHAR2(100) NULL,
		TRA_ADDRESSLINEONE VARCHAR2(100) NULL,
		TRA_ADDRESSLINETWO VARCHAR2(100) NULL,
		TRA_ADDRESSLINETHREE VARCHAR2(100) NULL,
		TRA_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		TRA_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		TRA_ADDRESSTYPE VARCHAR2(100) NULL,
		TRA_POSTTOWN VARCHAR2(100) NULL,
		TRA_COUNTY VARCHAR2(100) NULL,
		TRA_COUNTYCODE VARCHAR2(100) NULL,
		TRA_STATEPROV VARCHAR2(100) NULL,
		TRA_POSTALCODE VARCHAR2(100) NULL,
		TRA_POSTALCODESUFFIX VARCHAR2(100) NULL,
		TRA_COUNTRYNAME VARCHAR2(100) NULL,
		TRA_COUNTRYCODE VARCHAR2(100) NULL,
		TRA_GEOCODE VARCHAR2(100) NULL,
		TRA_LABEL VARCHAR2(100) NULL,
		TRA_CREATIONSOURCE VARCHAR2(100) NULL,
		TRA_ISSTANDARDIZED CHAR(1) NULL,
		TRA_ISSTREETADDRESS CHAR(1) NULL,
		TRA_DONOTSTAND CHAR(1) NULL,
		MAINPHONE_ID VARCHAR2(100) NULL,
		MAINPHONE_DEVICETYPE VARCHAR2(100) NULL,
		MAINPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		MAINPHONE_AREACODE VARCHAR2(100) NULL,
		MAINPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		MAINPHONE_EXTENSION VARCHAR2(100) NULL,
		MAINPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		MAINPHONE_PIN VARCHAR2(100) NULL,
		MAINPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		MAINPHONE_DEFAULTT CHAR(1) NULL,
		MAINPHONE_TAG VARCHAR2(100) NULL,
		FAXPHONE_ID VARCHAR2(100) NULL,
		FAXPHONE_DEVICETYPE VARCHAR2(100) NULL,
		FAXPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		FAXPHONE_AREACODE VARCHAR2(100) NULL,
		FAXPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		FAXPHONE_EXTENSION VARCHAR2(100) NULL,
		FAXPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		FAXPHONE_PIN VARCHAR2(100) NULL,
		FAXPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		FAXPHONE_DEFAULTT CHAR(1) NULL,
		FAXPHONE_TAG VARCHAR2(100) NULL,
		MA_ADDRESSLINEONE VARCHAR2(100) NULL,
		MA_ADDRESSLINETWO VARCHAR2(100) NULL,
		MA_ADDRESSLINETHREE VARCHAR2(100) NULL,
		MA_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		MA_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		MA_ADDRESSTYPE VARCHAR2(100) NULL,
		MA_POSTTOWN VARCHAR2(100) NULL,
		MA_COUNTY VARCHAR2(100) NULL,
		MA_COUNTYCODE VARCHAR2(100) NULL,
		MA_STATEPROV VARCHAR2(100) NULL,
		MA_POSTALCODE VARCHAR2(100) NULL,
		MA_POSTALCODESUFFIX VARCHAR2(100) NULL,
		MA_COUNTRYNAME VARCHAR2(100) NULL,
		MA_COUNTRYCODE VARCHAR2(100) NULL,
		MA_GEOCODE VARCHAR2(100) NULL,
		MA_LABEL VARCHAR2(100) NULL,
		MA_CREATIONSOURCE VARCHAR2(100) NULL,
		MA_ISSTANDARDIZED CHAR(1) NULL,
		MA_ISSTREETADDRESS CHAR(1) NULL,
		MA_DONOTSTAND CHAR(1) NULL,
		WORKERCOUNT NUMBER(10,0)  DEFAULT 0 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "WORKLOCATION_RX" ON WORKLOCATION (REALM_ID ASC)
/	
    CREATE INDEX "WORKLOCATION_FK_EMPLOYER" ON WORKLOCATION (EMPLOYER ASC)
/	
    CREATE INDEX "WORKLOCATION_FK_REALMOWNER" ON WORKLOCATION (REALMOWNER ASC)
/	



	CREATE TABLE PTDDATUM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		DATUM_PTDTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		DATUM_PERIOD_STARTDATE DATE NULL,
		DATUM_PERIOD_ENDDATE DATE NULL,
		DATUM_DATUMTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		DATUM_MONEY_CUR VARCHAR2(100) NULL,
		DATUM_MONEY_AMT NUMBER(19,4) NULL,
		DATUM_WAGEBASE_CUR VARCHAR2(100) NULL,
		DATUM_WAGEBASE_AMT NUMBER(19,4) NULL,
		DATUM_INCOMESUBJECTTOTAX_CUR VARCHAR2(100) NULL,
		DATUM_INCOMESUBJECTTOTAX_AMT NUMBER(19,4) NULL,
		DATUM_TOTALHOURS NUMBER NULL,
		DATUM_QUANTITY NUMBER NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		WORKERADJLINEITEM NUMBER(20,0) NULL,
		HISTPAYCHECKLINEITEM NUMBER(20,0) NULL,
		PAYCHECKLINEITEM NUMBER(20,0) NULL,
		PAYROLLITEMDTL NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PTDDATUM_RX" ON PTDDATUM (REALM_ID ASC)
/	
    CREATE INDEX "PTDDATUMHPLITEM_FK_HPLITEM" ON PTDDATUM (WORKERADJLINEITEM ASC)
/	
    CREATE INDEX "PTDDATUM_FK_REALMOWNER" ON PTDDATUM (REALMOWNER ASC)
/	
    CREATE INDEX "PAYITMDTLPTDDATUM_FK_PAYITMDTL" ON PTDDATUM (PAYROLLITEMDTL ASC)
/	
    CREATE INDEX "PCHKLITEMPTD_FK_PCHKLITEM" ON PTDDATUM (PAYCHECKLINEITEM ASC)
/	
    CREATE INDEX "HPCHKLITMPTD_FK_HPCHKLITM" ON PTDDATUM (HISTPAYCHECKLINEITEM ASC)
/	



	CREATE TABLE PAYMENTLINEITEM (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		AMOUNT_CUR VARCHAR2(100) NULL,
		AMOUNT_AMT NUMBER(19,4) NULL,
		PAYMENTTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		PAYMENT NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PAYMENTLINEITEM_RX" ON PAYMENTLINEITEM (REALM_ID ASC)
/	
    CREATE INDEX "PAYMENTLINEITEM_FK_REALMOWNER" ON PAYMENTLINEITEM (REALMOWNER ASC)
/	
    CREATE INDEX "PAYMENTLINEITEM_FK_PAYMENT" ON PAYMENTLINEITEM (PAYMENT ASC)
/	



	CREATE TABLE EMPLOYERADJUSTMENT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		TXNDATE TIMESTAMP NULL,
		TXNNO VARCHAR2(100) NULL,
		EFFECTIVEDATE TIMESTAMP NULL,
		PAYROLLPERIOD_STARTDATE DATE NULL,
		PAYROLLPERIOD_ENDDATE DATE NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		PAYROLLRUN NUMBER(20,0) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "EMPLOYERADJUSTMENT_RX" ON EMPLOYERADJUSTMENT (REALM_ID ASC)
/	
    CREATE INDEX "ERADJ_FK_ER" ON EMPLOYERADJUSTMENT (REALMOWNER ASC)
/	
    CREATE INDEX "EMPLOYERADJUSTMENT_FK_EMPLOYER" ON EMPLOYERADJUSTMENT (EMPLOYER ASC)
/	
    CREATE INDEX "ERADJ_FK_PRUN" ON EMPLOYERADJUSTMENT (PAYROLLRUN ASC)
/	



	CREATE TABLE EMPLOYER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		LEGALNAME VARCHAR2(100) NULL,
		DBANAME VARCHAR2(100) NULL,
		LEGALSTRUCTURE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		INDUSTRYTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		LEGALPHONE_ID VARCHAR2(100) NULL,
		LEGALPHONE_DEVICETYPE VARCHAR2(100) NULL,
		LEGALPHONE_COUNTRYCODE VARCHAR2(100) NULL,
		LEGALPHONE_AREACODE VARCHAR2(100) NULL,
		LEGALPHONE_EXCHANGECODE VARCHAR2(100) NULL,
		LEGALPHONE_EXTENSION VARCHAR2(100) NULL,
		LEGALPHONE_FREEFORMNUMBER VARCHAR2(100) NULL,
		LEGALPHONE_PIN VARCHAR2(100) NULL,
		LEGALPHONE_DATELASTVERIFIED TIMESTAMP NULL,
		LEGALPHONE_DEFAULTT CHAR(1) NULL,
		LEGALPHONE_TAG VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINEONE VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINETWO VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINETHREE VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		LEGALADDRESS_ADDRESSTYPE VARCHAR2(100) NULL,
		LEGALADDRESS_POSTTOWN VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTY VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTYCODE VARCHAR2(100) NULL,
		LEGALADDRESS_STATEPROV VARCHAR2(100) NULL,
		LEGALADDRESS_POSTALCODE VARCHAR2(100) NULL,
		LEGALADDRESS_POSTALCODESUFFIX VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTRYNAME VARCHAR2(100) NULL,
		LEGALADDRESS_COUNTRYCODE VARCHAR2(100) NULL,
		LEGALADDRESS_GEOCODE VARCHAR2(100) NULL,
		LEGALADDRESS_LABEL VARCHAR2(100) NULL,
		LEGALADDRESS_CREATIONSOURCE VARCHAR2(100) NULL,
		LEGALADDRESS_ISSTANDARDIZED CHAR(1) NULL,
		LEGALADDRESS_ISSTREETADDRESS CHAR(1) NULL,
		LEGALADDRESS_DONOTSTAND CHAR(1) NULL,
		BA_ADDRESSLINEONE VARCHAR2(100) NULL,
		BA_ADDRESSLINETWO VARCHAR2(100) NULL,
		BA_ADDRESSLINETHREE VARCHAR2(100) NULL,
		BA_ADDRESSLINEFOUR VARCHAR2(100) NULL,
		BA_ADDRESSLINEFIVE VARCHAR2(100) NULL,
		BA_ADDRESSTYPE VARCHAR2(100) NULL,
		BA_POSTTOWN VARCHAR2(100) NULL,
		BA_COUNTY VARCHAR2(100) NULL,
		BA_COUNTYCODE VARCHAR2(100) NULL,
		BA_STATEPROV VARCHAR2(100) NULL,
		BA_POSTALCODE VARCHAR2(100) NULL,
		BA_POSTALCODESUFFIX VARCHAR2(100) NULL,
		BA_COUNTRYNAME VARCHAR2(100) NULL,
		BA_COUNTRYCODE VARCHAR2(100) NULL,
		BA_GEOCODE VARCHAR2(100) NULL,
		BA_LABEL VARCHAR2(100) NULL,
		BA_CREATIONSOURCE VARCHAR2(100) NULL,
		BA_ISSTANDARDIZED CHAR(1) NULL,
		BA_ISSTREETADDRESS CHAR(1) NULL,
		BA_DONOTSTAND CHAR(1) NULL,
		LEGALANDBUSADDRESSSAME CHAR(1)  DEFAULT '0' NOT NULL,
		WEBADDRESS_ID VARCHAR2(100) NULL,
		WEBADDRESS_URI VARCHAR2(100) NULL,
		WEBADDRESS_DATELASTVERIFIED TIMESTAMP NULL,
		WEBADDRESS_DEFAULTT CHAR(1) NULL,
		WEBADDRESS_TAG VARCHAR2(100) NULL,
		FIRSTPAYROLLDATE TIMESTAMP NULL,
		NONPROFIT CHAR(1) NULL,
		COMPANYNAME VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL
,UNIQUE(REALMOWNER)	)
/
    
    CREATE INDEX "EMPLOYER_RX" ON EMPLOYER (REALM_ID ASC)
/	



	CREATE TABLE BENEFITSVC (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NULL,
		SERVICEID VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		BENEFITSPROVIDER NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "BENEFITSVC_RX" ON BENEFITSVC (REALM_ID ASC)
/	
    CREATE INDEX "BENEFITSVC_FK_BENEFITSPROVIDER" ON BENEFITSVC (BENEFITSPROVIDER ASC)
/	



	CREATE TABLE EMPLOYERID (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		VALUE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		AGENCYIDTYPE NUMBER(20,0) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		EMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "EMPLOYERID_RX" ON EMPLOYERID (REALM_ID ASC)
/	
    CREATE INDEX "EMPLOYERID_FK_REALMOWNER" ON EMPLOYERID (REALMOWNER ASC)
/	
    CREATE INDEX "EMPLOYERID_FK_AGENCYIDTYPE" ON EMPLOYERID (AGENCYIDTYPE ASC)
/	
    CREATE INDEX "EMPLOYERID_FK_EMPLOYER" ON EMPLOYERID (EMPLOYER ASC)
/	



	CREATE TABLE AGENCY (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		NAME VARCHAR2(100) NOT NULL,
		SHORTNAME VARCHAR2(100) NULL,
		AGENCYKEY VARCHAR2(100)  DEFAULT 'NOTSET' NOT NULL,
		MAPPINGKEY VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		JURISDICTION NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "AGENCY_RX" ON AGENCY (REALM_ID ASC)
/	
    CREATE INDEX "JURCONAGENCY_FK_JUR" ON AGENCY (JURISDICTION ASC)
/	



	CREATE TABLE WORKERCOMPLIANCEDOCDTL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		LAWID_VALUE VARCHAR2(100) NULL,
		DOCID VARCHAR2(100) NULL,
		DERIVED CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		REALMOWNER NUMBER(20,0) NULL,
		WORKER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "WORKERCOMPLIANCEDOCDTL_RX" ON WORKERCOMPLIANCEDOCDTL (REALM_ID ASC)
/	
    CREATE INDEX "WKRCOMPLDOCDTL_FK_ER" ON WORKERCOMPLIANCEDOCDTL (REALMOWNER ASC)
/	
    CREATE INDEX "WKRWKRCOMPDOCDTL_FK_WKR" ON WORKERCOMPLIANCEDOCDTL (WORKER ASC)
/	



	CREATE TABLE AGENCYIDTYPE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		AGENCYKEY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		IDTYPEKEY VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		AGENCYIDVALIDATIONPATTERN VARCHAR2(100) NULL,
		GHOSTTEXT VARCHAR2(100) NULL,
		MANDATORY CHAR(1) NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "AGENCYIDTYPE_RX" ON AGENCYIDTYPE (REALM_ID ASC)
/	



	CREATE TABLE CONTACTPERSONWORKLOCATION (
		PRIMARY KEY(CONTACTPERSON, WORKLOCATION),
		CONTACTPERSON NUMBER(20,0) NOT NULL,
		WORKLOCATION NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "CONWLOC_FK_CON" ON CONTACTPERSONWORKLOCATION (CONTACTPERSON ASC)
/	
    CREATE INDEX "CONWLOC_FK_WLOC" ON CONTACTPERSONWORKLOCATION (WORKLOCATION ASC)
/	



	CREATE TABLE WORKLOCATIONBENEFITSERVICE (
		PRIMARY KEY(WORKLOCATION, BENEFITSERVICE),
		WORKLOCATION NUMBER(20,0) NOT NULL,
		BENEFITSERVICE NUMBER(20,0) NOT NULL	)
/
    
    CREATE INDEX "WLOCBS_FK_WLOC" ON WORKLOCATIONBENEFITSERVICE (WORKLOCATION ASC)
/	
    CREATE INDEX "WLOCBS_FK_BS" ON WORKLOCATIONBENEFITSERVICE (BENEFITSERVICE ASC)
/	


    

    
    
    -- Functions
    
    
    
ALTER TABLE HISTPAYCHECKLINEITEM 
	ADD CONSTRAINT HPCHKLITM_FK_PITMDTL 
	FOREIGN KEY (PAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE HISTPAYCHECKLINEITEM 
	ADD CONSTRAINT HPCHK_FK_HPCHKLITM 
	FOREIGN KEY (HISTPAYCHECK) 
	REFERENCES HISTPAYCHECK (ID)
/

ALTER TABLE HISTPAYCHECKLINEITEM 
	ADD CONSTRAINT HPCHKLITM_FK_PITM 
	FOREIGN KEY (PAYROLLITEM) 
	REFERENCES PAYROLLITEM (ID)
/

ALTER TABLE HISTPAYCHECKLINEITEM 
	ADD CONSTRAINT HSTPCHKLITM_FK_ER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "HISTPAYCHECKLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "HISTPAYCHECKLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYROLLITEM 
	ADD CONSTRAINT PAYROLLITEM_FK_LAW 
	FOREIGN KEY (LAW) 
	REFERENCES LAW (ID)
/

ALTER TABLE PAYROLLITEM 
	ADD CONSTRAINT PAYROLLITEM_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYROLLITEM 
	ADD CONSTRAINT PAYROLLITEM_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYROLLITEM 
	ADD CONSTRAINT PAYROLLITEM_FK_BENEFITSERVICE 
	FOREIGN KEY (BENEFITSERVICE) 
	REFERENCES BENEFITSVC (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYROLLITEM_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE HISTPAYCHECK 
	ADD CONSTRAINT HISTPAYCHECK_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

ALTER TABLE HISTPAYCHECK 
	ADD CONSTRAINT HISTPAYCHECK_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE HISTPAYCHECK 
	ADD CONSTRAINT HISTPAYCHECK_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "HISTPAYCHECK_VT" 
    BEFORE INSERT OR UPDATE ON "HISTPAYCHECK" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYROLLSCHEDULE 
	ADD CONSTRAINT PAYROLLSCHEDULE_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYROLLSCHEDULE 
	ADD CONSTRAINT PAYROLLSCHEDULE_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYROLLSCHEDULE_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLSCHEDULE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE CONTACTPERSON 
	ADD CONSTRAINT CONTACTPERSON_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE CONTACTPERSON 
	ADD CONSTRAINT CONTACTPERSON_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "CONTACTPERSON_VT" 
    BEFORE INSERT OR UPDATE ON "CONTACTPERSON" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYROLLITEMDTL 
	ADD CONSTRAINT PAYROLLITEMDTL_FK_PAYROLLITEM 
	FOREIGN KEY (PAYROLLITEM) 
	REFERENCES PAYROLLITEM (ID)
/

ALTER TABLE PAYROLLITEMDTL 
	ADD CONSTRAINT PITMDTL_FK_PITMDTL 
	FOREIGN KEY (LINKEDPAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE PAYROLLITEMDTL 
	ADD CONSTRAINT PAYROLLITEMDTL_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYROLLITEMDTL 
	ADD CONSTRAINT PAYROLLITEMDTL_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYROLLITEMDTL_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLITEMDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "DISABILITYINSDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "DISABILITYINSDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKERADJLINEITEM 
	ADD CONSTRAINT HPLITMPITMDTL_FK_PITMDTL 
	FOREIGN KEY (PAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE WORKERADJLINEITEM 
	ADD CONSTRAINT HSTPCHKLITEM_FK_HSTPCHK 
	FOREIGN KEY (WORKERADJUSTMENT) 
	REFERENCES WORKERADJUSTMENT (ID)
/

ALTER TABLE WORKERADJLINEITEM 
	ADD CONSTRAINT WKRADJLITEM_FK_ER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKERADJLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "WORKERADJLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE BANKACCOUNT 
	ADD CONSTRAINT BANKACCOUNT_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE BANKACCOUNT 
	ADD CONSTRAINT BANKACCOUNT_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE BANKACCOUNT 
	ADD CONSTRAINT BANKACCOUNT_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "BANKACCOUNT_VT" 
    BEFORE INSERT OR UPDATE ON "BANKACCOUNT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERCOMPLIANCEDOCDTL 
	ADD CONSTRAINT ERCOMPLDOCDTL_FK_ER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE EMPLOYERCOMPLIANCEDOCDTL 
	ADD CONSTRAINT ERCOMPLDOCDTL_FK_ER1 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERCOMPLIANCEDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERCOMPLIANCEDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYMENTPERIOD 
	ADD CONSTRAINT EMPLOYMENTPERIOD_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE EMPLOYMENTPERIOD 
	ADD CONSTRAINT EMPLOYMENTPERIOD_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYMENTPERIOD_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYMENTPERIOD" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERADJLINEITEM 
	ADD CONSTRAINT ERADJLITM_FK_PITEM 
	FOREIGN KEY (PAYROLLITEM) 
	REFERENCES PAYROLLITEM (ID)
/

ALTER TABLE EMPLOYERADJLINEITEM 
	ADD CONSTRAINT LIABADJASSOC_FK_LIABADJ 
	FOREIGN KEY (EMPLOYERADJUSTMENT) 
	REFERENCES EMPLOYERADJUSTMENT (ID)
/

ALTER TABLE EMPLOYERADJLINEITEM 
	ADD CONSTRAINT ERADJLITM_FK_ER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERADJLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERADJLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "JURISDICTION_VT" 
    BEFORE INSERT OR UPDATE ON "JURISDICTION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE COMPLIANCEDOC 
	ADD CONSTRAINT COMPLIANCEDOC_FK_LAW 
	FOREIGN KEY (LAW) 
	REFERENCES LAW (ID)
/

    
    CREATE or REPLACE TRIGGER "COMPLIANCEDOC_VT" 
    BEFORE INSERT OR UPDATE ON "COMPLIANCEDOC" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYMENT 
	ADD CONSTRAINT PAYMENT_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYMENT 
	ADD CONSTRAINT PAYMENT_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYMENT_VT" 
    BEFORE INSERT OR UPDATE ON "PAYMENT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "INDUSTRYTYPE_VT" 
    BEFORE INSERT OR UPDATE ON "INDUSTRYTYPE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "BENEFITPROVIDER_VT" 
    BEFORE INSERT OR UPDATE ON "BENEFITPROVIDER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYCHECKLINEITEM 
	ADD CONSTRAINT PCLI_PID_FK_CONSTRAINT 
	FOREIGN KEY (SOURCEPAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE PAYCHECKLINEITEM 
	ADD CONSTRAINT PAYCHECKLINEITEM_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYCHECKLINEITEM 
	ADD CONSTRAINT PCHKPCHKLITEM_FK_PCHK 
	FOREIGN KEY (PAYCHECK) 
	REFERENCES PAYCHECK (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYCHECKLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "PAYCHECKLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "LEGALSTRUCTURE_VT" 
    BEFORE INSERT OR UPDATE ON "LEGALSTRUCTURE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYMENTLINEITEMSPLIT 
	ADD CONSTRAINT PAYMNTLITMSPLT_FK_PAYITM 
	FOREIGN KEY (PAYROLLITEM) 
	REFERENCES PAYROLLITEM (ID)
/

ALTER TABLE PAYMENTLINEITEMSPLIT 
	ADD CONSTRAINT PMTLITMSPLT_FK_ER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYMENTLINEITEMSPLIT 
	ADD CONSTRAINT PAYMNTLITM_FK_PAYMNTLITMSPLT 
	FOREIGN KEY (PAYMENTLINEITEM) 
	REFERENCES PAYMENTLINEITEM (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYMENTLINEITEMSPLIT_VT" 
    BEFORE INSERT OR UPDATE ON "PAYMENTLINEITEMSPLIT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYCHECK 
	ADD CONSTRAINT PAYCHECK_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYCHECK 
	ADD CONSTRAINT PAYCHECK_FK_PAYROLLRUN 
	FOREIGN KEY (PAYROLLRUN) 
	REFERENCES PAYROLLRUN (ID)
/

ALTER TABLE PAYCHECK 
	ADD CONSTRAINT PAYCHECK_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYCHECK_VT" 
    BEFORE INSERT OR UPDATE ON "PAYCHECK" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE LAW 
	ADD CONSTRAINT JURCONLAW_FK_JUR 
	FOREIGN KEY (JURISDICTION) 
	REFERENCES JURISDICTION (ID)
/

ALTER TABLE LAW 
	ADD CONSTRAINT LAW_FK_AGENCY 
	FOREIGN KEY (AGENCY) 
	REFERENCES AGENCY (ID)
/

    
    CREATE or REPLACE TRIGGER "LAW_VT" 
    BEFORE INSERT OR UPDATE ON "LAW" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE WORKER 
	ADD CONSTRAINT WORKER_FK_PAYROLLSCHEDULE 
	FOREIGN KEY (PAYROLLSCHEDULE) 
	REFERENCES PAYROLLSCHEDULE (ID)
/

ALTER TABLE WORKER 
	ADD CONSTRAINT WORKER_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE WORKER 
	ADD CONSTRAINT WLOCWRKR_FK_WLOC 
	FOREIGN KEY (WORKLOCATION) 
	REFERENCES WORKLOCATION (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKER_VT" 
    BEFORE INSERT OR UPDATE ON "WORKER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYROLLRUN 
	ADD CONSTRAINT PAYROLLRUN_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYROLLRUN_VT" 
    BEFORE INSERT OR UPDATE ON "PAYROLLRUN" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKERADJUSTMENT 
	ADD CONSTRAINT WORKERWKRLIABADJ_FK_WORKER 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

ALTER TABLE WORKERADJUSTMENT 
	ADD CONSTRAINT WORKERADJUSTMENT_FK_PAYROLLRUN 
	FOREIGN KEY (PAYROLLRUN) 
	REFERENCES PAYROLLRUN (ID)
/

ALTER TABLE WORKERADJUSTMENT 
	ADD CONSTRAINT WORKERADJUSTMENT_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKERADJUSTMENT_VT" 
    BEFORE INSERT OR UPDATE ON "WORKERADJUSTMENT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "UNEMPLOYMENTINSDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "UNEMPLOYMENTINSDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERCONTACTPERSON 
	ADD CONSTRAINT ERCONTACTPERSON_FK_ER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERCONTACTPERSON_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERCONTACTPERSON" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE TASK 
	ADD CONSTRAINT TASK_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "TASK_VT" 
    BEFORE INSERT OR UPDATE ON "TASK" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKLOCATION 
	ADD CONSTRAINT WORKLOCATION_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE WORKLOCATION 
	ADD CONSTRAINT WORKLOCATION_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKLOCATION_VT" 
    BEFORE INSERT OR UPDATE ON "WORKLOCATION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PTDDATUM 
	ADD CONSTRAINT PTDDATUMHPLITEM_FK_HPLITEM 
	FOREIGN KEY (WORKERADJLINEITEM) 
	REFERENCES WORKERADJLINEITEM (ID)
/

ALTER TABLE PTDDATUM 
	ADD CONSTRAINT PTDDATUM_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PTDDATUM 
	ADD CONSTRAINT PAYITMDTLPTDDATUM_FK_PAYITMDTL 
	FOREIGN KEY (PAYROLLITEMDTL) 
	REFERENCES PAYROLLITEMDTL (ID)
/

ALTER TABLE PTDDATUM 
	ADD CONSTRAINT PCHKLITEMPTD_FK_PCHKLITEM 
	FOREIGN KEY (PAYCHECKLINEITEM) 
	REFERENCES PAYCHECKLINEITEM (ID)
/

ALTER TABLE PTDDATUM 
	ADD CONSTRAINT HPCHKLITMPTD_FK_HPCHKLITM 
	FOREIGN KEY (HISTPAYCHECKLINEITEM) 
	REFERENCES HISTPAYCHECKLINEITEM (ID)
/

    
    CREATE or REPLACE TRIGGER "PTDDATUM_VT" 
    BEFORE INSERT OR UPDATE ON "PTDDATUM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PAYMENTLINEITEM 
	ADD CONSTRAINT PAYMENTLINEITEM_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE PAYMENTLINEITEM 
	ADD CONSTRAINT PAYMENTLINEITEM_FK_PAYMENT 
	FOREIGN KEY (PAYMENT) 
	REFERENCES PAYMENT (ID)
/

    
    CREATE or REPLACE TRIGGER "PAYMENTLINEITEM_VT" 
    BEFORE INSERT OR UPDATE ON "PAYMENTLINEITEM" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERADJUSTMENT 
	ADD CONSTRAINT ERADJ_FK_ER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE EMPLOYERADJUSTMENT 
	ADD CONSTRAINT EMPLOYERADJUSTMENT_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE EMPLOYERADJUSTMENT 
	ADD CONSTRAINT ERADJ_FK_PRUN 
	FOREIGN KEY (PAYROLLRUN) 
	REFERENCES PAYROLLRUN (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERADJUSTMENT_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERADJUSTMENT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE EMPLOYER 
	ADD CONSTRAINT EMPLOYER_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYER_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE BENEFITSVC 
	ADD CONSTRAINT BENEFITSVC_FK_BENEFITSPROVIDER 
	FOREIGN KEY (BENEFITSPROVIDER) 
	REFERENCES BENEFITPROVIDER (ID)
/

    
    CREATE or REPLACE TRIGGER "BENEFITSVC_VT" 
    BEFORE INSERT OR UPDATE ON "BENEFITSVC" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPLOYERID 
	ADD CONSTRAINT EMPLOYERID_FK_REALMOWNER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE EMPLOYERID 
	ADD CONSTRAINT EMPLOYERID_FK_AGENCYIDTYPE 
	FOREIGN KEY (AGENCYIDTYPE) 
	REFERENCES AGENCYIDTYPE (ID)
/

ALTER TABLE EMPLOYERID 
	ADD CONSTRAINT EMPLOYERID_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPLOYERID_VT" 
    BEFORE INSERT OR UPDATE ON "EMPLOYERID" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE AGENCY 
	ADD CONSTRAINT JURCONAGENCY_FK_JUR 
	FOREIGN KEY (JURISDICTION) 
	REFERENCES JURISDICTION (ID)
/

    
    CREATE or REPLACE TRIGGER "AGENCY_VT" 
    BEFORE INSERT OR UPDATE ON "AGENCY" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE WORKERCOMPLIANCEDOCDTL 
	ADD CONSTRAINT WKRCOMPLDOCDTL_FK_ER 
	FOREIGN KEY (REALMOWNER) 
	REFERENCES EMPLOYER (ID)
/

ALTER TABLE WORKERCOMPLIANCEDOCDTL 
	ADD CONSTRAINT WKRWKRCOMPDOCDTL_FK_WKR 
	FOREIGN KEY (WORKER) 
	REFERENCES WORKER (ID)
/

    
    CREATE or REPLACE TRIGGER "WORKERCOMPLIANCEDOCDTL_VT" 
    BEFORE INSERT OR UPDATE ON "WORKERCOMPLIANCEDOCDTL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "AGENCYIDTYPE_VT" 
    BEFORE INSERT OR UPDATE ON "AGENCYIDTYPE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE CONTACTPERSONWORKLOCATION 
	ADD CONSTRAINT CONWLOC_FK_CON 
	FOREIGN KEY (CONTACTPERSON) 
	REFERENCES CONTACTPERSON (ID)
/

ALTER TABLE CONTACTPERSONWORKLOCATION 
	ADD CONSTRAINT CONWLOC_FK_WLOC 
	FOREIGN KEY (WORKLOCATION) 
	REFERENCES WORKLOCATION (ID)
/

    

    
    
ALTER TABLE WORKLOCATIONBENEFITSERVICE 
	ADD CONSTRAINT WLOCBS_FK_WLOC 
	FOREIGN KEY (WORKLOCATION) 
	REFERENCES WORKLOCATION (ID)
/

ALTER TABLE WORKLOCATIONBENEFITSERVICE 
	ADD CONSTRAINT WLOCBS_FK_BS 
	FOREIGN KEY (BENEFITSERVICE) 
	REFERENCES BENEFITSVC (ID)
/

    

    
    

    -- Synonyms
    
    -- Grants
    
	GRANT SELECT, INSERT, UPDATE, DELETE ON HISTPAYCHECKLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON HISTPAYCHECK TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLSCHEDULE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON CONTACTPERSON TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLITEMDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON DISABILITYINSDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKERADJLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BANKACCOUNT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERCOMPLIANCEDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYMENTPERIOD TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERADJLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON JURISDICTION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON COMPLIANCEDOC TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYMENT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON INDUSTRYTYPE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BENEFITPROVIDER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYCHECKLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON LEGALSTRUCTURE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYMENTLINEITEMSPLIT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYCHECK TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON LAW TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYROLLRUN TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKERADJUSTMENT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON UNEMPLOYMENTINSDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERCONTACTPERSON TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TASK TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKLOCATION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTDDATUM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PAYMENTLINEITEM TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERADJUSTMENT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BENEFITSVC TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPLOYERID TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON AGENCY TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKERCOMPLIANCEDOCDTL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON AGENCYIDTYPE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON CONTACTPERSONWORKLOCATION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON WORKLOCATIONBENEFITSERVICE TO &&2
	/


	GRANT SELECT ON HIBERNATE_SEQUENCE TO &&2
	/

  
    
	--
    -- Table permissions for the VPD internal-to-external mapping table
    --
    GRANT SELECT,INSERT,UPDATE ON SBCORE_VPD_TABLE TO &&2
    /
    --
    -- Permission for VPD SEQ
    --
    GRANT SELECT ON SBCORE_VPD_SEQ TO &&2
    /
        
 

    
DECLARE
  table_exists PLS_INTEGER;
  row_exists PLS_INTEGER;

  INSERT_CMD VARCHAR2(255);
  ROWCHECK_CMD VARCHAR2(255);
  UPDATE_CMD VARCHAR2(255);

BEGIN
  SELECT COUNT(*) INTO table_exists
  FROM "USER_TABLES"
  WHERE TABLE_NAME = 'PROJECT_VERSIONS_TABLE';
  IF table_exists = 1 THEN 
  
    SELECT 'SELECT COUNT(*)  FROM PROJECT_VERSIONS_TABLE WHERE PROJECT_ID=''_c4GAoJEkEd2zF5tDuPZkGw'''   
    INTO ROWCHECK_CMD
    FROM DUAL;
    EXECUTE IMMEDIATE ROWCHECK_CMD INTO row_exists;   
   
    IF row_exists = 1 THEN    
        SELECT 'UPDATE PROJECT_VERSIONS_TABLE SET MODEL_VERSION='''',SCHEMA_VERSION=''1.0.28'',TIMESTAMP=''2009-07-06 10:57:16.595'' WHERE PROJECT_ID=''_c4GAoJEkEd2zF5tDuPZkGw'''
        INTO UPDATE_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE UPDATE_CMD;
    ELSE
        SELECT 'INSERT INTO PROJECT_VERSIONS_TABLE (PROJECT_NAME,PROJECT_ID,MODEL_VERSION,SCHEMA_VERSION,TIMESTAMP) VALUES (''sb-payroll-entity-intl'',''_c4GAoJEkEd2zF5tDuPZkGw'','''',''1.0.28'',''2009-07-06 10:57:16.595'')' 
        INTO INSERT_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE INSERT_CMD;
    END IF;   
  END IF;
END;
/

    