package com.intuit.sb.payroll.entity.utils;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.entity.model.PersonName;
import com.intuit.sb.payroll.entity.utils.PersonNameUtils;

/**
 * Tests the {@link PersonNameUtils} class.
 * 
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 *
 */
public class PersonNameUtilsTest {
	
	@Test
	public void testGetFullNameHappyPath() throws Exception {
		PersonName name = new PersonName();
		name.setFirstName("First");
		name.setMiddleName("Middle");
		name.setLastName("Last");
		String fullName = PersonNameUtils.getFullName(name);
		AssertJUnit.assertEquals("First Middle Last", fullName);
	}
	
	@Test
	public void testGetFullNameNullFirst() throws Exception {
		PersonName name = new PersonName();
		name.setFirstName(null);
		name.setMiddleName("Middle");
		name.setLastName("Last");
		String fullName = PersonNameUtils.getFullName(name);
		AssertJUnit.assertEquals("Middle Last", fullName);
	}
	
	@Test
	public void testGetFullNameNullMiddle() throws Exception {
		PersonName name = new PersonName();
		name.setFirstName("First");
		name.setMiddleName(null);
		name.setLastName("Last");
		String fullName = PersonNameUtils.getFullName(name);
		AssertJUnit.assertEquals("First Last", fullName);
	}
	
	@Test
	public void testGetFullNameNullLast() throws Exception {
		PersonName name = new PersonName();
		name.setFirstName("First");
		name.setMiddleName("Middle");
		name.setLastName(null);
		String fullName = PersonNameUtils.getFullName(name);
		AssertJUnit.assertEquals("First Middle", fullName);
	}
	
	@Test
	public void testGetFullNameEmptyFirst() throws Exception {
		PersonName name = new PersonName();
		name.setFirstName("");
		name.setMiddleName("Middle");
		name.setLastName("Last");
		String fullName = PersonNameUtils.getFullName(name);
		AssertJUnit.assertEquals("Middle Last", fullName);
	}
	
	@Test
	public void testGetFullNameEmptyMiddle() throws Exception {
		PersonName name = new PersonName();
		name.setFirstName("First");
		name.setMiddleName("");
		name.setLastName("Last");
		String fullName = PersonNameUtils.getFullName(name);
		AssertJUnit.assertEquals("First Last", fullName);
	}
	
	@Test
	public void testGetFullNameEmptyLast() throws Exception {
		PersonName name = new PersonName();
		name.setFirstName("First");
		name.setMiddleName("Middle");
		name.setLastName("");
		String fullName = PersonNameUtils.getFullName(name);
		AssertJUnit.assertEquals("First Middle", fullName);
	}
}
