package com.intuit.sb.payroll.rules;

import com.intuit.sb.payroll.rules.impl.drools.DroolsJsr94RulesFacade;


public class RulesEngineFactory 
{
	private static RulesEngineFactory instance = null;
	
	static
	{
		instance = new RulesEngineFactory();
	}
	
	private RulesEngineFactory()
	{
	}
	
	public static RulesEngineFactory getInstance()
	{
		return instance;
	}
	
	public DroolsJsr94RulesFacade getRulesProvider() throws RulesException
	{
		DroolsJsr94RulesFacade droolsJsr94RulesFacade;
		try {
			droolsJsr94RulesFacade = new DroolsJsr94RulesFacade();
		} catch (Exception e) {
			throw new RulesException(e);
		}
		return droolsJsr94RulesFacade;
	}
}
