package com.intuit.sb.payroll.rules.impl.drools;

import java.net.URL;

import com.intuit.sb.payroll.rules.RulesException;

public class DroolsJsr94RulesFacade
{
	private DroolsJsr94Runtime drlsRuntime;
	
	public DroolsJsr94RulesFacade() throws Exception
	{
		drlsRuntime = DroolsJsr94Runtime.getInstance();
	}

	public void initializeRulesRuntime() throws Exception
	{
		drlsRuntime.Initialize();
	}
	
	//returns a statelessRuleSession object associated with the rulesExecutionSet represented by the uri
    public DroolsStatelessSession getStatelessRuleSession(final String uri) throws Exception
    {
    	if(!drlsRuntime.isInitialised())
    	{
    		throw new Exception(" The rules engine is not initialized properly.");
    	}
    	
    	return new DroolsStatelessSession(drlsRuntime, uri);
    }
	public void registerRulesets(final URL configUrl) throws RulesException
	{
		try
		{
			drlsRuntime.registerRulesets(configUrl);
		}
		catch(Exception e)
		{
			throw new RulesException("Unable to register ruleset [" +configUrl + "]: " + DroolsHelper.throwableMessageChain(e));
		}
	}
	public void unRegisterRulesets(final URL configUrl) throws RulesException
	{
		try
		{
			drlsRuntime.unRegisterRulesets(configUrl);
		}
		catch(Exception e)
		{
			throw new RulesException("Unable to unregister ruleset [" +configUrl + "]: " + DroolsHelper.throwableMessageChain(e));
		}
	}
}