package com.intuit.sb.payroll.capability.agency;

import java.util.List;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.model.DateRange;

/**
 * Component that exposes data related to Agencies.
 * 
 * $Author$ 
 * $Revision$
 * $DateTime$
 *
 */
@Local
public interface AgencyComponent {

	public static final String JNDI_NAME =  "AgencyComponent/local";
	
	/**
	 * Returns a list of Federal Holidays for the given period.
	 * 
	 * @param period
	 * @return the list of {@link Holiday}s if any.
	 */
	public List<Holiday> getHolidaysForPeriod(DateRange period);
}
