package com.intuit.sb.payroll.capability.benefits.impl;

import java.util.List;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.validation.AbstractEntityDataValidator;
import com.intuit.sb.payroll.common.validation.PayrollParamValidator;
import com.intuit.sb.payroll.entity.model.HealthBenefitDtl;

/**
 * Validates HealthBenefitDtls.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
@SuppressWarnings("nls")
public class HealthBenefitValidator extends AbstractEntityDataValidator<HealthBenefitDtl> {

	private static HealthBenefitValidator sInstance = new HealthBenefitValidator();
	
	private HealthBenefitValidator() {}
	
	public static HealthBenefitValidator getInstance() {
		return sInstance;
	}
	
	@Override
	public void validateEntity(HealthBenefitDtl healthBenefitDtl) throws ValidationException {
		PayrollParamValidator.checkIsNotNull(healthBenefitDtl, "healthBenefitDtl");
    	PayrollParamValidator.checkIsNotNull(healthBenefitDtl.getBenefitType(), "healthBenefitType");
	}

	@Override
	public void validateEntityCollection(List<HealthBenefitDtl> entityCollection) throws ValidationException {
		PayrollParamValidator.checkIsNotNull(entityCollection, "entityCollection");
		
    	for (HealthBenefitDtl newItem : entityCollection)	{
        	validateEntity(newItem);
    	}
	}
}
