package com.intuit.sb.payroll.capability.compensation.impl;

import com.intuit.sb.payroll.entity.model.Compensation;
import com.intuit.sb.payroll.entity.model.CompensationDtl;
import com.intuit.sb.payroll.entity.model.Datum;

/**
 * Creates CompensationDtl instances based on the type of Compensation Payroll Item.
 * 
 * $Author$ 
 * $Revision$
 * $DateTime$
 *
 */
public class CompensationFactory {

	/**
	 * Creates a {@link CompensationDtl} based on the Compensation Payroll Item.
	 * @param compensation
	 * @return
	 */
	static CompensationDtl createCompensationDtlFromCompensation(Compensation compensation) {
		//TODO this will vary, so far this is good enough but the variation point is in
		CompensationDtl compensationDtl = new CompensationDtl();
		compensationDtl.setPayrollItem(compensation);
		compensationDtl.setCompensationType(compensation.getCompensationType());
		compensationDtl.setName(compensation.getName());
		compensationDtl.setDescription(compensation.getDescription());
		Datum rateDatum = new Datum();
		compensationDtl.setRate(rateDatum);
		Datum quantityDatum = new Datum();
		quantityDatum.setValue1AsQuantity(0.0);
		compensationDtl.setQuantity(quantityDatum);
		return compensationDtl;
	}

}
