/**
 * Copyright: 2007, Intuit, Inc. All rights reserved.
 *
 */
package com.intuit.sb.payroll.capability.config;

public interface GeminiConfigurationService {

	
	 /**
     *  JNDI name of this class for lookup
     *  Should be same as "@Service(objectName = '')... value
     *  used for annotation of this class
     */
	static public final String JNDI_NAME = "geminiJMX:service=GeminiConfigurationMBean";
	
    /**
     * Property to enable and disable the Tax Payment Service
     * @param isTaxPaymentServiceEnabled
     */
    public void setTaxPaymentServiceEnabled(boolean isTaxPaymentServiceEnabled);

	public boolean isTaxPaymentServiceEnabled();
	
	
	/**
	 * Get the URL for the Tax Payment Service
	 * @return
	 */
	public String getTaxPaymentServiceHost();
	   
	public void setTaxPaymentServiceHost(String url);
    
    // Life cycle method
    public void create() throws Exception;

    public void destroy() throws Exception;
}