package com.intuit.sb.payroll.capability.employer;

import com.intuit.payroll.types.enumtype.PayrollState;

/**
 * Enum providing names for Jurisdictions
 * Every time a new Jurisdiction area is added, an entry should be made here.
 */
public enum JurisdictionType  {
	
	UNITED_STATES("United States", null), 
	CALIFORNIA("California", PayrollState.CA), 
	TEXAS("Texas", PayrollState.TX),
	SAN_FRANCISCO("San Francisco", null);
	
	private String name;
	
	private PayrollState payrollState;
	
	/**
	 * Private constructor to prevent external instantiation.
	 * @param name - String literal representation for this JurisdictionType object
	 */
	private JurisdictionType(String name, PayrollState payrollState) {
		this.setName(name);
		this.setPayrollState(payrollState);
	}

	/**
	 * Setting only via constructor allowed
	 * @param name
	 */
	private void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public PayrollState getPayrollState() {
		return payrollState;
	}

	private void setPayrollState(PayrollState payrollState) {
		this.payrollState = payrollState;
	}

}
