package com.intuit.sb.payroll.capability.employer.impl;

import java.util.List;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.capability.employer.impl.evaluator.EmployerEvaluator;
import com.intuit.sb.payroll.common.validation.AbstractEntityDataValidator;
import com.intuit.sb.payroll.entity.model.Employer;

/**
 * Validates fields in the Employer entity that have values. Fields with no
 * values are ignored.
 * 
 * This class does not ensure data integrity or completeness.
 * 
 * @see EmployerEvaluator 
 * $Author$ 
 * $Revision$ 
 * $DateTime$
 * 
 */
@SuppressWarnings("nls")
public class EmployerValidator extends AbstractEntityDataValidator<Employer> {
	private static EmployerValidator sInstance = new EmployerValidator();

	private EmployerValidator() {
	}

	public static EmployerValidator getInstance() {
		return sInstance;
	}

	@Override
	public void validateEntityCollection(List<Employer> employerCollection) throws ValidationException {
		for (Employer employer : employerCollection) {
			validateEntityImpl(employer);
		}
	}

	@Override
	public void validateEntity(Employer employer) throws ValidationException {
		validateEntityImpl(employer);
	}

	public void validateEntityImpl(Employer employer) throws ValidationException {
		//String busName = employer.getDbaName();
		//TODO fix this post ALPHA - [rj] - we can have empty string, but not null
		//PayrollParamValidator.checkIsNotNullOrBlankString(busName, "DBA Name");
		//PayrollParamValidator.checkIsNotNull(busName, "DBA Name");
	}
}
