package com.intuit.sb.payroll.capability.employer.impl.evaluator;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.capability.employer.impl.EmployerSetupRules;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.common.RequiredData;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;


public class EmployerEvaluator extends AbstractPayrollEntityDataEvaluator<PTSEmployer>{

private static Map<RequiredData, PayrollEntityDataEvaluator<PTSEmployer>> registerMap = null;
    
    static {
        registerMap = new HashMap<RequiredData, PayrollEntityDataEvaluator<PTSEmployer>>();
        
        registerMap.put(EmployerSetupRules.employerEIN, EmployerFEINEvaluator.getInstance());
        registerMap.put(EmployerSetupRules.employerLegalName, EmployerLegalNameEvaluator.getInstance());
        registerMap.put(EmployerSetupRules.employerLegalAddress, EmployerLegalAddressEvaluator.getInstance());
        registerMap.put(EmployerSetupRules.employerPrimaryContact, EmployerPrimaryContactEvaluator.getInstance());
        
    }
	
	@Override
	public PayrollEntityDataState evaluateState(PTSEmployer entity)
			throws ValidationException {
		return PayrollEntityDataState.Complete;
	}

	public static List<RequiredData> getCompletedFields(PTSEmployer ptsEmployer,
			List<RequiredData> allData)  throws ValidationException{
		List<RequiredData> results = new ArrayList<RequiredData>();
		
        for (RequiredData field : allData)
        {
            PayrollEntityDataState entityState = registerMap.get(field).evaluateState(ptsEmployer);
            
            if (entityState == PayrollEntityDataState.Complete) {
                results.add(field);
            } 
        }

		return results;
	}

}
