package com.intuit.sb.payroll.capability.employer.impl.evaluator;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.entity.model.GlobalPostalAddress;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;

public class EmployerLegalAddressEvaluator extends AbstractPayrollEntityDataEvaluator<PTSEmployer>{

	private static EmployerLegalAddressEvaluator sInstance = new EmployerLegalAddressEvaluator();

	private EmployerLegalAddressEvaluator() {
	}
	
	public static PayrollEntityDataEvaluator<PTSEmployer> getInstance() {
		return sInstance;
	}
	
	@Override
	public PayrollEntityDataState evaluateState(PTSEmployer entity)
			throws ValidationException {
		Employer employer = entity.getEmployer();
		
		GlobalPostalAddress legalAddress = employer.getLegalAddress();
		if (legalAddress == null){
			return PayrollEntityDataState.Incomplete;
		}else{
			return PayrollEntityDataState.Complete;
		}
	}

}
