/**
 * 
 */
package com.intuit.sb.payroll.capability.pts.adapter.mapper;

import java.util.Calendar;
import java.util.Date;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.capability.pts.adapter.dtos.DatetimeDTO;
import com.intuit.sb.payroll.common.i18n.LocaleGuru;
import com.intuit.sbd.payroll.psp.adapters.gemini.DateAdapterDTO;

/**
 * @author dkulkarni
 *
 */
public class DateMapper {
	public static DateAdapterDTO mapDateToDTO(Date date) throws ServiceFailureException {
		if(date == null) {
			return null;
		}
		Calendar calendar = LocaleGuru.getInstance().getCalendar();
		calendar.setTime(date);
		DateAdapterDTO dateAdapterDTO = new DateAdapterDTO();
		dateAdapterDTO.setDay(calendar.get(Calendar.DATE));
		dateAdapterDTO.setMonth(calendar.get(Calendar.MONTH) + 1);
		dateAdapterDTO.setYear(calendar.get(Calendar.YEAR));
		return dateAdapterDTO;
	}
	
	public static Date mapDateAdapterDTOToDate(DateAdapterDTO dateAdapterDTO) {
		if(dateAdapterDTO == null){
			return null;
		}
		Calendar cal = LocaleGuru.getInstance().getCalendar();
		int year = dateAdapterDTO.getYear();
		int month = dateAdapterDTO.getMonth() - 1;
		int date = dateAdapterDTO.getDay();
		cal.set(year, month, date);
		return cal.getTime();
	}
	
	public static Date mapDatetimeDTOToDate(DatetimeDTO datetimeDTO) {
		if(datetimeDTO == null){
			return null;
		}
		Calendar cal = LocaleGuru.getInstance().getCalendar();
		int year = datetimeDTO.getYear();
		// make it month 0-11 from 1 - 12
		int month = datetimeDTO.getMonth() - 1;
		int date = datetimeDTO.getDay();
		int hourOfDay = datetimeDTO.getHour();
		int minute = datetimeDTO.getMinute();
		int second = datetimeDTO.getSecond();
		cal.set(year, month, date, hourOfDay, minute, second);
		return cal.getTime();
	}
}
