package com.intuit.sb.payroll.capability.pts.statehandler;

import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationException;
import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationRequest;
import com.intuit.sb.payroll.pts.entity.ActivationStatusEnum;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;


public class GenericStatusUpdateHandler extends AbstractStatusUpdateHandler  {

	private static GenericStatusUpdateHandler genericStatusHandler = 
					new GenericStatusUpdateHandler();
	
	private GenericStatusUpdateHandler(){
		registerStatusChangeWorkers();
	}
	
	public void validateNotificationRequest(PTSNotificationRequest ptsNotification) throws PTSNotificationException {
		//TODO
	}
	
	public static StatusUpdateHandler getInstance(){
		return genericStatusHandler;
	}
	
	// Inner classes for Individual state handlers

	static class GenericStatusChangeWorker extends StatusChangeWorker{

		@Override
		public void updateStatus(PTSEmployer ptsEmployer, PTSNotificationRequest ptsNotification) 
			throws PTSNotificationException {
			//TODO

		}
	}
	
	
	/**
	 * Generic Post processing event after ACH Enrollment update has been received from PTS
	 */
	@SuppressWarnings("unused")
    private static class CommonStatusChangeWorker extends GenericStatusChangeWorker{
		public CommonStatusChangeWorker() {
			super();
			statusTypeChange.add(ActivationStatusEnum.ACTIVATION_ACTIVE_ST_RECEIVED);
		    statusTypeChange.add(ActivationStatusEnum.ACTIVATION_AGENT_REVIEW_APPROVED_ST_RECEIVED);
		    statusTypeChange.add(ActivationStatusEnum.ACTIVATION_AWAITING_AGENT_REVIEW_ST_RECEIVED);
		    statusTypeChange.add(ActivationStatusEnum.ACTIVATION_CANCELLED_ST_RECEIVED);
		}

    	@Override
		public void updateStatus(PTSEmployer ptsEmployer, PTSNotificationRequest ptsNotification) throws PTSNotificationException {
    		super.updateStatus(ptsEmployer, ptsNotification);

		}
    }
}
