package com.intuit.sb.payroll.capability.pts.statehandler;

import java.util.HashMap;
import java.util.Map;

import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationTypeEnum;

public class StatusUpdateHandlerFactory {
	
	private static Map<PTSNotificationTypeEnum,StatusUpdateHandler> statusUpdateHandlerMap
	                              = new HashMap<PTSNotificationTypeEnum, StatusUpdateHandler>();
	
    
	static {
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.ACTIVATION_NOTIFICATION, ActivationStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.ACH_NOTIFICATION, ACHStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.EFTPS_ENROLLMENT_NOTIFICATION, EFTPSEnrollmentStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.RAA_NOTIFICATION, RAAStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.RAF_NOTIFICATION, RAFStatusUpdateHandler.getInstance());
		
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.BANK_ACCOUNT_NOTIFICATION,BankAccountStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.EMPLOYEE_ACTIVATION_NOTIFICATION, GenericStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.HISTORICAL_PAYROLL_DATA_NOTIFICATION, GenericStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.STATE_ID_RECVD_NOTIFICATION,GenericStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.TAX_AUDIT_NOTIFICATION,GenericStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.UNEMPLOYMENT_RATE_NOTIFICATION, GenericStatusUpdateHandler.getInstance());
		statusUpdateHandlerMap.put(PTSNotificationTypeEnum.STATE_ID_MODIFIED, StateIdModifiedNotificationHandler.getInstance());
		
	}
	
	public static StatusUpdateHandler getStatusUpdateHandler(PTSNotificationTypeEnum ptsNotificationType){
	    return statusUpdateHandlerMap.get(ptsNotificationType);	
	}
	
}
