package com.intuit.sb.payroll.capability.qa;

import java.lang.reflect.Field;
import java.util.List;

import javax.annotation.security.RolesAllowed;
import javax.ejb.EJB;
import javax.ejb.Stateless;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.entity.common.EntityService;
import com.intuit.sb.payroll.entity.domain.Identifiable;

@Stateless(name = "QaBootstrap")
@SecurityDomain("BHPIAM")
@RolesAllowed( { "Authenticated" })
public class QaBootstrapBean implements QaBootstrap {
	
	/**
	 * ejbName: full qualified name of the EJB class
	 */
	@SuppressWarnings("unchecked")
	public <T> T getEjb(String ejbName)
	{
		try{
			Class cl = Class.forName(ejbName);
			Field fl = cl.getField("JNDI_NAME");
			String fieldName = (String)(fl.get(null));
			Object obj = ServiceLocator.getInstance().getService(fieldName);
			T ejb = (T)obj;
			return ejb;
		}
		catch (Exception ex)
		{
			throw new RuntimeException("Can not get an intance of the ejb " + ejbName, ex);
		}
	}

	@SuppressWarnings("unchecked")
	public <T> T getEjbFromClass(Class cl)
	{
		try{
			Field fl = cl.getField("JNDI_NAME");
			String fieldName = (String)(fl.get(null));
			Object obj = ServiceLocator.getInstance().getService(fieldName);
			T ejb = (T)obj;
			return ejb;
		}
		catch (Exception ex)
		{
			throw new RuntimeException("Can not get an intance of the ejb " + cl.getCanonicalName(), ex);
		}
	}
	
	@EJB
	EntityService entityService;
	public <T> T findById(Class<T> type, Long Id)
	{
		return entityService.findById(type, Id);
	}
	public <T> T findByIdentifiable(Class<T> type, Identifiable identifiable)
	{
		return entityService.findByIdentifiable(type, identifiable);
	}
	public <T> List<T> findAll(Class<T> type)
	{
		return entityService.findAll(type);
	}
    public <T> T makeManaged(T entity)
    {
    	return entityService.makeManaged(entity);
    }
    public <T> T makePersistent(T entity)
    {
    	return entityService.makePersistent(entity);
    }
    public <T> boolean notPersistent(T entity)
    {
    	return entityService.notPersistent(entity);
    }
    public <T> void makeTransient(T entity)
    {
    	entityService.makeTransient(entity);
    }
}
