package com.intuit.sb.payroll.capability.taxes.impl;

import java.io.Serializable;

import com.intuit.sb.payroll.entity.model.RelationshipToOwnerEnum;

/**
 * DTO used for Rules evaluations.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
public class RulesEmployee implements Serializable{

	private static final long serialVersionUID = 896163717521879643L;
	private int ageInYears;
    private String workCountry;
    private String workState;
	private RelationshipToOwnerEnum relationToOwner;
    
    public RulesEmployee()
    {
        //Initialize variables to sensible defaults
        ageInYears = 0;
        workCountry = null;
        workState = null;
        relationToOwner = RelationshipToOwnerEnum.UNRELATED;
    }
        
    public Integer getAgeInYears() {
        return ageInYears;
    }

    public void setAgeInYears(Integer age) {
        ageInYears = age;      
    }

    public String getWorkCountry() {
        return workCountry;
    }

    public void setWorkCountry(String country) {
        workCountry = country;
        
    }

	public String getWorkState() {
        return workState;
    }

    public void setWorkState(String state) {
        workState = state;
        
    }

	public RelationshipToOwnerEnum getRelationToOwner() {
		return relationToOwner;
	}

	public void setRelationToOwner(RelationshipToOwnerEnum relationshipToOwner) {
		this.relationToOwner = relationshipToOwner;
	}

}
