package com.intuit.sb.payroll.capability.taxes.impl;


import java.io.Serializable;

import com.intuit.sb.payroll.entity.model.IndustryTypeEnum;
import com.intuit.sb.payroll.entity.model.LegalStructureEnum;

/**
 * Simple Implementation for IRulesEmployer
 * @see IRulesEmployer
 *
 */
public class RulesEmployer implements Serializable {
    
    /**
	 * 
	 */
	private static final long serialVersionUID = 2256633882936323934L;
	private boolean isForProfit;
    private IndustryTypeEnum industryType;
    private LegalStructureEnum legalStructure;
    private int numEmployees; //number of employees employed
    private boolean ssnAllowedForEIN;
    
    
    public RulesEmployer()
    {
        //Initialize to sensible defaults
        isForProfit = true;
        industryType= IndustryTypeEnum.NOTSET;
        legalStructure = LegalStructureEnum.NOTSET;        
    }
    

    public IndustryTypeEnum getIndustryType() {
        return industryType;
    }
    
    public void setIndustryType(IndustryTypeEnum type) {
        industryType = type;       
    }
    
    public Boolean getIsForProfit() {
        return Boolean.valueOf(isForProfit);
    }

    public void setIsForProfit(Boolean forProfit) {
    	if (forProfit != null){
    		isForProfit = forProfit.booleanValue();
    	}
    }

    public LegalStructureEnum getLegalStructure() {
        return legalStructure;
    }
    
    public void setLegalStructure(LegalStructureEnum structure) {
        legalStructure = structure;        
    }

    public boolean isSsnAllowedForEIN() {
		return ssnAllowedForEIN;
	}


	public void setSsnAllowedForEIN(boolean ssnAllowedForEIN) {
		this.ssnAllowedForEIN = ssnAllowedForEIN;
	}


	public int getNumEmployees() {
		return numEmployees;
	}


	public void setNumEmployees(int numEmployees) {
		this.numEmployees = numEmployees;
	}

}
