package com.intuit.sb.payroll.capability.worker.impl.evaluator;

import java.util.HashMap;
import java.util.Map;

import com.intuit.sb.payroll.capability.worker.impl.WorkerSetupRules;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.RequiredData;
import com.intuit.sb.payroll.entity.model.Worker;

public class USWorkerEvaluator extends WorkerEvaluator 
{
	public USWorkerEvaluator()
	{
		super();
		
		Map<RequiredData, PayrollEntityDataEvaluator<Worker>> registerMap = this.getRegisterMap();
		if(registerMap == null)
		{
			registerMap = new HashMap<RequiredData, PayrollEntityDataEvaluator<Worker>>();			
		}       
        registerMap.put(WorkerSetupRules.taxSettings, WorkerTaxesEvaluator.getInstance());
        //Make this a Factory too
        registerMap.put(WorkerSetupRules.withholdingInfo, WorkerFederalWithholdingsEvaluator.getInstance());
        //Make this a Factory too
        registerMap.put(WorkerSetupRules.stateWithholdingInfo, WorkerStateWithholdingEvaluator.getInstance());
        registerMap.put(WorkerSetupRules.liveLocation, WorkerLiveLocationEvaluator.getInstance());
        registerMap.put(WorkerSetupRules.hireDate, WorkerHireDateEvaluator.getInstance());
        registerMap.put(WorkerSetupRules.compensation, WorkerCompensationEvaluator.getInstance());
        registerMap.put(WorkerSetupRules.workLocation, WorkLocationEvaluator.getInstance());
        registerMap.put(WorkerSetupRules.worker_ssn, WorkerTaxIdEvaluator.getInstance());
        this.setRegisterMap(registerMap);
	}

}
