/**
 * 
 */
package com.intuit.sb.payroll.capability.worker.impl.evaluator;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.common.validation.PayrollParamValidator;
import com.intuit.sb.payroll.entity.model.Worker;

/**
 * @author dkulkarni
 *
 */
public class WorkerTaxIdEvaluator extends AbstractPayrollEntityDataEvaluator<Worker> {

	private static WorkerTaxIdEvaluator sInstance = new WorkerTaxIdEvaluator();
    
    private WorkerTaxIdEvaluator(){}
    
    public static PayrollEntityDataEvaluator<Worker> getInstance()
    {
        return sInstance ;
    }
    
	@Override
	public PayrollEntityDataState evaluateState(Worker worker)
			throws ValidationException {
		PayrollParamValidator.checkIsNotNull(worker, "Worker entity");
		if(worker.getPersonTaxId() != null && worker.getPersonTaxId().getValue() != null)
		{
			return PayrollEntityDataState.Complete;
		}
		return PayrollEntityDataState.Incomplete;
	}

}
