package com.intuit.sb.payroll.capability.worker.impl.evaluator;

import java.util.Set;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.common.AbstractPayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataEvaluator;
import com.intuit.sb.payroll.common.PayrollEntityDataState;
import com.intuit.sb.payroll.common.validation.PayrollParamValidator;
import com.intuit.sb.payroll.entity.model.TaxDtl;
import com.intuit.sb.payroll.entity.model.Worker;

public class WorkerTaxesEvaluator extends AbstractPayrollEntityDataEvaluator<Worker>
{
    private static WorkerTaxesEvaluator sInstance = new WorkerTaxesEvaluator();
    
    private WorkerTaxesEvaluator(){}
    
    public static PayrollEntityDataEvaluator<Worker> getInstance()
    {
        return sInstance ;
    }

    @Override
    public PayrollEntityDataState evaluateState(Worker worker) throws ValidationException
    {
        PayrollParamValidator.checkIsNotNull(worker, "Worker entity");
        Set<TaxDtl> taxDetails = worker.getTaxDtls();
        
        if(taxDetails != null && taxDetails.size() > 0)
        {
        	return PayrollEntityDataState.Complete;
        }
        return PayrollEntityDataState.Incomplete;
    }
}
