package com.intuit.sb.payroll.capability.workerpayments;

import java.util.List;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.capability.pts.LiabilityBalance;
import com.intuit.sb.payroll.common.WorkflowEventType;
import com.intuit.sb.payroll.entity.model.PayrollRun;
import com.intuit.sb.payroll.pts.entity.PTSEmployer;

public interface PayrollPTSWorkflowComponent {
	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "PayrollPTSWorkflowComponent/local";
	
	/**
	 * This component is interested in changes related to the Payroll Run
	 * @param eventType
	 * @param payrollRun
	 * @throws ServiceFailureException
	 */
	public void handlePayrollRunEvent(WorkflowEventType eventType, 
			PayrollRun payrollRun) throws ServiceFailureException;

	public void handleAssistedSetupEvent(WorkflowEventType workflowEventType,
			PTSEmployer ptsEmployer) throws ServiceFailureException;

	public List<LiabilityBalance> getHistoricalLiabilityBalances(PTSEmployer ptsEmployer)
			throws ServiceFailureException;
}
