package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.handlers;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Set;

import com.intuit.dataTypes.Rate;
import com.intuit.payroll.j.EmployeeIf;
import com.intuit.payroll.j.PayrollDatumIf;
import com.intuit.payroll.j.PayrollItemIf;
import com.intuit.payroll.types.enumtype.DatumID;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext;
import com.intuit.sb.payroll.entity.model.DisabilityInsDocDtl;
import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.entity.model.EmployerComplianceDocDtl;
import com.intuit.sb.payroll.entity.model.UnemploymentInsDocDtl;
import com.intuit.sb.payroll.entity.model.Worker;

public class USStateUnemploymentHandler extends AbstractPayrollItemHandler {

	private static List<Locale> localeList = new ArrayList<Locale>();

	static {
		localeList.add(Locale.US);
	}
	
	public void createQboPayrollItemsFromPayrollItemDtls(PayrollEngineContext context, EmployeeIf employee,
			Worker worker) {
		Employer employer = context.getEmployer();
		//Set the rate on the UI payroll item. 
		Set<EmployerComplianceDocDtl> employerComplianceDocDtls = employer.getEmployerComplianceDocDtls();
		for (EmployerComplianceDocDtl employerComplianceDocDtl : employerComplianceDocDtls) {
			String docId = employerComplianceDocDtl.getLawId().getValue();
			String rate;
			if (employerComplianceDocDtl instanceof UnemploymentInsDocDtl) {
				rate = ((UnemploymentInsDocDtl)employerComplianceDocDtl).getPercentageRate().toString() + "%";
			} else if (employerComplianceDocDtl instanceof DisabilityInsDocDtl) {
				rate = ((DisabilityInsDocDtl)employerComplianceDocDtl).getPercentageRate().toString() + "%";
			} else {
				String mesg = MessageFormat.format("Unexpected company compliance type ''{0}'' (LawId={1}).",
						new Object[] {employerComplianceDocDtl.getClass().getName(), docId});
				throw new IllegalArgumentException(mesg);
			}
			Rate uiRate = new Rate(rate);
			PayrollItemIf payrollItemIf = context.getPayrollItemForLaw(docId);
			PayrollDatumIf qboeRateContainer = payrollItemIf.getDatum(DatumID.RATE);

			if (qboeRateContainer.isEditable()) {
				qboeRateContainer.setValue(uiRate);
			}
		}
	}

	public String getLawId() {
		// TODO Auto-generated method stub
		return null;
	}

	public List<Locale> getLocaleList() {
		return localeList;
	}

	//FIXME cut and paste of the above.
	public void handle(PaycheckCalculationContext context) {
		Employer employer = context.getEmployer();
		//Set the rate on the UI payroll item. 
		Set<EmployerComplianceDocDtl> employerComplianceDocDtls = employer.getEmployerComplianceDocDtls();
		for (EmployerComplianceDocDtl employerComplianceDocDtl : employerComplianceDocDtls) {
			String docId = employerComplianceDocDtl.getLawId().getValue();
			String rate;
			if (employerComplianceDocDtl instanceof UnemploymentInsDocDtl) {
				rate = ((UnemploymentInsDocDtl)employerComplianceDocDtl).getPercentageRate().toString() + "%";
			} else if (employerComplianceDocDtl instanceof DisabilityInsDocDtl) {
				rate = ((DisabilityInsDocDtl)employerComplianceDocDtl).getPercentageRate().toString() + "%";
			} else {
				String mesg = MessageFormat.format("Unexpected company compliance type ''{0}'' (LawId={1}).",
						new Object[] {employerComplianceDocDtl.getClass().getName(), docId});
				throw new IllegalArgumentException(mesg);
			}
			Rate uiRate = new Rate(rate);
			PayrollItemIf payrollItemIf = context.getPayrollItemForLaw(docId);
			PayrollDatumIf qboeRateContainer = payrollItemIf.getDatum(DatumID.RATE);

			if (qboeRateContainer.isEditable()) {
				qboeRateContainer.setValue(uiRate);
			}
		}
	}

}
