package com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.handlers;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Set;

import com.intuit.payroll.j.EmployeeIf;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PaycheckCalculationContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.PayrollEngineContext;
import com.intuit.sb.payroll.capability.workerpayments.impl.calcengine.QboeLawIdConstants;
import com.intuit.sb.payroll.entity.model.CompensationDtl;
import com.intuit.sb.payroll.entity.model.CompensationTypeEnum;
import com.intuit.sb.payroll.entity.model.Worker;

public class USVacationPTODisbursementHandler extends AbstractPTOHandler {

	private static List<Locale> localeList = new ArrayList<Locale>();
	
	static {
		localeList.add(Locale.US);
	}
	
	public String getLawId() {
		return QboeLawIdConstants.sVacationDisbursementLawId;
	}

	public List<Locale> getLocaleList() {
		return localeList;
	}

	public void handle(PaycheckCalculationContext context) {
		Set<CompensationDtl> workerCompensations = context.getWorker().getCompensationDtls();
		for (final CompensationDtl compensationDtl : workerCompensations) {
			if (compensationDtl.getCompensationType() == CompensationTypeEnum.VACTAKEN) {
				super.handleImpl(context, compensationDtl);
			}
		}
	}
	
	public void createQboPayrollItemsFromPayrollItemDtls(PayrollEngineContext context, EmployeeIf employee,
			Worker worker) {
		Set<CompensationDtl> workerCompensations = worker.getCompensationDtls();
		for (final CompensationDtl compensationDtl : workerCompensations) {
			if (compensationDtl.getCompensationType() == CompensationTypeEnum.VACTAKEN) {
				super.createImpl(context, worker, employee, compensationDtl);
			}
		}
	}

}
