package com.intuit.sb.payroll.message;

//import javax.ejb.ActivationConfigProperty;
//import javax.ejb.MessageDriven;
import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.ObjectMessage;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.capability.employer.impl.EmployerEntityActivity;
import com.intuit.sb.payroll.capability.worker.impl.WorkerEntityActivity;
import com.intuit.sb.payroll.capability.workerpayments.impl.PayrollScheduleEntityActivity;
import com.intuit.sb.payroll.entity.domain.Identifiable;
import com.intuit.sb.payroll.entity.model.Employee;
import com.intuit.sb.payroll.entity.model.Employer;
import com.intuit.sb.payroll.entity.model.PayrollSchedule;



//@MessageDriven(activationConfig =
//{
//@ActivationConfigProperty(propertyName="destinationType", propertyValue="javax.jms.Queue"),
//@ActivationConfigProperty(propertyName="destination", propertyValue="queue/payrollmdb")
//@ActivationConfigProperty(propertyName="messageSelector", propertyValue="JMSType = 'request' AND myProperty = 'myValue'"),
//@ActivationConfigProperty(propertyName="acknowledgeMode", propertyValue="AUTO_ACKNOWLEDGE"),
//@ActivationConfigProperty(propertyName="subscriptionDurability", propertyValue="Durable"),
//@ActivationConfigProperty(propertyName="subscriptionName", propertyValue="TestMdbSubscription"),
//@ActivationConfigProperty(propertyName="clientId", propertyValue="PayrollMdb")
//})

@Stateless(name = "PayrollMessageDriven")
@SecurityDomain("BHPIAM")
@RolesAllowed({"Authenticated"})
//TODO Logging
public class PayrollMessageDrivenBean  implements PayrollMessageDriven{ //implements MessageListener{

	public void performMessageAction(PayrollMessage payrollMessage){
		Identifiable entity = (Identifiable)payrollMessage.getEntity();
		PayrollMessageEnum payrollCommand = payrollMessage.getPayrollCommand();
		invokeEntityActivity(payrollCommand, entity);
	}
	
	public void onMessage(Message message) {
		PayrollMessageEnum payrollCommand = null;
		com.intuit.sb.payroll.entity.domain.Identifiable entity = null;

		// Retrieve the payload from the message
		if (message instanceof ObjectMessage){
			try {
				PayrollMessage payrollMessage = (PayrollMessage)((ObjectMessage)message).getObject();
				entity = (com.intuit.sb.payroll.entity.domain.Identifiable)payrollMessage.getEntity();
				payrollCommand = payrollMessage.getPayrollCommand();
				
			} catch (JMSException e) {
				e.printStackTrace();
			}
		}
		invokeEntityActivity(payrollCommand, entity);
		
		
			
	}

	private void invokeEntityActivity(PayrollMessageEnum payrollCommand,
			Object entity) {
		try{
			
			// TODO improve the impl and use more intelligent message object
			if (payrollCommand != null){
				if (payrollCommand.equals(PayrollMessageEnum.NEW_EMPLOYER_CREATION)){
					EmployerEntityActivity empActivity = new EmployerEntityActivity();
					empActivity.entityCreationAsync((Employer)entity);
				}
				else if (payrollCommand.equals(PayrollMessageEnum.NEW_EMPLOYEE_CREATION)){
					WorkerEntityActivity workerEntityActivity = new WorkerEntityActivity();
					workerEntityActivity.entityCreationAsync((Employee)entity);
				}
				else if (payrollCommand.equals(PayrollMessageEnum.EMPLOYEE_UPDATE)){
					WorkerEntityActivity workerEntityActivity = new WorkerEntityActivity();
					workerEntityActivity.entityUpdateAsync((Employee)entity);
				}
				else if (payrollCommand.equals(PayrollMessageEnum.NEW_PAYROLL_SCHEDULE_CREATION)){
					PayrollScheduleEntityActivity payrollScheduleEntityActivity = new PayrollScheduleEntityActivity();
					payrollScheduleEntityActivity.entityCreationAsync((PayrollSchedule)entity);
				}
				else if (payrollCommand.equals(PayrollMessageEnum.DELETE_EMPLOYER)){
					EmployerEntityActivity empActivity = new EmployerEntityActivity();
					empActivity.entityDeleteAsync();
				}
				else if (payrollCommand.equals(PayrollMessageEnum.DELETE_EMPLOYEE)){
					WorkerEntityActivity workerEntityActivity = new WorkerEntityActivity();
					workerEntityActivity.entityDeleteAsync();
				}
				else if (payrollCommand.equals(PayrollMessageEnum.DELETE_PAYROLL_SCHEDULE)){
					PayrollScheduleEntityActivity payrollScheduleEntityActivity = new PayrollScheduleEntityActivity();
					payrollScheduleEntityActivity.entityDeleteAsync();
				}
			}
		}catch(Exception e){
			// catch the exception here and let it not pollute the other requests
			e.printStackTrace();
		}
	}


}
