package com.intuit.sb.payroll.capability.common;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *  <P>The <CODE>XMLUtil</CODE> class contains helper methods for parsing XML contents</P>
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */
public class XMLUtil {
	public static final String columnTag = "COL";

	public static List<RowData> getRowData(String input) {
		Document dom = null;
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			ByteArrayInputStream s = new ByteArrayInputStream(input.getBytes());
			dom = db.parse(s);
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		List<RowData> rowDataList = new ArrayList<RowData>();
		Element docElement = dom.getDocumentElement();
		NodeList nl = docElement.getElementsByTagName("ROW");
		if (null != nl) {
			for (int i = 0; i < nl.getLength(); i++) {
				Element element = (Element)nl.item(i);
				RowData rowData = new RowData();
				Node node = element.getFirstChild();
				while (null != node) {
					String name = node.getNodeName();
					if (columnTag.equalsIgnoreCase(name)) {
						String value = node.getTextContent();
						NameValuePair nameValuePair = new NameValuePair(name, value);
						rowData.addNameValuePair(nameValuePair);
					}
					node = node.getNextSibling();
				}
				rowDataList.add(rowData);
			}
		}
		return rowDataList;
	}
}
