package com.intuit.sb.payroll.capability.pts.statehandler;

import org.testng.Assert;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationException;
import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationRequest;
import com.intuit.sb.payroll.capability.pts.notification.PTSNotificationTypeEnum;
import com.intuit.sb.payroll.pts.entity.RAFEnrollmentStatusEnum;


public class RAFStatusUpdateHandlerTest extends StatusUpdateHandlerTestBase  {
    
	@Test(enabled=true)
	public void testRAFStatusUpdateHandler(){
		RAFEnrollmentStatusEnum[] rafEnrollementStatus = RAFEnrollmentStatusEnum.values();
		
		for (RAFEnrollmentStatusEnum enrollmentStatusEnum : rafEnrollementStatus) {
			if (enrollmentStatusEnum.equals(RAFEnrollmentStatusEnum.NOTSET)){
				// Skip
				continue;
			}
			PTSNotificationRequest ptsNotificationRequest = createPTSNotificationRequest(
					PTSNotificationTypeEnum.RAF_NOTIFICATION, enrollmentStatusEnum);
			try {
				updateNotificationRequest(ptsNotificationRequest);
			} catch (PTSNotificationException e) {
				Assert.fail(e.getLocalizedMessage(), e);
			}
		}
	}

}
