package com.intuit.sb.payroll.capability.taxes.withholding;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.entity.model.ComplianceDocIdEnum;
import com.intuit.sb.payroll.entity.model.WorkerComplianceDocDtl;

/**
 * <P>
 * The <CODE>CreateWorkerComplianceDocDtlTest</CODE> class contains tests for testing the
 * createWorkerComplianceDocDtl() in TaxWithholdingsComponent
 * </P>
 * 
 * $Author$ $Revision$ $DateTime$
 * 
 */
public class CreateWorkerComplianceDocDtlTest extends TaxWithholdingsComponentTestBase {

	/**
	 * <P>Test calling createWorkerComplianceDocDtl() with ComplianceDocIdEnum.W4IRS</P>
	 * 
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Call the TaxWithholdingsComponent.createWorkerComplianceDocDtl() with ComplianceDocIdEnum.W4IRS</LI>
	 * </OL>
	 * 
	 * <UL>
	 * <LI>Verify that a valid WorkerComplianceDocDtl is returned
	 * </UL>
	 */
	@Test
	public void testComplianceDocIdEnum_W4IRS() throws Exception {
    	//Exercise
		WorkerComplianceDocDtl workerComplianceDocDtl = sTaxWithholdingsComponent.createWorkerComplianceDocDtl(
				ComplianceDocIdEnum.W4IRS);
		AssertJUnit.assertNotNull("WorkerComplianceDocDtl returned is null!", workerComplianceDocDtl);
		AssertJUnit.assertEquals("ComplianceDocIdEnum value mismatch!", ComplianceDocIdEnum.W4IRS,
				workerComplianceDocDtl.getDocId());
	}

	/**
	 * <P>Test calling createWorkerComplianceDocDtl() with ComplianceDocIdEnum.DE4</P>
	 * 
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Call the TaxWithholdingsComponent.createWorkerComplianceDocDtl() with ComplianceDocIdEnum.DE4</LI>
	 * </OL>
	 * 
	 * <UL>
	 * <LI>Verify that a valid WorkerComplianceDocDtl is returned
	 * </UL>
	 */
	@Test
	public void testComplianceDocIdEnum_DE4() throws Exception {
    	//Exercise
		WorkerComplianceDocDtl workerComplianceDocDtl = sTaxWithholdingsComponent.createWorkerComplianceDocDtl(
				ComplianceDocIdEnum.DE4);
		AssertJUnit.assertNotNull("WorkerComplianceDocDtl returned is null!", workerComplianceDocDtl);
		AssertJUnit.assertEquals("ComplianceDocIdEnum value mismatch!", ComplianceDocIdEnum.DE4,
				workerComplianceDocDtl.getDocId());
	}

	/**
	 * <P>Test calling createWorkerComplianceDocDtl() with unsupported ComplianceDocIdEnum</P>
	 * 
	 * <H3>Steps:</H3>
	 * <OL>
	 * <LI>Call the TaxWithholdingsComponent.createWorkerComplianceDocDtl() with unsupported ComplianceDocIdEnum</LI>
	 * </OL>
	 * 
	 * <UL>
	 * <LI>Verify that null is returned
	 * </UL>
	 */
	@Test(expectedExceptions={ValidationException.class})
	public void testUnsupportedComplianceDocIdEnum() throws Exception {
    	//Exercise
		@SuppressWarnings("unused")
		WorkerComplianceDocDtl workerComplianceDocDtl = sTaxWithholdingsComponent.createWorkerComplianceDocDtl(
				ComplianceDocIdEnum.TD1_CRA);
	}

}
