package com.intuit.sb.payroll.capability.workerpayments;

import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;


/**
 * The <CODE>GetNextScheduledPayrollRunInfoExceptionsTest</CODE> class contains exception tests for testing the
 * getNextScheduledPayrollRunInfo() in PayrollScheduleComponent
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */
public class GetNextScheduledPayrollRunInfoExceptionsTest extends WorkerPaymentsComponentTestBase {
	
    /**
     * <P>Test calling getNextScheduledPayrollRunInfo() with a null PayrollSchedule</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call PayrollScheduleComponent.getNextScheduledPayrollRunInfo() will a null PayrollSchedule</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that ValidationException is thrown</LI>
     * </UL>
     */
	@Test(expectedExceptions = ValidationException.class)
	public void testNullPayrollSchedule() throws Exception {
		// Exercise
		@SuppressWarnings("unused")
		PayrollRunInfo computed = pScheduleComponent.getNextScheduledPayrollRunInfo(null);
	}
	
}
