package com.intuit.sb.payroll.reports;

import java.io.Serializable;
import java.util.Date;

/*
 * Defines the response to a report request
 */
public class ReportRequest implements Serializable {
	
	private static final long serialVersionUID = 4806859730839656927L;
	private ReportType reportType;
	private Date fromDate;
	private Date toDate;
	private ReportSubtotals reportSubtotals;
	private ReportDetail reportDetail;
	private String reportTitle;

	
	/**
	 * Minimal constructor (required by LCDS)
	 */
	public ReportRequest() {
	}
	
	/**
	 * Constructs a ReportsRequest.
	 */
	public ReportRequest(ReportType reportType, Date fromDate, Date toDate, ReportSubtotals reportSubtotals,
			ReportDetail reportDetail, String reportTitle) {
		this.reportType = reportType;
		this.fromDate = fromDate;
		this.toDate = toDate;
		this.reportSubtotals = reportSubtotals;
		this.reportDetail = reportDetail;
		this.reportTitle = reportTitle;
	}
	
	/**
	 * @return the reportType
	 */
	public ReportType getReportType() {
		return reportType;
	}
	/**
	 * @param reportType the reportType to set
	 */
	public void setReportType(ReportType reportType) {
		this.reportType = reportType;
	}

	/**
	 * @return the fromDate
	 */
	public Date getFromDate() {
		return fromDate;
	}
	/**
	 * @param fromDate the fromDate to set
	 */
	public void setFromDate(Date fromDate) {
		this.fromDate = fromDate;
	}

	/**
	 * @return the toDate
	 */
	public Date getToDate() {
		return toDate;
	}
	/**
	 * @param toDate the toDate to set
	 */
	public void setToDate(Date toDate) {
		this.toDate = toDate;
	}

	/**
	 * @return the reportSubtotals
	 */
	public ReportSubtotals getReportSubtotals() {
		return reportSubtotals;
	}
	/**
	 * @param reportSubtotals the reportSubtotals to set
	 */
	public void setReportSubtotals(ReportSubtotals reportSubtotals) {
		this.reportSubtotals = reportSubtotals;
	}

	/**
	 * @return the reportDetail
	 */
	public ReportDetail getReportDetail() {
		return reportDetail;
	}
	/**
	 * @param reportDetail the reportDetail to set
	 */
	public void setReportDetail(ReportDetail reportDetail) {
		this.reportDetail = reportDetail;
	}

	/**
	 * @param reportTitle the reportTitle to set
	 */
	public void setReportTitle(String reportTitle) {
		this.reportTitle = reportTitle;
	}

	/**
	 * @return the reportTitle
	 */
	public String getReportTitle() {
		return reportTitle;
	}

}
