package com.intuit.sb.payroll.services.benefits;

import java.io.Serializable;
import java.math.BigDecimal;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.services.common.ObjectHandle;

public class HealthBenefitTemplate  implements Serializable
{
	private static final long serialVersionUID = 1120423860611487862L;
	
	private ObjectHandle objectHandle;
	private String name;
	private BigDecimal rate;
	private HealthBenefitType type;
	
	public HealthBenefitTemplate() {} //default constructor

	public void copy(HealthBenefitTemplate benefit)
	{
		this.objectHandle = benefit.objectHandle;
		this.name = benefit.name;
		this.rate = benefit.rate;
		this.type = benefit.type;
	}

	/**
	 * Gets the handle to this object.
	 * @return the objectHandle
	 */
	public ObjectHandle getObjectHandle() {
		return objectHandle;
	}

	/**
	 * Sets the handle to this object.
	 * @param objectHandle the objectHandle to set
	 */
	public void setObjectHandle(ObjectHandle objectHandle) {
		this.objectHandle = objectHandle;
	}

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }
	/**
	 * @return the rate 
	 */
	public java.math.BigDecimal getRate() {
		return this.rate;
	}

	/**
	 * @param rate the rate to set 
	 */
	public void setRate(BigDecimal value) {
		this.rate = value;
		if (null != value) {
            // set to 2 decimal places
    		this.rate = this.rate.setScale(2);
		}
	}

    /**
     * @return the type 
     */
    public HealthBenefitType getType() {
        return this.type;
    }

    /**
     * @param type the type to set 
     */
    public void setType(HealthBenefitType type) {
        this.type = type;
    }

	/**
	 * @return the serialVersionUID
	 */
	public static long getSerialVersionUID() {
		return serialVersionUID;
	}

    @Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }

    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }

	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
