package com.intuit.sb.payroll.services.common;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;


/**
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */ 
public class WorkLocation implements Serializable {

	private static final long serialVersionUID = -1166058212436162614L;
	
	private ObjectHandle objectHandle;
	private String name;
	private PhysicalAddress address;
	private String phoneNumber;
	private String extn;
	private int workerCount;
	private boolean isDefault;

	public WorkLocation() {
		super();
	}

	public WorkLocation(ObjectHandle objectHandle, String name, boolean isDefault) {
		this();
		this.objectHandle = objectHandle;
		this.name = name;
		this.isDefault = isDefault;
	}
	
	public ObjectHandle getObjectHandle() {
		return objectHandle;
	}

	public void setObjectHandle(ObjectHandle objectHandle) {
		this.objectHandle = objectHandle;
	}

	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
    
    public void setAddress(PhysicalAddress address) {
		this.address = address;
	}

	public PhysicalAddress getAddress() {
		return address;
	}

	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}

	public String getPhoneNumber() {
		return phoneNumber;
	}
	
	public void setExtn(String extn) {
		this.extn = extn;
	}

	public String getExtn() {
		return extn;
	}

	public void setWorkerCount(int workerCount) {
		this.workerCount = workerCount;
	}

	public void setIsDefault(boolean isDefault) {
		this.isDefault = isDefault;
	}

	public boolean getIsDefault() {
		return isDefault;
	}

	public int getWorkerCount() {
		return workerCount;
	}

	@Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }
    
    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }
    
	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}