package com.intuit.sb.payroll.services.common.impl;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.services.common.ObjectHandle;

public class CommonValidators {

	/**
	 * Ensures that an entity id conforms to some basic validation rules.
	 * It must be non-null and numeric.
	 * @param id the id to validate.
	 * @throws ValidationException if the ID is invalid.
	 */
	public static void validateId(Long id) throws ValidationException {
		if (id == null) {
			//FIXME [I18N] resource translation
			throw new ValidationException("The ID is null");
		}
	}

	public static void validateObjectHandle(ObjectHandle handle) throws ServiceFailureException{
		if (null == handle) {
			//FIXME [I18N] resource translation
			throw new ServiceFailureException("ObjectHandle is required for non-create operations");				
		}
	}
}
