package com.intuit.sb.payroll.services.employer;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.services.common.ObjectHandle;
import com.intuit.sb.payroll.services.common.PhysicalAddress;

//TODO [rj] - we need to think about defining another class like Contact which can
//be the base class for ContactDetail and EmployerContact
public class EmployerContact  implements Serializable
{
	private static final long serialVersionUID = -7310367480338017009L;
    
	private ObjectHandle objectHandle;
	private String firstName;
	private String lastName;
	private String middleName;
	private boolean owner;
	private String title; //if not owner
	private String phone;
	private String extn;
	private String fax;
	private String email;
	private boolean sameAsCompanyAddress;
	private PhysicalAddress address;
	private EmployerContactType employerContactType;


	public EmployerContact() {} //default constructor

	public void copy(EmployerContact contact)
	{
		this.firstName = contact.firstName;
		this.lastName = contact.lastName;
		this.middleName = contact.middleName;
		this.owner = contact.owner;
		this.title = contact.title;
		this.phone = contact.phone;
		this.extn = contact.extn;
		this.fax = contact.fax;
		this.email = contact.email;
		this.sameAsCompanyAddress = contact.sameAsCompanyAddress;
		this.address = contact.address;
		this.employerContactType = contact.employerContactType;
		this.objectHandle = contact.objectHandle;
	}

	/**
	 * @return the firstName
	 */
	public String getFirstName() {
		return firstName;
	}

	/**
	 * @param firstName the firstName to set
	 */
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	/**
	 * @return the lastName
	 */
	public String getLastName() {
		return lastName;
	}

	/**
	 * @param lastName the lastName to set
	 */
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	/**
	 * @return the middleName
	 */
	public String getMiddleName() {
		return middleName;
	}
	
	/**
	 * @param middleName the middleName to set
	 */
	public void setMiddleName(String middleName){
		this.middleName = middleName;
	}
	/**
	 * @return the title
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * @param title the title to set
	 */
	public void setTitle(String title) {
		this.title = title;
	}

	/**
	 * @return the phone
	 */
	public String getPhone() {
		return phone;
	}

	/**
	 * @param phone the phone to set
	 */
	public void setPhone(String phone) {
		this.phone = phone;
	}

	/**
	 * @return the extn
	 */
	public String getExtn() {
		return extn;
	}

	/**
	 * @param extn the extn to set
	 */
	public void setExtn(String extn) {
		this.extn = extn;
	}

	/**
	 * @return the fax
	 */
	public String getFax() {
		return fax;
	}

	/**
	 * @param fax the fax to set
	 */
	public void setFax(String fax) {
		this.fax = fax;
	}

	/**
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * @param email the email to set
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * @return the sameAsCompanyAddress
	 */
	public boolean isSameAsCompanyAddress() {
		return sameAsCompanyAddress;
	}

	/**
	 * @param sameAsCompanyAddress the sameAsCompanyAddress to set
	 */
	public void setSameAsCompanyAddress(boolean sameAsCompanyAddress) {
		this.sameAsCompanyAddress = sameAsCompanyAddress;
	}

	/**
	 * @return the address
	 */
	public PhysicalAddress getAddress() {
		return address;
	}

	/**
	 * @param address the address to set
	 */
	public void setAddress(PhysicalAddress address) {
		this.address = address;
	}

	/**
	 * @return the serialVersionUID
	 */
	public static long getSerialVersionUID() {
		return serialVersionUID;
	}

	/**
	 * @return the owner
	 */
	public boolean isOwner() {
		return owner;
	}

	/**
	 * @param owner the owner to set
	 */
	public void setOwner(boolean owner) {
		this.owner = owner;
	}
	
	/**
	 * @return the objectHandle
	 */
	public ObjectHandle getObjectHandle() {
		return objectHandle;
	}

	/**
	 * @param objectHandle the objectHandle to set
	 */
	public void setObjectHandle(ObjectHandle objectHandle) {
		this.objectHandle = objectHandle;
	}
	
	/**
	 * @return the  employerContactType
	 */
	public EmployerContactType getEmployerContactType(){
		return employerContactType;
	}
	
	/**
	 * @param employerContactType the employerContact to set
	 */
	public void setEmployerContactType(EmployerContactType empContactType){
		this.employerContactType = empContactType;
	}

    @Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }

    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }

	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
