package com.intuit.sb.payroll.services.employer;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.services.common.ObjectHandle;
import com.intuit.sb.payroll.services.common.PhysicalAddress;

/**
 * What is the difference with CompanyInfo?
 * 
 * $Author$ 
 * $Revision$ 
 * $DateTime$
 */
public class EmployerInfo implements Serializable {
	private static final long serialVersionUID = -7310367480338017011L;

	private ObjectHandle objectHandle;

	// Formerly the CompanyInfo dto
	private String companyName;
	private String DBAName;
	private String phoneNumber;
	private String webAddress;

	private PhysicalAddress companyAddress;

	// Formerly the CompanyLegalTaxFilingInfo dto
	private CompanyType companyLegalType;
	private IndustryType industryType;
	private String legalName;
	private boolean legalAddressSameAsBusinessAddress;
	private PhysicalAddress legalAddress;
	private String legalPhone;
	private String extn;

	private AssistedStateType assistedStateType;
	
	private PrintPreferencesDTO printPreferences;
	private TakeHomeCompanyYTDChoicesDTO takeHomeCompanyYTDChoices;
	private byte[] companyLogo;
	
	// Formerly the CompanyInfo dto
	public void setCompanyName(String companyName) {
		this.companyName = companyName;
	}

	public String getCompanyName() {
		return companyName;
	}

	/**
	 * @return the DBAName
	 */
	public String getDBAName() {
		return DBAName;
	}

	/**
	 * @param DBAName the DBAName to set
	 */
	public void setDBAName(String DBAName) {
		this.DBAName = DBAName;
	}

	/**
	 * @return the companyPhone
	 */
	public String getCompanyPhone() {
		return phoneNumber;
	}

	/**
	 * @param companyPhone the companyPhone to set
	 */
	public void setCompanyPhone(String value) {
		phoneNumber = value;
	}

	/**
	 * @return the webAddress
	 */
	public String getWebAddress() {
		return webAddress;
	}

	/**
	 * @param webAddress the webAddress to set
	 */
	public void setWebAddress(String value) {
		this.webAddress = value;
	}

	/**
	 * @return the companyAddress
	 */
	public PhysicalAddress getCompanyAddress() {
		return companyAddress;
	}

	/**
	 * @param companyAddress the companyAddress to set
	 */
	public void setCompanyAddress(PhysicalAddress companyAddress) {
		this.companyAddress = companyAddress;
	}

	// Formerly the CompanyLegalTaxFilingInfo dto

	public CompanyType getCompanyType() {
		return companyLegalType;
	}

	public void setCompanyType(CompanyType companyLegalType) {
		this.companyLegalType = companyLegalType;
	}

	public IndustryType getIndustryType() {
		return industryType;
	}

	public void setIndustryType(IndustryType industryType) {
		this.industryType = industryType;
	}

	public String getLegalName() {
		return legalName;
	}

	public void setLegalName(String legalName) {
		this.legalName = legalName;
	}

	public boolean isLegalAddressSameAsBusinessAddress() {
		return legalAddressSameAsBusinessAddress;
	}

	public void setLegalAddressSameAsBusinessAddress(boolean legalAddressSameAsBusinessAddress) {
		this.legalAddressSameAsBusinessAddress = legalAddressSameAsBusinessAddress;
	}

	public PhysicalAddress getLegalAddress() {
		return legalAddress;
	}

	public void setLegalAddress(PhysicalAddress legalAddress) {
		this.legalAddress = legalAddress;
	}

	public String getLegalPhone() {
		return legalPhone;
	}

	public void setLegalPhone(String legalPhone) {
		this.legalPhone = legalPhone;
	}

	public String getExtn() {
		return extn;
	}

	public void setExtn(String extn) {
		this.extn = extn;
	}
	
	/**
	 * @param assistedStateType the assistedStateType to set
	 */
	public void setAssistedStateType(AssistedStateType assistedStateType) {
		this.assistedStateType = assistedStateType;
	}

	/**
	 * @return the assistedStateType
	 */
	public AssistedStateType getAssistedStateType() {
		return assistedStateType;
	}

	@Override
	public boolean equals(Object other) {
		return EqualsBuilder.reflectionEquals(this, other);
	}

	@Override
	public int hashCode() {
		return HashCodeBuilder.reflectionHashCode(this);
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

	public void setObjectHandle(ObjectHandle objectHandle) {
		this.objectHandle = objectHandle;
	}

	public ObjectHandle getObjectHandle() {
		return objectHandle;
	}
	
	/**
	 * The printing preferences for this company.  Relates to adjustments they have made for their check stock.
	 * @return the printPreferences.
	 */
	public PrintPreferencesDTO getPrintPreferences() {
		return printPreferences;
	}

	public void setPrintPreferences(PrintPreferencesDTO printPreferences) {
		this.printPreferences = printPreferences;
	}
	
	public TakeHomeCompanyYTDChoicesDTO getTakeHomeCompanyYTDChoices() {
		return takeHomeCompanyYTDChoices;
	}

	public void setTakeHomeCompanyYTDChoices(
			TakeHomeCompanyYTDChoicesDTO takeHomeCompanyYTDChoices) {
		this.takeHomeCompanyYTDChoices = takeHomeCompanyYTDChoices;
	}
	
	public byte[] getCompanyLogo() {
		return companyLogo;
	}

	public void setCompanyLogo(byte[] companyLogo) {
		this.companyLogo = companyLogo;
	}
}
