package com.intuit.sb.payroll.services.employer.impl;

import com.intuit.sb.payroll.pts.entity.TaxServiceStatusEnum;
import com.intuit.sb.payroll.services.employer.AssistedStateType;

public class AssistedStateTypeMapper {

	public static TaxServiceStatusEnum mapAssistedStateType(
			AssistedStateType assistedStateType) {
		
		if (assistedStateType == null) {
			return null;
		}
		if (assistedStateType == AssistedStateType.INITIATED_ONBOARDING){
			return TaxServiceStatusEnum.SIGNED_UP_FOR_ASSISTED;
		}else if (assistedStateType == AssistedStateType.ASSISTED_FORMS_PRINTED){
			return TaxServiceStatusEnum.READY_FOR_ADD_COMPANY;
		}else if (assistedStateType == AssistedStateType.NOT_ASSISTED){
			return TaxServiceStatusEnum.NOT_SIGNED_FOR_ASSISTED;
		}else if (assistedStateType == AssistedStateType.ASSISTED_ACTIVATION_ACCEPT){
			return TaxServiceStatusEnum.ACTIVATION_ACTIVE_ST_ACCEPTED;
		}else if (assistedStateType == AssistedStateType.ASSISTED_ACTIVATION_REJECT){
			return TaxServiceStatusEnum.ACTIVATION_ACTIVE_ST_REJECTED;
		}else if (assistedStateType == AssistedStateType.ASSISTED_PRE_ACTIVATE){
			return TaxServiceStatusEnum.PRE_ACTIVATE;
		}
		
		return null;
	}
	
	public static AssistedStateType mapEmployerAssistedStateEnum(
			TaxServiceStatusEnum taxServiceStatus) {
		if (taxServiceStatus == null){
			return null;
		}
		switch(taxServiceStatus){
			case NOT_SIGNED_FOR_ASSISTED:
				return AssistedStateType.NOT_ASSISTED;
			case SIGNED_UP_FOR_ASSISTED:
				return AssistedStateType.INITIATED_ONBOARDING;
			case READY_FOR_ADD_COMPANY:
				return AssistedStateType.ASSISTED_FORMS_PRINTED;
			case ACTIVATION_ACTIVE_ST_ACCEPTED:
				return AssistedStateType.ASSISTED_ACTIVATION_ACCEPT;
			case ACTIVATION_ACTIVE_ST_REJECTED:
				return AssistedStateType.ASSISTED_ACTIVATION_REJECT;
			case PRE_ACTIVATE:
				return AssistedStateType.ASSISTED_PRE_ACTIVATE;
			default:
				return null;
		}
		
		
	}

}
