package com.intuit.sb.payroll.services.employer.impl;

import com.intuit.sb.payroll.entity.model.IndustryTypeEnum;
import com.intuit.sb.payroll.services.employer.IndustryType;

/**
 * Mapper class to handle IndustryType Mappings between the DTO/Service layer and the Entity Model.
 * 
 * $Author$ 
 * $Revision$ 
 * $DateTime$
 */
public class IndustryTypeMapper {

	/**
	 * Maps from a DTO IndustryType to an Entity IndustryTypeEnum. Null input = null output.
	 * 
	 * @param IndustryType
	 * @return
	 */
	public static com.intuit.sb.payroll.entity.model.IndustryTypeEnum mapIndustryType(IndustryType type) {
		IndustryTypeEnum industryType;

		if (type == null) {
			return null;
		}

		if (type.equals(IndustryType.Accommodation)) {
			industryType = IndustryTypeEnum.ACCOMMODATION;
		} else if (type.equals(IndustryType.ArtsEntertainRec)) {
			industryType = IndustryTypeEnum.ARTS_ENTERTAINMENT;
		} else if (type.equals(IndustryType.Construction)) {
			industryType = IndustryTypeEnum.CONSTRUCTION;
		} else if (type.equals(IndustryType.EducationalServices)) {
			industryType = IndustryTypeEnum.EDUCATION;
		} else if (type.equals(IndustryType.FinanceInsurance)) {
			industryType = IndustryTypeEnum.FINANCE_INSURANCE;
		} else if (type.equals(IndustryType.HealthCareSocialAssist)) {
			industryType = IndustryTypeEnum.HEALTH_SOCIAL;
		} else if (type.equals(IndustryType.ManagementCE)) {
			industryType = IndustryTypeEnum.MANAGEMENT;
		} else if (type.equals(IndustryType.Manufacturing)) {
			industryType = IndustryTypeEnum.MANUFACTURING;
		} else if (type.equals(IndustryType.NonProfit)) {
			industryType = IndustryTypeEnum.NONPROFIT;
		} else if (type.equals(IndustryType.OtherServices)) {
			industryType = IndustryTypeEnum.OTHER;
		} else if (type.equals(IndustryType.PSTServices)) {
			industryType = IndustryTypeEnum.SCIENCE_TECHNICAL;
		} else if (type.equals(IndustryType.PublicAdmin)) {
			industryType = IndustryTypeEnum.GOVERNMENT;
		} else if (type.equals(IndustryType.RealEstateRentalLeasing)) {
			industryType = IndustryTypeEnum.REAL_ESTATE;
		} else if (type.equals(IndustryType.Restaurants)) {
			industryType = IndustryTypeEnum.RESTAURANT;
		} else if (type.equals(IndustryType.RetailTrade)) {
			industryType = IndustryTypeEnum.RETAIL;
		} else if (type.equals(IndustryType.TransportWarehousing)) {
			industryType = IndustryTypeEnum.TRANSPORT_WAREHOUSE;
		} else if (type.equals(IndustryType.WholesaleTrade)) {
			industryType = IndustryTypeEnum.WHOLESALE;
		} else {
			industryType = IndustryTypeEnum.NOTSET;
		}

		return industryType;
	}

	/**
	 * Maps from an Entity IndustryTypeEnum to a DTO IndustryType. Null input = null output.
	 * 
	 * @param IndustryTypeEnum
	 * @return
	 */
	public static IndustryType mapIndustryType(com.intuit.sb.payroll.entity.model.IndustryTypeEnum type) {
		IndustryType industryType;

		if (type == null) {
			return null;
		}

		if (type.equals(IndustryTypeEnum.ACCOMMODATION)) {
			industryType = IndustryType.Accommodation;
		} else if (type.equals(IndustryTypeEnum.ARTS_ENTERTAINMENT)) {
			industryType = IndustryType.ArtsEntertainRec;
		} else if (type.equals(IndustryTypeEnum.CONSTRUCTION)) {
			industryType = IndustryType.Construction;
		} else if (type.equals(IndustryTypeEnum.EDUCATION)) {
			industryType = IndustryType.EducationalServices;
		} else if (type.equals(IndustryTypeEnum.FINANCE_INSURANCE)) {
			industryType = IndustryType.FinanceInsurance;
		} else if (type.equals(IndustryTypeEnum.HEALTH_SOCIAL)) {
			industryType = IndustryType.HealthCareSocialAssist;
		} else if (type.equals(IndustryTypeEnum.MANAGEMENT)) {
			industryType = IndustryType.ManagementCE;
		} else if (type.equals(IndustryTypeEnum.MANUFACTURING)) {
			industryType = IndustryType.Manufacturing;
		} else if (type.equals(IndustryTypeEnum.NONPROFIT)) {
			industryType = IndustryType.NonProfit;
		} else if (type.equals(IndustryTypeEnum.OTHER)) {
			industryType = IndustryType.OtherServices;
		} else if (type.equals(IndustryTypeEnum.SCIENCE_TECHNICAL)) {
			industryType = IndustryType.PSTServices;
		} else if (type.equals(IndustryTypeEnum.GOVERNMENT)) {
			industryType = IndustryType.PublicAdmin;
		} else if (type.equals(IndustryTypeEnum.REAL_ESTATE)) {
			industryType = IndustryType.RealEstateRentalLeasing;
		} else if (type.equals(IndustryTypeEnum.RESTAURANT)) {
			industryType = IndustryType.Restaurants;
		} else if (type.equals(IndustryTypeEnum.RETAIL)) {
			industryType = IndustryType.RetailTrade;
		} else if (type.equals(IndustryTypeEnum.TRANSPORT_WAREHOUSE)) {
			industryType = IndustryType.TransportWarehousing;
		} else if (type.equals(IndustryTypeEnum.WHOLESALE)) {
			industryType = IndustryType.WholesaleTrade;
		} else {
			industryType = null;
		}

		return industryType;
	}
}
