package com.intuit.sb.payroll.services.taxes;

import java.io.Serializable;

import com.intuit.sb.payroll.services.taxes.TaxAgency;

/**
 * Clas representing employer tax id's setting.
 * It can contain a single federal tax id and a number of state tax ids
 * @author riyer
 *
 */
public class EmployerTaxIdInfo implements Serializable 
{
	private static final long serialVersionUID = 3028892972870492176L;

	private Long uniqueId; //unique identifier 
	
	private int version; //version for optimistic locking purposes

	private String taxId; //the actual tax Id assigned by the agency
	
	private TaxAgency taxAgency;
	
	private boolean locked; 


	public boolean isLocked() {
		return locked;
	}

	public void setLocked(boolean locked) {
		this.locked = locked;
	}
	
	public TaxAgency getTaxAgency() {
		return taxAgency;
	}

	public void setTaxAgency(TaxAgency ta) {
		this.taxAgency = ta;
	}

	/**
	 * @return the taxId
	 */
	public String getTaxId() {
		return taxId;
	}

	/**
	 * @param taxId the taxId to set
	 */
	public void setTaxId(String taxId) {
		this.taxId = taxId;
	}

	/**
	 * @return the uniqueId
	 */
	public Long getUniqueId() {
		return uniqueId;
	}

	/**
	 * @param uniqueId the uniqueId to set
	 */
	public void setUniqueId(Long uniqueId) {
		this.uniqueId = uniqueId;
	}

	/**
	 * @return the version
	 */
	public int getVersion() {
		return version;
	}

	/**
	 * @param version the version to set
	 */
	public void setVersion(int version) {
		this.version = version;
	}
}
