package com.intuit.sb.payroll.services.taxes;

import java.io.Serializable;
import java.util.Date;

/**
 * POJO that represents the Employer SUI setting for a state
 * @author rjohn2
 *
 */
public class SuiSetting implements Serializable  
{
	private static final long serialVersionUID = -7310367480338017108L;
	private String state; //TODO - [rj] later we may need to change this to a StateClass with the State abbreviation and the localized state name string
	private String currentRate; //TODO - should this be changed to float?
	private String futureRate; //TODO - should this be changed to float?
	private Date futureRateStartDate;
	//FIXME ObjectHandle
	private Long uniqueId; //unique identifier
	private Long version; //version for optimistic locking purposes
	
	private boolean rateChangedByIntuit; //flag indicating whether the rate is changed by Intuit or not
	private boolean defaultRate;
	
	private String minRate;
	private String maxRate;

	public String getMinRate() {
		return minRate;
	}

	public void setMinRate(String minRate) {
		this.minRate = minRate;
	}

	public String getMaxRate() {
		return maxRate;
	}

	public void setMaxRate(String maxRate) {
		this.maxRate = maxRate;
	}
	
	/**
	 * @return the defaultRate
	 */
	public boolean isDefaultRate() {
		return defaultRate;
	}

	/**
	 * @param defaultRate the defaultRate to set
	 */
	public void setDefaultRate(boolean defaultRate) {
		this.defaultRate = defaultRate;
	}

	/**
	 * @return the state
	 */
	public String getState() 
	{
		return state;
	}

	/**
	 * @param state the state to set
	 */
	public void setState(String state) 
	{
		this.state = state;
	}

	/**
	 * @return the currentRate
	 */
	public String getCurrentRate() 
	{
		return currentRate;
	}

	/**
	 * @param currentRate the currentRate to set
	 */
	public void setCurrentRate(String currentRate) 
	{
		this.currentRate = currentRate;
	}

	/**
	 * @return the futureRate
	 */
	public String getFutureRate() 
	{
		return futureRate;
	}

	/**
	 * @param futureRate the futureRate to set
	 */
	public void setFutureRate(String futureRate) 
	{
		this.futureRate = futureRate;
	}

	/**
	 * @return the futureRateStartDate
	 */
	public Date getFutureRateStartDate() 
	{
		return futureRateStartDate;
	}

	/**
	 * @param futureRateStartDate the futureRateStartDate to set
	 */
	public void setFutureRateStartDate(Date futureRateStartDate) 
	{
		this.futureRateStartDate = futureRateStartDate;
	}

	/**
	 * @return the rateChangedByIntuit
	 */
	public boolean isRateChangedByIntuit() 
	{
		return rateChangedByIntuit;
	}

	/**
	 * @param rateChangedByIntuit the rateChangedByIntuit to set
	 */
	public void setRateChangedByIntuit(boolean rateChangedByIntuit) 
	{
		this.rateChangedByIntuit = rateChangedByIntuit;
	}

	/**
	 * @return the uniqueId
	 */
	public Long getUniqueId() 
	{
		return uniqueId;
	}

	/**
	 * @param uniqueId the uniqueId to set
	 */
	public void setUniqueId(Long uniqueId) 
	{
		this.uniqueId = uniqueId;
	}

	/**
	 * @return the version
	 */
	public Long getVersion() 
	{
		return version;
	}

	/**
	 * @param version the version to set
	 */
	public void setVersion(Long version) 
	{
		this.version = version;
	}

}
