package com.intuit.sb.payroll.services.taxes;

import java.io.Serializable;

public class TaxDetails implements Serializable 
{
	private static final long serialVersionUID = -7310367480338018308L;
	
	private long uniqueId; //unique identifier
	private int version; //version for optimistic locking purposes
	
	private String jurisdictionName;
	private String agencyName;
	private String agencyUrl;
	private String agencyTIN; //tax ID alloted by the specified agency
	
	private TaxSummary[] taxSummaryCollection;

	/**
	 * @return the uniqueId
	 */
	public long getUniqueId() 
	{
		return uniqueId;
	}

	/**
	 * @param uniqueId the uniqueId to set
	 */
	public void setUniqueId(long uniqueId) 
	{
		this.uniqueId = uniqueId;
	}

	/**
	 * @return the version
	 */
	public int getVersion() 
	{
		return version;
	}

	/**
	 * @param version the version to set
	 */
	public void setVersion(int version) 
	{
		this.version = version;
	}

	/**
	 * @return the jurisdictionName
	 */
	public String getJurisdictionName() 
	{
		return jurisdictionName;
	}

	/**
	 * @param jurisdictionName the jurisdictionName to set
	 */
	public void setJurisdictionName(String jurisdictionName) 
	{
		this.jurisdictionName = jurisdictionName;
	}

	/**
	 * @return the agencyName
	 */
	public String getAgencyName()
	{
		return agencyName;
	}

	/**
	 * @param agencyName the agencyName to set
	 */
	public void setAgencyName(String agencyName) 
	{
		this.agencyName = agencyName;
	}

	/**
	 * @return the agencyTIN
	 */
	public String getAgencyTIN() 
	{
		return agencyTIN;
	}

	/**
	 * @param agencyTIN the agencyTIN to set
	 */
	public void setAgencyTIN(String agencyTIN) 
	{
		this.agencyTIN = agencyTIN;
	}

	/**
	 * @param taxSummary the taxSummary to set
	 */
	public void setTaxSummary(TaxSummary[] taxSummaryCollection) 
	{
		this.taxSummaryCollection = taxSummaryCollection;
	}

	/**
	 * @return the agencyUrl
	 */
	public String getAgencyUrl() {
		return agencyUrl;
	}

	/**
	 * @param agencyUrl the agencyUrl to set
	 */
	public void setAgencyUrl(String agencyUrl) {
		this.agencyUrl = agencyUrl;
	}

	/**
	 * @return the taxSummaryCollection
	 */
	public TaxSummary[] getTaxSummaryCollection() 
	{
		return taxSummaryCollection;
	}

	/**
	 * @param taxSummaryCollection the taxSummaryCollection to set
	 */
	public void setTaxSummaryCollection(TaxSummary[] taxSummaryCollection) 
	{
		this.taxSummaryCollection = taxSummaryCollection;
	}
}