package com.intuit.sb.payroll.services.taxes;

import java.io.Serializable;

public class TaxSummary implements Serializable 
{
	private static final long serialVersionUID = -7310367480338017638L;
	
	private long uniqueId; //unique identifier
	private int version; //version for optimistic locking purposes
	
	private String shortDescription; //example Federal Income Tax
	private String companyTaxRate; //could be the values none,or a valid %
	private String employeeRate; //could be None,Varies by Employee or a valid %
	private String wageLimit; //the wage limit for this tax
	private boolean editable = false; //flag whether the tax rate is editable by the user or not; default is false
	
	/**
	 * @return the uniqueId
	 */
	public long getUniqueId() 
	{
		return uniqueId;
	}
	/**
	 * @param uniqueId the uniqueId to set
	 */
	public void setUniqueId(long uniqueId) 
	{
		this.uniqueId = uniqueId;
	}
	/**
	 * @return the version
	 */
	public int getVersion() 
	{
		return version;
	}
	/**
	 * @param version the version to set
	 */
	public void setVersion(int version) 
	{
		this.version = version;
	}
	/**
	 * @return the shortDescription
	 */
	public String getShortDescription() 
	{
		return shortDescription;
	}
	/**
	 * @param shortDescription the shortDescription to set
	 */
	public void setShortDescription(String shortDescription) {
		this.shortDescription = shortDescription;
	}
	/**
	 * @return the companyTaxRate
	 */
	public String getCompanyTaxRate() 
	{
		return companyTaxRate;
	}
	/**
	 * @param companyTaxRate the companyTaxRate to set
	 */
	public void setCompanyTaxRate(String companyTaxRate) 
	{
		this.companyTaxRate = companyTaxRate;
	}
	/**
	 * @return the employeeRate
	 */
	public String getEmployeeRate() 
	{
		return employeeRate;
	}
	/**
	 * @param employeeRate the employeeRate to set
	 */
	public void setEmployeeRate(String employeeRate) 
	{
		this.employeeRate = employeeRate;
	}
	/**
	 * @return the editable
	 */
	public boolean isEditable() 
	{
		return editable;
	}
	/**
	 * @param editable the editable to set
	 */
	public void setEditable(boolean editable) 
	{
		this.editable = editable;
	}
	
	/**
	 * @return the wageLimit
	 */
	public String getWageLimit() 
	{
		return wageLimit;
	}
	
	/**
	 * @param wageLimit the wageLimit to set
	 */
	public void setWageLimit(String wageLimit) 
	{
		this.wageLimit = wageLimit;
	}
}
