package com.intuit.sb.payroll.services.taxpayments;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * Value object to hold paymentType and its corresponding<br>
 * Liability value
 */
public class PaymentTypeLiability implements Serializable {

    private static final long serialVersionUID = -705548867723643333L;;

    private String paymentType; //  string representation of PaymentType enum

    private BigDecimal liability;

    public PaymentTypeLiability(String paymentType, BigDecimal liability) {
        this.paymentType = paymentType;
        this.liability = liability;
    }

    //  default no-args constructor to enable Flex LCDS to construct equivalent .as class
    public PaymentTypeLiability() {
    }

    public BigDecimal getLiability() {
        return liability;
    }

    public void setLiability(BigDecimal liability) {
        this.liability = liability;
    }

    public void setPaymentType(String paymentType) {
        this.paymentType = paymentType;
    }

    public String getPaymentType() {
        return paymentType;
    }
}
