package com.intuit.sb.payroll.services.workerpayments;

import java.io.Serializable;
import java.math.BigDecimal;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

public class PaycheckDetails implements Serializable
{

	private static final long serialVersionUID = -5416449549873364691L;
	private Long               paycheckId;
    private Long               workerId;
	private BigDecimal           grossPay;
	private BigDecimal           netPay;
	private String checkNumber;
	private String memo;
	private PaycheckLineItem[]   paycheckLineItems;
    private PaycheckDistributionMethod distributionMethod;
	private PaycheckStatus paycheckStatus;

	/**
	 * 
	 */
	public PaycheckDetails()
	{
		super();
	}

	/**
	 * @param grossPay
	 * @param netPay
	 * @param wageItemTotals
	 * @param paycheckLineItems
	 */
	public PaycheckDetails(Long workerId, BigDecimal grossPay, BigDecimal netPay,
			PaycheckLineItem[] paycheckLineItems)
	{
		this();
		this.workerId = workerId;
		this.grossPay = grossPay;
		this.netPay = netPay;
		this.paycheckLineItems = paycheckLineItems;
	}

	
	/**
	 * @return the workerId
	 */
	public Long getWorkerId() 
    {
		return workerId;
	}

	/**
	 * @param workerId the workerId to set
	 */
	public void setWorkerId(Long workerId) 
    {
		this.workerId = workerId;
	}

	/**
	 * @return the grossTotal
	 */
	public BigDecimal getGrossTotal()
	{
		return grossPay;
	}

	/**
	 * @param grossPay the grossPay to set
	 */
	public void setGrossTotal(BigDecimal grossPay)
	{
		this.grossPay = grossPay;
	}

	/**
	 * @return the netTotal
	 */
	public BigDecimal getNetTotal()
	{
		return netPay;
	}

	/**
	 * @param netPay the netPay to set
	 */
	public void setNetTotal(BigDecimal netPay)
	{
		this.netPay = netPay;
	}

	/**
	 * @return the paycheckLineItemsList
	 */
	public PaycheckLineItem[] getPaycheckLineItemsList()
	{
		return paycheckLineItems;
	}

	/**
	 * @param paycheckLineItems The paycheckLineItems to set
	 */
	public void setPaycheckLineItemsList(PaycheckLineItem[] paycheckLineItems)
	{
		this.paycheckLineItems = paycheckLineItems;
	}
    
    /**
     * @return the paycheckId
     */
    public Long getPaycheckId() 
    {
        return paycheckId;
    }
    /**
     * @param paycheckId the paycheckId to set
     */
    public void setPaycheckId(Long paycheckId) 
    {
        this.paycheckId = paycheckId;
    }
    
    /**
     * @return the distributionMethod
     */
    public PaycheckDistributionMethod getDistributionMethod() 
    {
        return distributionMethod;
    }
    /**
     * @param distributionMethod the distributionMethod to set
     */
    public void setDistributionMethod(PaycheckDistributionMethod distributionMethod) 
    {
        this.distributionMethod = distributionMethod;
    }
    
    public String getCheckNumber() {
		return checkNumber;
	}

	public void setCheckNumber(String checkNumber) {
		this.checkNumber = checkNumber;
	}
	
	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public PaycheckStatus getPaycheckStatus() {
		return paycheckStatus;
	}

	public void setPaycheckStatus(PaycheckStatus paycheckStatus) {
		this.paycheckStatus = paycheckStatus;
	}
	
	@Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }
    
    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }
    
	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}