package com.intuit.sb.payroll.services.workerpayments;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.entity.model.PayrollRunTypeEnum;

/**
 * The properties a calc engine client must provide in order to request
 * the creation of a new payroll run.
 */
public class PayrollRunCreateRequest implements Serializable
{

	private static final long serialVersionUID = 3609140228374056583L;
	// Payroll Run Period
    private PayrollRunPeriod period;
    // Array of workers Id to create payrollRun
	private Long[] workerIds;
	//PayrollRunType
	private PayrollRunTypeEnum payrollRunType;

	
	/**
	 * @return the period
	 */
	public PayrollRunPeriod getPeriod() {
		return period;
	}
	/**
	 * @param period the period to set
	 */
	public void setPeriod(PayrollRunPeriod period) {
		this.period = period;
	}
	/**
	 * @return the workerIds
	 */
	public Long[] getWorkerIds() {
		return workerIds;
	}
	/**
	 * @param workerIds the workerIds to set
	 */
	public void setWorkerIds(Long[] workerIds) {
		this.workerIds = workerIds;
	}
	
	/**
	 * 
	 * @return PayrollRunTypeEnum
	 */
	public PayrollRunTypeEnum  getPayrollRunType()
	{
		return payrollRunType;
	}
	
	/**
	 * 
	 * @param payrollRunType
	 */
	public void setPayrollRunType(PayrollRunTypeEnum payrollRunType)
	{
		this.payrollRunType = payrollRunType;
	}
	
    @Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }
    
    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }
    
	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
