package com.intuit.sb.payroll.services.workerpayments;

import java.io.Serializable;
import java.util.Date;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.entity.model.PayrollRunTypeEnum;

/**
 * The properties required from a calc engine client in order to fullfil a payroll run save request. This does not run
 * the payroll. It saves the payroll run parameters for future use.
 */
public class PayrollRunSaveRequest implements Serializable
{
	
	private static final long serialVersionUID = 8673225037266077654L;
	private Long payrollRunId;
    private PaycheckRequest[] paycheckRequests;
    private PayrollRunPeriod payrollRunPeriod;
    private PayrollRunTypeEnum payrollRunType;
    private Date terminationDate;
    private String description;

    /**
     * @return the payrollRunId
     */
    public Long getPayrollRunId()
    {
        return payrollRunId;
    }

    /**
     * @param payrollRunId the payrollRunId to set
     */
    public void setPayrollRunId(Long payrollRunId)
    {
        this.payrollRunId = payrollRunId;
    }


    public PaycheckRequest[] getPaycheckRequests() {
		return paycheckRequests;
	}

	public void setPaycheckRequests(PaycheckRequest[] paycheckRequests) {
		this.paycheckRequests = paycheckRequests;
	}

	/**
     * @return the payrollRunPeriod
     */
    public PayrollRunPeriod getPayrollRunPeriod()
    {
        return payrollRunPeriod;
    }

    /**
     * @param payrollRunPeriod the payrollRunPeriod to set
     */
    public void setPayrollRunPeriod(PayrollRunPeriod payrollRunPeriod)
    {
        this.payrollRunPeriod = payrollRunPeriod;
    }

	public void setPayrollRunType(PayrollRunTypeEnum payrollRunType) {
		this.payrollRunType = payrollRunType;
	}

	public PayrollRunTypeEnum getPayrollRunType() {
		return payrollRunType;
	}

	public void setTerminationDate(Date terminationDate) {
		this.terminationDate = terminationDate;
	}

	public Date getTerminationDate() {
		return terminationDate;
	}
	
    public void setDescription(String description) {
		this.description = description;
	}

	public String getDescription() {
		return description;
	}

	@Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }
    
    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }
    
	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
