package com.intuit.sb.payroll.services.workerpayments;

import java.io.Serializable;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.services.worker.Worker;

/**
 * The response from committing (saving) a payroll run.
 */
public class PayrollRunSaveResponse implements Serializable
{
	private static final long serialVersionUID = 8673225037266077654L;
	private PayrollSchedule payrollSchedule;
	private PayrollRunSummary payrollRunSummary;
    private Worker[] workers;

    public PayrollRunSaveResponse() {
    	super();
    }
    public PayrollRunSaveResponse(PayrollRunSummary payrollRunSummary, PayrollSchedule payrollSchedule, Worker[] workers) {
    	this();
    	setPayrollRunSummary(payrollRunSummary);
    	setWorkers(workers);
    	setPayrollSchedule(payrollSchedule);
    }
    
    /**
     * @return the PayrollRunSummary
     */
    public PayrollRunSummary getPayrollRunSummary()
    {
    	return payrollRunSummary;
    }

    /**
     * @param payrollRunSummary the PayrollRunSummary to set
     */
    public void setPayrollRunSummary(PayrollRunSummary payrollRunSummary)
    {
        this.payrollRunSummary = payrollRunSummary;
    }


    public Worker[] getWorkers() {
		return workers;
	}

	public void setWorkers(Worker[] workers) {
		this.workers = workers;
	}

    public void setPayrollSchedule(PayrollSchedule payrollSchedule) {
		this.payrollSchedule = payrollSchedule;
	}
	public PayrollSchedule getPayrollSchedule() {
		return payrollSchedule;
	}
	
	@Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }
    
    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }
    
	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

}
