package com.intuit.sb.payroll.services.workerpayments;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

import com.intuit.sb.payroll.task.Task;

/**
 * Setup Task to set the company Pay Schedule. This task will come into existence when a company
 * setup is required to update the default seeded PaySchedule
 *
 */
public class PayrollScheduleTask extends Task
{
   
    private static final long serialVersionUID = 2580019752504236966L;
    
    // The state of the PayrollScheduleTask 
    private PayrollScheduleTaskState payrollScheduleState;
    
     
    /**
     * @return the payrollScheduleState
     */
    public PayrollScheduleTaskState getPayrollScheduleState()
    {
        return payrollScheduleState;
    }

    
    /**
     * @param payrollScheduleState the payrollScheduleState to set
     */
    public void setPayrollScheduleState(PayrollScheduleTaskState payrollScheduleState)
    {
        this.payrollScheduleState = payrollScheduleState;
    }

    @Override
    public boolean equals(Object other)
    {
        return EqualsBuilder.reflectionEquals(this, other);
    }
    
    @Override
    public int hashCode()
    {
       return HashCodeBuilder.reflectionHashCode(this);
    }
    
	@Override
	public String toString()
	{
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
