package com.intuit.sb.payroll.services.workerpayments.impl;

import com.intuit.sb.payroll.entity.model.PayrollDistributionMethodEnum;
import com.intuit.sb.payroll.services.workerpayments.PaycheckDistributionMethod;

public class PayrollDistributionMethodMapper {

	private PayrollDistributionMethodMapper() {
	}

	public static PayrollDistributionMethodEnum mapInterfaceToEntity(PaycheckDistributionMethod paycheckDistributionMethod) {
		if (null == paycheckDistributionMethod) {
			return null;
		}

		if (paycheckDistributionMethod.equals(PaycheckDistributionMethod.CASH)) {
			return PayrollDistributionMethodEnum.CASH;
		} else if (paycheckDistributionMethod.equals(PaycheckDistributionMethod.DIRECT_DEPOSIT)) {
			return PayrollDistributionMethodEnum.DIRECTDEPOSIT;
		} else if (paycheckDistributionMethod.equals(PaycheckDistributionMethod.HANDWRITTEN)) {
			return PayrollDistributionMethodEnum.HANDWRITTENPAYCHECK;
		} else if (paycheckDistributionMethod.equals(PaycheckDistributionMethod.PRINT)) {
			return PayrollDistributionMethodEnum.PRINTEDPAYCHECK;
		} else if (paycheckDistributionMethod.equals(PaycheckDistributionMethod.OTHER)) {
			return PayrollDistributionMethodEnum.NOTSET;	
		} else {
			return null;
		}

	}

	public static PaycheckDistributionMethod mapEntityToInterface(PayrollDistributionMethodEnum payrollDistributionMethod) {
		if (payrollDistributionMethod == PayrollDistributionMethodEnum.CASH) {
			return PaycheckDistributionMethod.CASH;
		} else if (payrollDistributionMethod == PayrollDistributionMethodEnum.DIRECTDEPOSIT) {
			return PaycheckDistributionMethod.DIRECT_DEPOSIT;
		} else if (payrollDistributionMethod == PayrollDistributionMethodEnum.HANDWRITTENPAYCHECK) {
			return PaycheckDistributionMethod.HANDWRITTEN;
		} else if (payrollDistributionMethod == PayrollDistributionMethodEnum.PRINTEDPAYCHECK) {
			return PaycheckDistributionMethod.PRINT;
		} else if (payrollDistributionMethod == PayrollDistributionMethodEnum.NOTSET) {
			return PaycheckDistributionMethod.OTHER;
		} else {
			return null;
		}

	}

}
