package com.intuit.sb.payroll.services.workerpayments.impl;

import com.intuit.sb.payroll.entity.model.PaycheckLineItemSortSequenceEnum;
import com.intuit.sb.payroll.services.workerpayments.PayrollItemCategoryType;


/**
 * Converts Pojo and Services Payroll Frequencies.
 *
 * Tested by the PaycheckLineItemSortSequenceMapperTest in the same package.
 *
 * $Author: wafrica $
 * $Revision: #1 $
 * $DateTime: 2008/11/11 09:46:35 $
 *
 */
public class PayrollItemCategoryTypeMapper {

    private PayrollItemCategoryTypeMapper() {
    }

    /**
     * Maps a Data Entity PaycheckLineItemSortSequenceEnum to Entity Interface PayrollItemCategoryType
     *
     * @param PaycheckLineItemSortSequenceEnum
     * @return  Entity Interface PayrollItemCategoryType
     */
    static PayrollItemCategoryType mapFromDEntityToEI(PaycheckLineItemSortSequenceEnum pliSortSequence) {
        if (pliSortSequence == null) {
            return null;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.NOTSET) {
            return PayrollItemCategoryType.NOT_SET;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.WAGES) {
            return PayrollItemCategoryType.COMPENSATION;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.EMPLOYEEPAIDTAX) {
            return PayrollItemCategoryType.EMPLOYEE_PAID_TAX;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.EMPLOYERPAIDTAX) {
            return PayrollItemCategoryType.EMPLOYER_PAID_TAX;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.PRETAXDEDUCTION) {
            return PayrollItemCategoryType.PRE_TAX_DEDUCTION;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.POSTTAXDEDUCTION) {
            return PayrollItemCategoryType.POST_TAX_DEDUCTION;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.PRETAXADJUSTMENT) {
            return PayrollItemCategoryType.PRE_TAX_ADJUSTMENT;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.POSTTAXADJUSTMENT) {
            return PayrollItemCategoryType.POST_TAX_ADJUSTMENT;
        }
        if (pliSortSequence == PaycheckLineItemSortSequenceEnum.PAIDTIMEOFF) {
            return PayrollItemCategoryType.PAID_TIME_OFF;
        }
        return PayrollItemCategoryType.NOT_SET;
    }
}
