package com.intuit.sb.payroll.services.common;

import java.util.Date;

import com.intuit.sb.payroll.intl.capability.address.USPostalAddress;
import com.intuit.sb.payroll.us.capability.address.impl.USPostalAddressImpl;

/**
 * Utility class to create simple Pojo's for test purposes.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
public class PojoUtils
{
	public static final String EMPLOYEE_ADDRESSLINE1 = "2650 Casey Ave";
	public static final String EMPLOYEE_ADDRESSLINE2 = "Suite 101";
	public static final String EMPLOYEE_CITY = "Mountain View";
	public static final String EMPLOYEE_STATE = "CA";
	public static final String EMPLOYEE_COUNTRY = "USA";
	public static final String EMPLOYEE_COUNTRYISOCODE = "US";
	public static final String EMPLOYEE_ZIPCODE = "94043";
	
	public static final String contactPhoneNr = "650-944-6000";
	public static final String contactExt = "7777";
	public static final String contactFaxNr = "650-944-6001";

	public static final String email = "abc@abc.com";
	public static final String firstName = "Tony";
	public static final String lastName = "Blair";
	public static final Boolean owner = true;
	public static final Boolean sameAsCompanyAddress = true;
	
	public static final String title = "Mr. Owner";
	public static final String uniqueId = "001";
	public static final Long version = 9999L;	
	
	   public static com.intuit.sb.payroll.services.worker.Worker createPojoWorkerMinimal()
	   {
	       com.intuit.sb.payroll.services.worker.Worker worker = new com.intuit.sb.payroll.services.worker.Worker();
	       worker.setFirstName("Amitab");
	       worker.setLastName("Bachan");
	       worker.setHireDate(new Date(0));
	       
	       return worker;
	   }
	   
		public static PhysicalAddress createUSCAPhysicalAddress() 
		{
			PhysicalAddress physicalAddress = new PhysicalAddress();
			physicalAddress.setAddressLine1(EMPLOYEE_ADDRESSLINE1);
			physicalAddress.setAddressLine2(EMPLOYEE_ADDRESSLINE2);
			physicalAddress.setCity(EMPLOYEE_CITY);
			physicalAddress.setCountry(EMPLOYEE_COUNTRY);
			physicalAddress.setStateOrRegion(EMPLOYEE_STATE);
			physicalAddress.setZipOrPostalCode(EMPLOYEE_ZIPCODE);
			
			return physicalAddress;
		}
		
		public static USPostalAddress createUSCAPostalAddress() 
		{
			USPostalAddress postalAddress = new USPostalAddressImpl();
			postalAddress.setAddressLine1(EMPLOYEE_ADDRESSLINE1);
			postalAddress.setAddressLine2(EMPLOYEE_ADDRESSLINE2);
			postalAddress.setCity(EMPLOYEE_CITY);
			postalAddress.setCountry(EMPLOYEE_COUNTRY);
			postalAddress.setRegionOrState(EMPLOYEE_STATE);
			postalAddress.setZipOrPostalCode(EMPLOYEE_ZIPCODE);
			
			return postalAddress;
		}		
}
