package com.intuit.sb.payroll.services.employer;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;

public class EmployerCompanyInfoTest extends EmployerServiceTestBase {
   
	/**
     * This test saves a CompanyInfo and retrieves and verifies it
     * @throws Exception
     */
    @Test
    public void testCompanyInfo() throws Exception
    {
        EmployerInfo info = createBasicEmployerInfo(); 
        
    	//save the company
        sEmployerService.saveCompanyInfo(info);
    	//now get back the company info and verify we got it all back
    	EmployerInfo infoFromDb = sEmployerService.getEmployerInfo();
    	
    	AssertJUnit.assertNotNull("Company Info not saved", infoFromDb); 
    	AssertJUnit.assertEquals("Company's print preference for x alignment does not match", 
    			info.getPrintPreferences().getXalignment(), infoFromDb.getPrintPreferences().getXalignment());
		AssertJUnit.assertEquals("Company's print preference for y alignment does not match", 
				info.getPrintPreferences().getYalignment(), infoFromDb.getPrintPreferences().getYalignment());
    }	
            
    //**********************************************************
    // Validation Tests - these only validate the basic validations at the composite layer.
    // Business logic validations and their tests are at the Capability layer.
    //***********************************************************
    
    
    @Test(expectedExceptions = ValidationException.class)
    public void nullCompanyInfoAddTest() throws Exception {
    	sEmployerService.saveCompanyInfo(null);
    }
}
