package com.intuit.sb.payroll.services.employer;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;

public class EmployerLegalTaxFilingInfoTest extends EmployerServiceTestBase {
   
	/**
     * This test saves a LegalTaxFilingInfo and retrieves and verifies it
     * @throws Exception
     */
    @Test
    public void testLegalTaxFilingInfo() throws Exception
    {
    	CompanyLegalTaxFilingInfo info = createCompanyLegalTaxFilingInfo(); 
        
    	//save the company
        sEmployerService.saveCompanyLegalTaxFilingInfo(info);
    	//now get back the company info and verify we got it all back
        CompanyLegalTaxFilingInfo infoFromDb = sEmployerService.getCompanyLegalTaxFilingInfo();
    	
    	AssertJUnit.assertEquals("Company Legal Tax Filing Info saved and retrieved does not match!", info, infoFromDb);
    	
        
    }	
            
    //**********************************************************
    // Validation Tests - these only validate the basic validations at the composite layer.
    // Business logic validations and their tests are at the Capability layer.
    //***********************************************************
    

    @Test(expectedExceptions = ValidationException.class)
    public void nullLegalTaxFilingInfoAddTest() throws Exception {
    	sEmployerService.saveCompanyLegalTaxFilingInfo(null);
    }

    @Test(expectedExceptions = ValidationException.class)
    public void emptyLegalTaxFilingInfoAddTest() throws Exception {
    	sEmployerService.saveCompanyLegalTaxFilingInfo(new CompanyLegalTaxFilingInfo());
    }


}
