package com.intuit.sb.payroll.services.employer;

import org.testng.AssertJUnit;

import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.entity.model.IndustryTypeEnum;
import com.intuit.sb.payroll.services.employer.impl.IndustryTypeMapper;

/**
 * These tests are for IndustryTypeMapper to test the mapping functionality is working correctly.
 * @author smadduri
 *
 */

@SuppressWarnings("static-access") 
public class IndustryTypeMapperTest
{
	private IndustryTypeMapper mock;
	
	@BeforeMethod
	public void setup()
	{
		mock = new IndustryTypeMapper();
	}
	
	@Test
	public void testMapIndustryType()
	{
		AssertJUnit.assertEquals(IndustryTypeEnum.ACCOMMODATION, mock.mapIndustryType(IndustryType.Accommodation));
		AssertJUnit.assertEquals(IndustryTypeEnum.ARTS_ENTERTAINMENT, mock.mapIndustryType(IndustryType.ArtsEntertainRec));
		AssertJUnit.assertEquals(IndustryTypeEnum.CONSTRUCTION, mock.mapIndustryType(IndustryType.Construction));
		AssertJUnit.assertEquals(IndustryTypeEnum.EDUCATION, mock.mapIndustryType(IndustryType.EducationalServices));
		AssertJUnit.assertEquals(IndustryTypeEnum.FINANCE_INSURANCE, mock.mapIndustryType(IndustryType.FinanceInsurance));
		AssertJUnit.assertEquals(IndustryTypeEnum.HEALTH_SOCIAL, mock.mapIndustryType(IndustryType.HealthCareSocialAssist));
		AssertJUnit.assertEquals(IndustryTypeEnum.MANAGEMENT, mock.mapIndustryType(IndustryType.ManagementCE));
		AssertJUnit.assertEquals(IndustryTypeEnum.MANUFACTURING, mock.mapIndustryType(IndustryType.Manufacturing));
		AssertJUnit.assertEquals(IndustryTypeEnum.NONPROFIT, mock.mapIndustryType(IndustryType.NonProfit));
		AssertJUnit.assertEquals(IndustryTypeEnum.OTHER, mock.mapIndustryType(IndustryType.OtherServices));
		AssertJUnit.assertEquals(IndustryTypeEnum.SCIENCE_TECHNICAL, mock.mapIndustryType(IndustryType.PSTServices));
		AssertJUnit.assertEquals(IndustryTypeEnum.GOVERNMENT, mock.mapIndustryType(IndustryType.PublicAdmin));
		AssertJUnit.assertEquals(IndustryTypeEnum.REAL_ESTATE, mock.mapIndustryType(IndustryType.RealEstateRentalLeasing));
		AssertJUnit.assertEquals(IndustryTypeEnum.RESTAURANT, mock.mapIndustryType(IndustryType.Restaurants));
		AssertJUnit.assertEquals(IndustryTypeEnum.RETAIL, mock.mapIndustryType(IndustryType.RetailTrade));
		AssertJUnit.assertEquals(IndustryTypeEnum.TRANSPORT_WAREHOUSE, mock.mapIndustryType(IndustryType.TransportWarehousing));
		AssertJUnit.assertEquals(IndustryTypeEnum.WHOLESALE, mock.mapIndustryType(IndustryType.WholesaleTrade));
		AssertJUnit.assertEquals(null, mock.mapIndustryType((IndustryType)null));
		
		//Code from here tests the reverse mappings
		AssertJUnit.assertEquals(IndustryType.Accommodation,mock.mapIndustryType(IndustryTypeEnum.ACCOMMODATION));
		AssertJUnit.assertEquals(IndustryType.ArtsEntertainRec, mock.mapIndustryType(IndustryTypeEnum.ARTS_ENTERTAINMENT));
		AssertJUnit.assertEquals(IndustryType.Construction, mock.mapIndustryType(IndustryTypeEnum.CONSTRUCTION));
		AssertJUnit.assertEquals(IndustryType.EducationalServices, mock.mapIndustryType(IndustryTypeEnum.EDUCATION));
		AssertJUnit.assertEquals(IndustryType.FinanceInsurance, mock.mapIndustryType(IndustryTypeEnum.FINANCE_INSURANCE));
		AssertJUnit.assertEquals(IndustryType.HealthCareSocialAssist, mock.mapIndustryType(IndustryTypeEnum.HEALTH_SOCIAL));
		AssertJUnit.assertEquals(IndustryType.ManagementCE, mock.mapIndustryType(IndustryTypeEnum.MANAGEMENT));
		AssertJUnit.assertEquals(IndustryType.Manufacturing, mock.mapIndustryType(IndustryTypeEnum.MANUFACTURING));
		AssertJUnit.assertEquals(IndustryType.NonProfit, mock.mapIndustryType(IndustryTypeEnum.NONPROFIT));
		AssertJUnit.assertEquals(IndustryType.OtherServices, mock.mapIndustryType(IndustryTypeEnum.OTHER));
		AssertJUnit.assertEquals(IndustryType.PSTServices, mock.mapIndustryType(IndustryTypeEnum.SCIENCE_TECHNICAL));
		AssertJUnit.assertEquals(IndustryType.PublicAdmin, mock.mapIndustryType(IndustryTypeEnum.GOVERNMENT));
		AssertJUnit.assertEquals(IndustryType.RealEstateRentalLeasing, mock.mapIndustryType(IndustryTypeEnum.REAL_ESTATE));
		AssertJUnit.assertEquals(IndustryType.Restaurants, mock.mapIndustryType(IndustryTypeEnum.RESTAURANT));
		AssertJUnit.assertEquals(IndustryType.RetailTrade, mock.mapIndustryType(IndustryTypeEnum.RETAIL));
		AssertJUnit.assertEquals(IndustryType.TransportWarehousing, mock.mapIndustryType(IndustryTypeEnum.TRANSPORT_WAREHOUSE));
		AssertJUnit.assertEquals(IndustryType.WholesaleTrade, mock.mapIndustryType(IndustryTypeEnum.WHOLESALE));
		AssertJUnit.assertEquals(null, mock.mapIndustryType(IndustryTypeEnum.NOTSET));
		AssertJUnit.assertEquals(null, mock.mapIndustryType((IndustryTypeEnum)null));
	}
}
