/**
 *
 */
package com.intuit.sb.payroll.services.taxes;


import java.util.List;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.common.BasicTestBase;
import com.intuit.sb.payroll.entity.model.AgencyIdType;
import com.intuit.sb.payroll.entity.model.EmployerId;
import com.intuit.sb.payroll.entity.model.EmployerIdTypeEnum;
import com.intuit.sb.payroll.services.taxes.impl.EmployerTaxIdMapper;

/**
 * @author dkulkarni
 *
 */
public class EmployerTaxIdMapperTest extends BasicTestBase
{

	/**
	 * Test method for {@link com.intuit.sb.payroll.services.taxes.impl.EmployerTaxIdMapper#mapToEmployerTaxIdInfo(com.intuit.sb.payroll.entity.model.EmployerId)}.
	 */
	@Test
	public void testMapToEmployerTaxIdInfo()
	{
		EmployerId employerId = new EmployerId();
		List<AgencyIdType>  agencyIdtypes = entityService.findAll(AgencyIdType.class);
		for (AgencyIdType agencyIdType : agencyIdtypes)
		{
			if(EmployerIdTypeEnum.EIN.equals(agencyIdType.getIdTypeKey()))
			{
				employerId.setAgencyIdType(agencyIdType);
				break;
			}
		}
		employerId.setValue("12-3456784");

		EmployerTaxIdInfo taxIdInfo = EmployerTaxIdMapper.mapToEmployerTaxIdInfo(employerId);
		AssertJUnit.assertNotNull(taxIdInfo);
		AssertJUnit.assertEquals(taxIdInfo.getTaxId(), employerId.getValue());
		AssertJUnit.assertEquals(taxIdInfo.getUniqueId().longValue(), employerId.getId());
		AssertJUnit.assertEquals(taxIdInfo.getTaxAgency().name, "US_IRS");
	}

}
