package com.intuit.sb.payroll.services.workerpayments;

import org.testng.AssertJUnit;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.entity.model.PayrollFrequencyEnum;
import com.intuit.sb.payroll.services.workerpayments.impl.PayrollFrequencyMapper;

/**
 * Tests the PayrollFrequencyMapper.
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */
public class PayrollFrequencyMapperTest
{

	@Test
	public void testMapBiWeeklyFromPojoToEntity()
	{
		PayrollScheduleFrequency payrollScheduleFrequency = PayrollScheduleFrequency.BIWEEKLY;
		PayrollFrequencyEnum actual = PayrollFrequencyMapper.mapFromEIToDEntity(payrollScheduleFrequency);
		AssertJUnit.assertEquals(PayrollFrequencyEnum.BIWEEKLY, actual);
	}

	@Test
	public void testMapMonthlyFromPojoToEntity()
	{
		PayrollScheduleFrequency payrollScheduleFrequency = PayrollScheduleFrequency.MONTHLY;
		PayrollFrequencyEnum actual = PayrollFrequencyMapper.mapFromEIToDEntity(payrollScheduleFrequency);
		AssertJUnit.assertEquals(PayrollFrequencyEnum.MONTHLY, actual);
	}

	@Test
	public void testMapSemiMonthlyFromPojoToEntity()
	{
		PayrollScheduleFrequency payrollScheduleFrequency = PayrollScheduleFrequency.SEMIMONTHLY;
		PayrollFrequencyEnum actual = PayrollFrequencyMapper.mapFromEIToDEntity(payrollScheduleFrequency);
		AssertJUnit.assertEquals(PayrollFrequencyEnum.SEMIMONTHLY, actual);
	}

	@Test
	public void testMapWeeklyFromPojoToEntityi()
	{
		PayrollScheduleFrequency payrollScheduleFrequency = PayrollScheduleFrequency.WEEKLY;
		PayrollFrequencyEnum actual = PayrollFrequencyMapper.mapFromEIToDEntity(payrollScheduleFrequency);
		AssertJUnit.assertEquals(PayrollFrequencyEnum.WEEKLY, actual);
	}

	@Test
	public void testMapNullFromPojoToEntity()
	{
		PayrollScheduleFrequency payrollScheduleFrequency = null;
		PayrollFrequencyEnum actual = PayrollFrequencyMapper.mapFromEIToDEntity(payrollScheduleFrequency);
		AssertJUnit.assertEquals(null, actual);
	}
}