package com.intuit.sb.payroll.entity;

import java.util.MissingResourceException;

import com.intuit.sb.payroll.common.i18n.LocaleGuru;

/**
 * Helper class to retrieve the resources for the Entity component.
 *
 * $Author$ 
 * $Revision$
 * $DateTime$
 */
@SuppressWarnings("nls")
public class EntityResources {

	private static final String BUNDLE_NAME = "com.intuit.sb.payroll.entity.entity-resources"; //$NON-NLS-1$

	private EntityResources() {
	}

	public static String getString(String key) {
		try {
			 return LocaleGuru.getInstance().getString(BUNDLE_NAME, key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
