package com.intuit.sb.payroll.entity.benefits;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.HealthBenefit;
import com.intuit.sb.payroll.entity.model.HealthBenefitTypeEnum;

@Local
public interface HealthBenefitEAO extends GenericEAO<HealthBenefit> {
	
	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "HealthBenefitEAO/local";

	/**
	 * Find a HealthBenefit of a specific healthBenefit type.
	 * @param healthBenefitType the type of the healthBenefit to find.
	 * @return the healthBenefit entity.
	 */
	public HealthBenefit findHealthBenefit(HealthBenefitTypeEnum healthBenefitType);
	

}
