package com.intuit.sb.payroll.entity.deductions;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.Deduction;
import com.intuit.sb.payroll.entity.model.DeductionTypeEnum;

@Local
public interface DeductionEAO extends GenericEAO<Deduction> {
	
	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "DeductionEAO/local";

	/**
	 * Find a Deduction of a specific deduction type.
	 * @param deductionType the type of the deduction to find.
	 * @return the deduction entity.
	 */
	public Deduction findDeduction(DeductionTypeEnum deductionType);
	

}
