package com.intuit.sb.payroll.entity.employer;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.Employer;

@Local
public interface EmployerEAO extends GenericEAO<Employer> {
	
	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "EmployerEAO/local";
	
	/**
	 * Returns the instance of the current employer (assumes a VPD environment where there is one and only one 
	 * Company per Realm).
	 * @return the current {@link Employer}, or null if the employer does not exist.
	 */
	public Employer findCurrentEmployer();

}
