package com.intuit.sb.payroll.entity.employer;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.WorkLocation;

@Local
public interface WorkLocationEAO extends GenericEAO<WorkLocation> {

	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "WorkLocationEAO/local";
	
	/**
	 * Returns the count of WorkLocations for the current Employer.
	 * @return the number of WorkLocations.
	 */
	public int getWorkLocationCount();

	public int getWorkerCountForWorkLocation(WorkLocation workLocation);

}
