package com.intuit.sb.payroll.entity.employer.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.NamedQueryCatalog;
import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.entity.employer.EmployerAdjustmentEAO;
import com.intuit.sb.payroll.entity.model.DateRange;
import com.intuit.sb.payroll.entity.model.EmployerAdjustment;

@Stateless(name="EmployerAdjustmentEAO")
@TransactionManagement(TransactionManagementType.CONTAINER) // Use CMT
@TransactionAttribute(TransactionAttributeType.MANDATORY) 
@SecurityDomain("BHPIAM")
@RolesAllowed({"Authenticated"})
public final class EmployerAdjustmentEjbEAO extends GenericEjbEAO<EmployerAdjustment>
	implements EmployerAdjustmentEAO {

	public List<EmployerAdjustment> findEmployerAdjustmentsInRange(DateRange dateRange) {
        Map<String, Object> queryParameters = new HashMap<String, Object>();
        queryParameters.put(NamedQueryCatalog.START_DATE_QUERY_PARAM, dateRange.getStartDate());
        queryParameters.put(NamedQueryCatalog.END_DATE_QUERY_PARAM, dateRange.getEndDate());
        
		List<EmployerAdjustment> results = null;
		try {
			results = this.findByNamedQuery(NamedQueryCatalog.FIND_EMPLOYER_ADJUSTMENTS_IN_RANGE, queryParameters);
		} catch (RuntimeException ex) {
			handleExceptionMightBeOLE(ex);
		}
		return results;
	}


}
