package com.intuit.sb.payroll.entity.taxes;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.Tax;

/**
 * EAO operations for {@link Tax Tax} entities.
 * This class isolates all persistence concerns for Tax entities from
 * business logic. It provides all the CRUD operations on {@code Tax}
 * and its related entities.
 * 
 * @see Tax
 *
 * $Author: jzhong $
 * $Revision: #1 $
 * $DateTime: 2008/08/15 17:27:47 $
 *
 */
@Local
public interface TaxEAO extends GenericEAO<Tax> {
	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "TaxEAO/local";
    /**
     * Finds the Tax with the specified lawId.
     * @param lawId the lawId of the Tax we're finding
     * @return the Tax for the specified lawId
     */
    public Tax findTaxByLawId(String lawId);
}
