package com.intuit.sb.payroll.entity.wages;

import java.util.List;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.CompensationDtl;

@Local
public interface CompensationDtlEAO extends GenericEAO<CompensationDtl> {
	
	public static final String JNDI_NAME =  "CompensationDtlEAO/local";

	/**
	 * Find the CompensationDtls that link to the given compensationDtl
	 * @param compensationDtl
	 * @return the List of CompensationDtls linked to the given compensationDtl
	 */
	public List<CompensationDtl> findLinkedCompensationDtls(CompensationDtl compensationDtl);
}
