package com.intuit.sb.payroll.entity.workerpayments;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.eao.GenericEAO;
import com.intuit.sb.payroll.entity.model.Paycheck;
import com.intuit.sb.payroll.entity.model.Worker;

@Local
public interface PaycheckEAO extends GenericEAO<Paycheck> {

	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "PaycheckEAO/local";

	/**
	 * Finds the most recent paycheck 'issued' to a worker. The paycheck may
	 * not have have been physically issued but it is part of the most recent
	 * committed payroll run that includes this worker.
	 * 
	 * 'Most recent' is based on paycheck transaction date. The presumption is
	 * a worker can't have more than one paycheck created within a millisecond.
	 * 
	 * @param worker the worker whose most recent paycheck we need to find.
	 * @return the paycheck or null if the worker has no paychecks.
	 */
	public Paycheck findMostRecentPaycheckForWorker(Worker worker);
}
