package com.intuit.sb.payroll.entity.workerpayments;

import java.util.Set;

import javax.ejb.Local;

import com.intuit.sb.payroll.entity.model.DateRange;
import com.intuit.sb.payroll.entity.model.PayrollItemDtl;
import com.intuit.sb.payroll.entity.model.Worker;

/**
 * Serves the needs of queries and operations that span multiple
 * entities and do not have a home in an EAO.
 * 
 * $Author: $ 
 * $Revision: $
 * $DateTime: $
 *
 */
@Local
public interface WorkerPaymentsDataService {

	@SuppressWarnings("nls")
	public static final String JNDI_NAME =  "WorkerPaymentsDataService/local";
	
	/**
	 * Updates the PeriodToDate Data on all the {@link PayrollItemDtl}s for the {@link Worker}.
	 * @param worker
	 * @return
	 */
	public Worker updatePtdsForWorker(Worker worker, DateRange period);
	
	public Set<WorkerTotals> getEmployeeTotalsForCompany();
}
