package com.intuit.sb.payroll.pts.entity.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.pts.entity.PTSPayrollRun;
import com.intuit.sb.payroll.pts.entity.PTSPayrollRunEAO;

@Stateless(name = "PTSPayrollRunEAO")
@TransactionManagement(TransactionManagementType.CONTAINER)
// Use CMT
// Clients must start the Txn so multiple EAO calls in a single request are within a single txn
@TransactionAttribute(TransactionAttributeType.MANDATORY)
@SecurityDomain("BHPIAM")
@RolesAllowed( { "Authenticated" })
public class PTSPayrollRunEjbEAO extends GenericEjbEAO<PTSPayrollRun> implements PTSPayrollRunEAO {

	public PTSPayrollRun findPTSPayrollRunByPayrollRunId(Long payrollRunId) {
		Map<String, Object> queryParameters = new HashMap<String, Object>();
        queryParameters.put("payrollRunId", payrollRunId);
        
        List<PTSPayrollRun> results = null;
		try
		{
			results = findByNamedQuery("findPTSPayrollRunByPayrollRunId", queryParameters);
		}
		catch(RuntimeException ex)
		{
			handleExceptionMightBeOLE(ex);
		}
		//There can be only 1 PTSPayrollRun for a payrollRunId
		if(results.size() > 0) {
			return results.get(0);
		}
		return null;
	}

}
