package com.intuit.sb.payroll.takehome.entity.impl;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.jboss.annotation.security.SecurityDomain;

import com.intuit.sb.payroll.entity.eao.ejb.GenericEjbEAO;
import com.intuit.sb.payroll.takehome.entity.TakehomeReportsEAO;

/**
 * Implements the generic CRUD data access operations 

 * @param TakehomeCompany the concrete extension of {@code BaseEntity} that implements the entity
 * managed by this EAO. 
 * 
 * @see GenericEjbEAO
 */

@Stateless(name="TakehomeReportsEAO")
@TransactionManagement(TransactionManagementType.CONTAINER)
@TransactionAttribute(TransactionAttributeType.REQUIRED) 
@SecurityDomain("BHPIAM")
@RolesAllowed({"Authenticated"})
public final class TakehomeReportsEjbEAO implements TakehomeReportsEAO {
	//private static final Logger logger = PayrollLoggerFactory.makeLogger(GenericEAO.class);
    
    // Inject an entity manager instance for our data source
    @PersistenceContext(unitName = "payrollDB") 
    private EntityManager mEntityManager;
    
    /**
     * Gets the EJB3 {@code EntityManager} being used by this EAO.
     * This is not part of the {@code GenericEAO} interface because
     * @{code EntityManager} is an EJB3 concept and isn't generic to all
     * persistence providers.
     * @return The {@code EntityManager} used to access the DB.
     */
    public EntityManager getEntityManager()
    {
        return mEntityManager;
    }
}
