
    
    --
    -- VPD Twin-schema deployment - "&&1" schema
    -- 
    
	--
    -- Generated using Intuit's Oracle VPD DDL Xpand template
    --
    -- Create sequences
    
DECLARE 
	SEQUENCE_EXISTS PLS_INTEGER :=0;
BEGIN
	SELECT COUNT(*) INTO SEQUENCE_EXISTS
	FROM USER_SEQUENCES
	WHERE SEQUENCE_NAME = 'HIBERNATE_SEQUENCE';
	IF SEQUENCE_EXISTS = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE "HIBERNATE_SEQUENCE" MINVALUE 0 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 21 CACHE 20 NOORDER NOCYCLE';
	END IF;
END;
/

    -- Create tables 
    
    
    
	CREATE TABLE PTSMESSAGE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		MESSAGECODE VARCHAR2(100) NULL,
		MESSAGEDESCRIPTION VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		ACTIVATIONSTATE NUMBER(20,0) NULL,
		RAAENROLLMENTSTATE NUMBER(20,0) NULL,
		EFTPSENROLLMENTSTATE NUMBER(20,0) NULL,
		RAFENROLLMENTSTATE NUMBER(20,0) NULL,
		ACHENROLLMENTSTATE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE W4DETAIL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ISINCOMETAXEXEMPT CHAR(1) NULL,
		NOOFALLOWANCES NUMBER(10,0) NULL,
		ADDITIONALAMOUNT_CUR VARCHAR2(100) NULL,
		ADDITIONALAMOUNT_AMT NUMBER(19,4) NULL,
		WITHHOLDINGSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL	)
/
    



	CREATE TABLE W9DETAIL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ISBACKUPWITHHOLDINGEXEMPT CHAR(1) NULL,
		PERCENTAGERATE_CUR VARCHAR2(100) NULL,
		PERCENTAGERATE_AMT NUMBER(19,4) NULL	)
/
    



	CREATE TABLE PTSWORKFLOWSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL
,UNIQUE(TAXSERVICESTATE)	)
/
    



	CREATE TABLE TAKEHOMECOMPANY (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAYROLLEMPLOYERID NUMBER(20,0) NULL,
		PRINTPREFERENCES_XALIGNMENT NUMBER(10,0) NULL,
		PRINTPREFERENCES_YALIGNMENT NUMBER(10,0) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE PTSEMPLOYER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYER NUMBER(20,0) NULL
,UNIQUE(EMPLOYER),
		PTSWORKFLOWSTATE NUMBER(20,0) NOT NULL
,UNIQUE(PTSWORKFLOWSTATE)	)
/
    



	CREATE TABLE DE4DETAIL (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ISINCOMETAXEXEMPT CHAR(1) NULL,
		NOOFALLOWANCES NUMBER(10,0) NULL,
		NOOFDEDUCTIONS NUMBER(10,0) NULL,
		ADDITIONALAMOUNT_CUR VARCHAR2(100) NULL,
		ADDITIONALAMOUNT_AMT NUMBER(19,4) NULL,
		WITHHOLDINGSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL	)
/
    



	CREATE TABLE EFTPSENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		EFTPSENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE EMPPTSSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		STATUSDATE TIMESTAMP NULL,
		EMPLOYEEID NUMBER(20,0) NULL,
		PTSSTATE VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE TAXSERVICESTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE RAAENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		RAAENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE TAKEHOMEWORKER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAYROLLWORKERID NUMBER(20,0) NULL,
		AVATAR VARCHAR2(100) NULL,
		WORKERIMAGE BLOB NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    



	CREATE TABLE RAFENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		RAFENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE PTSCONTACTPERSON (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CONTACTPERSONTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		PAYROLLEMPLOYERCONTACTPERSONID NUMBER(20,0) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYERCONTACT NUMBER(20,0) NOT NULL
,UNIQUE(EMPLOYERCONTACT),
		PTSEMPLOYER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE BANKACCOUNTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		BANKACCOUNT NUMBER(20,0) NOT NULL
,UNIQUE(BANKACCOUNT),
		PTSEMPLOYER NUMBER(20,0) NULL	)
/
    



	CREATE TABLE ACHENROLLMENTSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ACHENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE ACTIVATIONSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		AGENCY VARCHAR2(100) NULL,
		ACTIVATIONSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUSDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL	)
/
    



	CREATE TABLE CAWAGEPLAN (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		VALUE VARCHAR2(100) NULL	)
/
    


    

    
	ALTER TABLE EMPLOYERADJUSTMENT ADD (
		USPAYROLLRUN NUMBER(20,0) NULL		)
	/





    
    
ALTER TABLE EMPLOYERADJUSTMENT 
	ADD CONSTRAINT USEMPADJ_FK_USPRUN 
	FOREIGN KEY (USPAYROLLRUN) 
	REFERENCES PAYROLLRUN (ID)
/

    
    
    
    
    
    
    
    
    
    -- Functions
    
    
    
ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_ACTIVATIONSTATE 
	FOREIGN KEY (ACTIVATIONSTATE) 
	REFERENCES ACTIVATIONSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_ACHSTATE 
	FOREIGN KEY (ACHENROLLMENTSTATE) 
	REFERENCES ACHENROLLMENTSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT RAASTATE_FK_PTSMESSAGE 
	FOREIGN KEY (RAAENROLLMENTSTATE) 
	REFERENCES RAAENROLLMENTSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_EFTPSSTATE 
	FOREIGN KEY (EFTPSENROLLMENTSTATE) 
	REFERENCES EFTPSENROLLMENTSTATE (ID)
/

ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_RAFSTATE 
	FOREIGN KEY (RAFENROLLMENTSTATE) 
	REFERENCES RAFENROLLMENTSTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSMESSAGE_VT" 
    BEFORE INSERT OR UPDATE ON "PTSMESSAGE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "W4DETAIL_VT" 
    BEFORE INSERT OR UPDATE ON "W4DETAIL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "W9DETAIL_VT" 
    BEFORE INSERT OR UPDATE ON "W9DETAIL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE PTSWORKFLOWSTATE 
	ADD CONSTRAINT PTSWFSTATE_FK_PTSASSISTEDSTATE 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSWORKFLOWSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "PTSWORKFLOWSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAKEHOMECOMPANY_VT" 
    BEFORE INSERT OR UPDATE ON "TAKEHOMECOMPANY" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    




ALTER TABLE PTSEMPLOYER 
	ADD CONSTRAINT PTSWFSTATE_FK_PTSEMP 
	FOREIGN KEY (PTSWORKFLOWSTATE) 
	REFERENCES PTSWORKFLOWSTATE (ID)
/

ALTER TABLE PTSEMPLOYER 
	ADD CONSTRAINT PTSEMPLOYER_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSEMPLOYER_VT" 
    BEFORE INSERT OR UPDATE ON "PTSEMPLOYER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "DE4DETAIL_VT" 
    BEFORE INSERT OR UPDATE ON "DE4DETAIL" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EFTPSENROLLMENTSTATE 
	ADD CONSTRAINT EFTPSENRST_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "EFTPSENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "EFTPSENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE EMPPTSSTATE 
	ADD CONSTRAINT EMPPTSSTATE_FK_TAXSERVICESTATE 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "EMPPTSSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "EMPPTSSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAXSERVICESTATE_VT" 
    BEFORE INSERT OR UPDATE ON "TAXSERVICESTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE RAAENROLLMENTSTATE 
	ADD CONSTRAINT RAASTATE_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "RAAENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "RAAENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAKEHOMEWORKER_VT" 
    BEFORE INSERT OR UPDATE ON "TAKEHOMEWORKER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE RAFENROLLMENTSTATE 
	ADD CONSTRAINT RAFSTATE_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "RAFENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "RAFENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE PTSCONTACTPERSON 
	ADD CONSTRAINT PTSEMP_FK_PTSCONTACT 
	FOREIGN KEY (PTSEMPLOYER) 
	REFERENCES PTSEMPLOYER (ID)
/

ALTER TABLE PTSCONTACTPERSON 
	ADD CONSTRAINT PTSCONTACT_FK_EMPCONTACT 
	FOREIGN KEY (EMPLOYERCONTACT) 
	REFERENCES CONTACTPERSON (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSCONTACTPERSON_VT" 
    BEFORE INSERT OR UPDATE ON "PTSCONTACTPERSON" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE BANKACCOUNTSTATE 
	ADD CONSTRAINT PTSEMP_FK_BANKACTSTATE 
	FOREIGN KEY (PTSEMPLOYER) 
	REFERENCES PTSEMPLOYER (ID)
/

ALTER TABLE BANKACCOUNTSTATE 
	ADD CONSTRAINT BANKACT_FK_PTSBANKSTATE 
	FOREIGN KEY (BANKACCOUNT) 
	REFERENCES BANKACCOUNT (ID)
/

    
    CREATE or REPLACE TRIGGER "BANKACCOUNTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "BANKACCOUNTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE ACHENROLLMENTSTATE 
	ADD CONSTRAINT ACHSTATE_FK_PTSASSISTEDST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "ACHENROLLMENTSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "ACHENROLLMENTSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE ACTIVATIONSTATE 
	ADD CONSTRAINT TAXSVCSTATE_FK_ACTIVSTATE 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "ACTIVATIONSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "ACTIVATIONSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "CAWAGEPLAN_VT" 
    BEFORE INSERT OR UPDATE ON "CAWAGEPLAN" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    

    -- Synonyms
    
    -- Grants
    
	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSMESSAGE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON W4DETAIL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON W9DETAIL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSWORKFLOWSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAKEHOMECOMPANY TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSEMPLOYER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON DE4DETAIL TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EFTPSENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON EMPPTSSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAXSERVICESTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON RAAENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAKEHOMEWORKER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON RAFENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSCONTACTPERSON TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON BANKACCOUNTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON ACHENROLLMENTSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON ACTIVATIONSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON CAWAGEPLAN TO &&2
	/


	GRANT SELECT ON HIBERNATE_SEQUENCE TO &&2
	/

  
    
	--
    -- Table permissions for the VPD internal-to-external mapping table
    --
    GRANT SELECT,INSERT,UPDATE ON SBCORE_VPD_TABLE TO &&2
    /
    --
    -- Permission for VPD SEQ
    --
    GRANT SELECT ON SBCORE_VPD_SEQ TO &&2
    /
        
 

    
DECLARE
  table_exists PLS_INTEGER;
  row_exists PLS_INTEGER;

  INSERT_CMD VARCHAR2(255);
  ROWCHECK_CMD VARCHAR2(255);
  UPDATE_CMD VARCHAR2(255);

BEGIN
  SELECT COUNT(*) INTO table_exists
  FROM "USER_TABLES"
  WHERE TABLE_NAME = 'PROJECT_VERSIONS_TABLE';
  IF table_exists = 1 THEN 
  
    SELECT 'SELECT COUNT(*)  FROM PROJECT_VERSIONS_TABLE WHERE PROJECT_ID=''_FY5ioOECEd2RxJXjYkjWBw'''   
    INTO ROWCHECK_CMD
    FROM DUAL;
    EXECUTE IMMEDIATE ROWCHECK_CMD INTO row_exists;   
   
    IF row_exists = 1 THEN    
        SELECT 'UPDATE PROJECT_VERSIONS_TABLE SET MODEL_VERSION='''',SCHEMA_VERSION=''1.0.23'',TIMESTAMP=''2009-05-01 19:02:30.856'' WHERE PROJECT_ID=''_FY5ioOECEd2RxJXjYkjWBw'''
        INTO UPDATE_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE UPDATE_CMD;
    ELSE
        SELECT 'INSERT INTO PROJECT_VERSIONS_TABLE (PROJECT_NAME,PROJECT_ID,MODEL_VERSION,SCHEMA_VERSION,TIMESTAMP) VALUES (''geminius'',''_FY5ioOECEd2RxJXjYkjWBw'','''',''1.0.23'',''2009-05-01 19:02:30.856'')' 
        INTO INSERT_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE INSERT_CMD;
    END IF;   
  END IF;
END;
/

    