	
    --
    -- VPD Twin-schema deployment - "APP" schema
    -- consisting of SYNONYMs and POLICY defintions
    --
DECLARE
	synonym_exists PLS_INTEGER;
  	object_exists PLS_INTEGER;
  	abort_run PLS_INTEGER := 0;
  	target_table_name VARCHAR(1024);
  	create_command VARCHAR2(1024);
  	grant_command VARCHAR2(1024);
  	drop_command VARCHAR(1024);
  	synonym_command VARCHAR2(1024);
  	BEGIN   
 		
	--
	-- check for the existence of the system table/sequence defintions from the APP schema as 
	-- this schema should only contain synonyms
	--
	--
	-- check for SBCORE_VPD_TABLE
	--
	SELECT COUNT(*) INTO object_exists
    FROM "USER_TABLES"
    WHERE TABLE_NAME = 'SBCORE_VPD_TABLE';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP TABLE "SBCORE_VPD_TABLE" CASCADE CONSTRAINTS';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20500, 'SBCORE_VPD_TABLE exists in APP schema, please drop this TABLE and rerun this script.');
    END IF;	
    --
   	-- check for PROJECT_VERSIONS_TABLE
   	--
    SELECT COUNT(*) INTO object_exists
    FROM "USER_TABLES"
    WHERE TABLE_NAME = 'PROJECT_VERSIONS_TABLE';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP TABLE "PROJECT_VERSIONS_TABLE'" CASCADE CONSTRAINTS';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20501, 'PROJECT_VERSIONS_TABLE exists in APP schema, please drop this TABLE and rerun this script.');
    END IF;	
  	--
  	-- check for SBCORE_VPD_SEQ
  	--
    SELECT COUNT(*) INTO object_exists
    FROM "USER_SEQUENCES"
    WHERE SEQUENCE_NAME = 'SBCORE_VPD_SEQ';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP SEQUENCE "SBCORE_VPD_SEQ"';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20502, 'SBCORE_VPD_SEQ exists in APP schema, please drop this SEQUENCE and rerun this script.');
    END IF;	
  	--
  	-- check for HIBERNATE_SEQUENCE
  	--
    SELECT COUNT(*) INTO object_exists
    FROM "USER_SEQUENCES"
    WHERE SEQUENCE_NAME = 'HIBERNATE_SEQUENCE';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP SEQUENCE "HIBERNATE_SEQUENCE"';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20503, 'HIBERNATE_SEQUENCE exists in APP schema, please drop this SEQUENCE and rerun this script.');     
    END IF;
    --
    -- check for HIBERNATE_SEQ
    --
    SELECT COUNT(*) INTO object_exists
    FROM "USER_SEQUENCES"
    WHERE SEQUENCE_NAME = 'HIBERNATE_SEQ';
    IF object_exists = 1 THEN
      --EXECUTE IMMEDIATE 'DROP SEQUENCE "HIBERNATE_SEQ"';
      abort_run := 1;
      RAISE_APPLICATION_ERROR(-20504, 'HIBERNATE_SEQ exists in APP schema, please drop this SEQUENCE and rerun this script.');    
    END IF;
    --
    	
	IF abort_run = 0 THEN
    	--
    	-- Create synonyms to non-generated artifacts that are needed to support
    	-- the VPD implementation
    	-- 
    	-- VPD internal to external realm-i lookup table
    	-- 
    	
		target_table_name := '&&1' || '.SBCORE_VPD_TABLE';
		create_command := 'CREATE OR REPLACE SYNONYM SBCORE_VPD_TABLE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

	  	--
	  	-- vpd sequence generator for realm-ids
	  	--
    	
		target_table_name := '&&1' || '.SBCORE_VPD_SEQ';
		create_command := 'CREATE OR REPLACE SYNONYM SBCORE_VPD_SEQ FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

	  	--
	    --anduril schema version info table
	    --
    	
		target_table_name := '&&1' || '.PROJECT_VERSIONS_TABLE';
		create_command := 'CREATE OR REPLACE SYNONYM PROJECT_VERSIONS_TABLE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

		--
    END IF;
    	
	--
    -- Generated using Intuit's Oracle VPD DDL Xpand template
    --
    -- Create sequences
    
    -- Create tables 
    
    
    
    

    
    
    -- Functions
    
    
    

    -- Synonyms
    
    
		target_table_name := '&&1' || '.TAKEHOMECOMPANY';
		create_command := 'CREATE OR REPLACE SYNONYM TAKEHOMECOMPANY FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.BANKACCOUNTSTATE';
		create_command := 'CREATE OR REPLACE SYNONYM BANKACCOUNTSTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.ACTIVATIONSTATE';
		create_command := 'CREATE OR REPLACE SYNONYM ACTIVATIONSTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.NOTIFICATIONSTATUSENTITY';
		create_command := 'CREATE OR REPLACE SYNONYM NOTIFICATIONSTATUSENTITY FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PTSCONTACTPERSON';
		create_command := 'CREATE OR REPLACE SYNONYM PTSCONTACTPERSON FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.TAXCREDIT';
		create_command := 'CREATE OR REPLACE SYNONYM TAXCREDIT FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.TAKEHOMEWORKER';
		create_command := 'CREATE OR REPLACE SYNONYM TAKEHOMEWORKER FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.RAFENROLLMENTSTATE';
		create_command := 'CREATE OR REPLACE SYNONYM RAFENROLLMENTSTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PTSPAYROLLRUN';
		create_command := 'CREATE OR REPLACE SYNONYM PTSPAYROLLRUN FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.STATEIDMODIFIED';
		create_command := 'CREATE OR REPLACE SYNONYM STATEIDMODIFIED FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PPSPTSINTERACTION';
		create_command := 'CREATE OR REPLACE SYNONYM PPSPTSINTERACTION FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PTSWORKFLOWSTATE';
		create_command := 'CREATE OR REPLACE SYNONYM PTSWORKFLOWSTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PTSMESSAGE';
		create_command := 'CREATE OR REPLACE SYNONYM PTSMESSAGE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.PTSEMPLOYER';
		create_command := 'CREATE OR REPLACE SYNONYM PTSEMPLOYER FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.ACHENROLLMENTSTATE';
		create_command := 'CREATE OR REPLACE SYNONYM ACHENROLLMENTSTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.EFTPSENROLLMENTSTATE';
		create_command := 'CREATE OR REPLACE SYNONYM EFTPSENROLLMENTSTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.RAAENROLLMENTSTATE';
		create_command := 'CREATE OR REPLACE SYNONYM RAAENROLLMENTSTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.TAXSERVICESTATE';
		create_command := 'CREATE OR REPLACE SYNONYM TAXSERVICESTATE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    
		target_table_name := '&&1' || '.HIBERNATE_SEQUENCE';
		create_command := 'CREATE OR REPLACE SYNONYM HIBERNATE_SEQUENCE FOR ' || target_table_name;
		EXECUTE IMMEDIATE create_command;

    
    -- Grants
    
  
    	IF abort_run = 0 THEN
    	--
    	-- Apply VPD policies to all Entity synonyms (no need to apply to JOIN synonyms)
    	--
  			BEGIN
    			

		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'TAKEHOMECOMPANY'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'TAKEHOMECOMPANY',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'BANKACCOUNTSTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'BANKACCOUNTSTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'ACTIVATIONSTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'ACTIVATIONSTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'NOTIFICATIONSTATUSENTITY'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'NOTIFICATIONSTATUSENTITY',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PTSCONTACTPERSON'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PTSCONTACTPERSON',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'TAXCREDIT'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'TAXCREDIT',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'TAKEHOMEWORKER'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'TAKEHOMEWORKER',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'RAFENROLLMENTSTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'RAFENROLLMENTSTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PTSPAYROLLRUN'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PTSPAYROLLRUN',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'STATEIDMODIFIED'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'STATEIDMODIFIED',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PPSPTSINTERACTION'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PPSPTSINTERACTION',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PTSWORKFLOWSTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PTSWORKFLOWSTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PTSMESSAGE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PTSMESSAGE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'PTSEMPLOYER'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'PTSEMPLOYER',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'ACHENROLLMENTSTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'ACHENROLLMENTSTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'EFTPSENROLLMENTSTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'EFTPSENROLLMENTSTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'RAAENROLLMENTSTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'RAAENROLLMENTSTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



		SELECT count(*) 
		INTO object_exists
		FROM USER_POLICIES
		WHERE OBJECT_NAME = 'TAXSERVICESTATE'
		AND PACKAGE='SBCORE_VPD_POLICY_PKG';
		--
		-- only create policy if it doesn't exist
		--
		IF object_exists = 0 THEN
			DBMS_RLS.ADD_POLICY(
				object_schema => USER,
				object_name => 'TAXSERVICESTATE',
				policy_name => 'SBCORE_VPD_POLICY_PKG',
				function_schema => USER,
				policy_function => 'SBCORE_VPD_POLICY_PKG.GENERATE_PREDICATES',
				statement_types => 'SELECT, INSERT, UPDATE, DELETE',
				update_check => TRUE,
				enable => TRUE,
				static_policy => FALSE);
		END IF;



  
  			END;
  		END IF;
  	END;
  	/
