ALTER TABLE STATEIDMODIFIED DROP CONSTRAINT STATEIDMODIFIED_FK_PTSEMPLOYER
/

DROP INDEX STATEIDMODIFIED_FK_PTSEMPLOYER
/

    -- WARNING: DESTRUCTIVE OPERATION NOT INCLUDED: Remove column PTSEMPLOYER from table STATEIDMODIFIED

CREATE TABLE PTSPAYROLLRUN (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    DDDEBITAMOUNT NUMBER(19,4) NULL, 
    DEBITAMOUNT NUMBER(19,4) NULL, 
    TAXDEBITAMOUNT NUMBER(19,4) NULL, 
    SETTLEMENTDATE TIMESTAMP NULL, 
    PAYROLLRUNID NUMBER(20,0) NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL
)
/

CREATE INDEX PTSPAYROLLRUN_RX ON PTSPAYROLLRUN(REALM_ID ASC)
/

CREATE OR REPLACE TRIGGER "PTSPAYROLLRUN_VT" BEFORE INSERT OR UPDATE ON "PTSPAYROLLRUN"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/


CREATE TABLE TAXCREDIT (
    PRIMARY KEY(ID),
    ID NUMBER(20,0) NOT NULL, 
    REALM_ID NUMBER(20,0) DEFAULT -1 NOT NULL, 
    TAXCREDITPAYROLLRUNID NUMBER(20,0) NULL, 
    TAXCREDITAMOUNT NUMBER(19,4) NULL, 
    CREATIONDATE TIMESTAMP NULL, 
    CREATEDBY VARCHAR2(100) NULL, 
    LASTMODIFICATIONDATE TIMESTAMP NULL, 
    LASTMODIFIEDBY VARCHAR2(100) NULL, 
    VERSION NUMBER(20,0) NOT NULL, 
    UUID VARCHAR2(255) NOT NULL, 
    PTSPAYROLLRUN NUMBER(20,0) NULL
)
/

CREATE INDEX TAXCREDIT_RX ON TAXCREDIT(REALM_ID ASC)
/

CREATE INDEX TAXCREDIT_FK_PTSPAYROLLRUN ON TAXCREDIT(PTSPAYROLLRUN ASC)
/

ALTER TABLE TAXCREDIT ADD CONSTRAINT TAXCREDIT_FK_PTSPAYROLLRUN
    FOREIGN KEY (PTSPAYROLLRUN)
    REFERENCES PTSPAYROLLRUN (ID)
/

CREATE OR REPLACE TRIGGER "TAXCREDIT_VT" BEFORE INSERT OR UPDATE ON "TAXCREDIT"
    FOR EACH ROW
    BEGIN
     IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 
    END;
/


ALTER TABLE STATEIDMODIFIED ADD (ACTIVE CHAR(1) NULL)
/

GRANT SELECT, INSERT, UPDATE, DELETE ON PTSPAYROLLRUN TO &&2
/

GRANT SELECT, INSERT, UPDATE, DELETE ON TAXCREDIT TO &&2
/

UPDATE PROJECT_VERSIONS_TABLE SET SCHEMA_VERSION='1.0.26', TIMESTAMP='2009-06-03 15:35:43.521' WHERE PROJECT_ID='_FY5ioOECEd2RxJXjYkjWBw'
/

