
    
    --
    -- VPD Twin-schema deployment - "&&1" schema
    -- 
    
	--
    -- Generated using Intuit's Oracle VPD DDL Xpand template
    --
    -- Create sequences
    
DECLARE 
	SEQUENCE_EXISTS PLS_INTEGER :=0;
BEGIN
	SELECT COUNT(*) INTO SEQUENCE_EXISTS
	FROM USER_SEQUENCES
	WHERE SEQUENCE_NAME = 'HIBERNATE_SEQUENCE';
	IF SEQUENCE_EXISTS = 0 THEN
		EXECUTE IMMEDIATE 'CREATE SEQUENCE "HIBERNATE_SEQUENCE" MINVALUE 0 MAXVALUE 999999999999999999999999999 INCREMENT BY 1 START WITH 21 CACHE 20 NOORDER NOCYCLE';
	END IF;
END;
/

    -- Create tables 
    
    
    
	CREATE TABLE TAKEHOMECOMPANY (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAYROLLEMPLOYERID NUMBER(20,0) NULL,
		PRINTPREFERENCES_XALIGNMENT NUMBER(10,0) NULL,
		PRINTPREFERENCES_YALIGNMENT NUMBER(10,0) NULL,
		COMPANYLOGO BLOB NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "TAKEHOMECOMPANY_RX" ON TAKEHOMECOMPANY (REALM_ID ASC)
/	



	CREATE TABLE TAKEHOMEWORKER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		PAYROLLWORKERID NUMBER(20,0) NULL,
		AVATAR VARCHAR2(100) NULL,
		WORKERIMAGE BLOB NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "TAKEHOMEWORKER_RX" ON TAKEHOMEWORKER (REALM_ID ASC)
/	



	CREATE TABLE TAXSERVICESTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "TAXSERVICESTATE_RX" ON TAXSERVICESTATE (REALM_ID ASC)
/	



	CREATE TABLE PTSCONTACTPERSON (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CONTACTPERSONTYPE VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		PAYROLLEMPLOYERCONTACTPERSONID NUMBER(20,0) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		EMPLOYERCONTACT NUMBER(20,0) NOT NULL
,UNIQUE(EMPLOYERCONTACT),
		PTSEMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PTSCONTACTPERSON_RX" ON PTSCONTACTPERSON (REALM_ID ASC)
/	
    CREATE INDEX "PTSEMP_FK_PTSCONTACT" ON PTSCONTACTPERSON (PTSEMPLOYER ASC)
/	



	CREATE TABLE PTSCANCELLEDPAYCHECK (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		AMOUNT NUMBER(19,4) NULL,
		PAYCHECKID NUMBER(20,0) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PTSVOIDPAYROLLRESULT NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PTSCANCELLEDPAYCHECK_RX" ON PTSCANCELLEDPAYCHECK (REALM_ID ASC)
/	
    CREATE INDEX "VOIDPROLLRSLT_VOIDPAYCHECK_FK" ON PTSCANCELLEDPAYCHECK (PTSVOIDPAYROLLRESULT ASC)
/	



	CREATE TABLE PTSPAYROLLRUN (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DDDEBITAMOUNT NUMBER(19,4) NULL,
		DEBITAMOUNT NUMBER(19,4) NULL,
		TAXDEBITAMOUNT NUMBER(19,4) NULL,
		SETTLEMENTDATE TIMESTAMP NULL,
		PAYROLLRUNID NUMBER(20,0) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "PTSPAYROLLRUN_RX" ON PTSPAYROLLRUN (REALM_ID ASC)
/	



	CREATE TABLE PTSVOIDPAYROLLRESULT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DDDEBITAMOUNT NUMBER(19,4) NULL,
		DEBITAMOUNT NUMBER(19,4) NULL,
		TAXDEBITAMOUNT NUMBER(19,4) NULL,
		SETTLEMENTDATE TIMESTAMP NULL,
		APPLIEDFORWARDREFUND NUMBER(19,4) NULL,
		CANCELLEDAMOUNT NUMBER(19,4) NULL,
		IMMEDIATEREFUND NUMBER(19,4) NULL,
		TAKEONRETURNREFUND NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL	)
/
    
    CREATE INDEX "PTSVOIDPAYROLLRESULT_RX" ON PTSVOIDPAYROLLRESULT (REALM_ID ASC)
/	



	CREATE TABLE PPSPTSINTERACTION (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		ENTITY VARCHAR2(100) NULL,
		OPERATION VARCHAR2(100) NULL,
		IDENTIFIER NUMBER(20,0) NULL,
		INTERACTIONDATE TIMESTAMP NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PTSEMPLOYER NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PPSPTSINTERACTION_RX" ON PPSPTSINTERACTION (REALM_ID ASC)
/	
    CREATE INDEX "PTSEMP_PPSINT_FK" ON PPSPTSINTERACTION (PTSEMPLOYER ASC)
/	



	CREATE TABLE PTSMESSAGE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		MESSAGECODE VARCHAR2(100) NULL,
		MESSAGEDESCRIPTION VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		NFST_FK_MESSAGE NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "PTSMESSAGE_RX" ON PTSMESSAGE (REALM_ID ASC)
/	
    CREATE INDEX "PTSMESSAGE_FK_NFST_FK_MESSAGE" ON PTSMESSAGE (NFST_FK_MESSAGE ASC)
/	



	CREATE TABLE PTSEMPLOYER (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CURRENTTAXSERVICESTATUS VARCHAR2(100) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PTSWORKFLOWSTATE NUMBER(20,0) NOT NULL
,UNIQUE(PTSWORKFLOWSTATE),
		EMPLOYER NUMBER(20,0) NULL
,UNIQUE(EMPLOYER)	)
/
    
    CREATE INDEX "PTSEMPLOYER_RX" ON PTSEMPLOYER (REALM_ID ASC)
/	



	CREATE TABLE PTSWORKFLOWSTATE (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL
,UNIQUE(TAXSERVICESTATE)	)
/
    
    CREATE INDEX "PTSWORKFLOWSTATE_RX" ON PTSWORKFLOWSTATE (REALM_ID ASC)
/	



	CREATE TABLE TAXCREDIT (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		TAXCREDITPAYROLLRUNID NUMBER(20,0) NULL,
		TAXCREDITAMOUNT NUMBER(19,4) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		PTSPAYROLLRUN NUMBER(20,0) NULL	)
/
    
    CREATE INDEX "TAXCREDIT_RX" ON TAXCREDIT (REALM_ID ASC)
/	
    CREATE INDEX "TAXCREDIT_FK_PTSPAYROLLRUN" ON TAXCREDIT (PTSPAYROLLRUN ASC)
/	



	CREATE TABLE NOTIFICATIONSTATUSENTITY (
		PRIMARY KEY(ID),
		ID NUMBER(20,0) NOT NULL,
		REALM_ID NUMBER(20,0)  DEFAULT -1 NOT NULL,
		DISCRIMINATOR VARCHAR2(100) NULL,
		STATUSDATE TIMESTAMP NULL,
		AGENCY VARCHAR2(100) NULL,
		ACTIVE CHAR(1) NULL,
		CREATIONDATE TIMESTAMP NULL,
		CREATEDBY VARCHAR2(100) NULL,
		LASTMODIFICATIONDATE TIMESTAMP NULL,
		LASTMODIFIEDBY VARCHAR2(100) NULL,
		VERSION NUMBER(20,0) NOT NULL,
		UUID VARCHAR2(255) NOT NULL,
		TAXSERVICESTATE NUMBER(20,0) NULL,
		RAAENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		ACTIVATIONSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		STATUS VARCHAR2(100) NULL,
		BANKACCTID NUMBER(20,0) NULL,
		RAFENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		EFTPSENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		ACHENROLLMENTSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL,
		OLDVALUE VARCHAR2(100) NULL,
		NEWVALUE VARCHAR2(100) NULL	)
/
    
    CREATE INDEX "NOTIFICATIONSTATUSENTITY_RX" ON NOTIFICATIONSTATUSENTITY (REALM_ID ASC)
/	
    CREATE INDEX "TAXSVCST_FK_NFST" ON NOTIFICATIONSTATUSENTITY (TAXSERVICESTATE ASC)
/	


    

    
	ALTER TABLE WORKERCOMPLIANCEDOCDTL ADD (
		SUBJECTTOBACKUPWITHHOLDING CHAR(1) NULL	,
		PERCENTAGERATE_CUR VARCHAR2(100) NULL	,
		PERCENTAGERATE_AMT NUMBER(19,4) NULL	,
		W4TAXEXEMPT CHAR(1) NULL	,
		W4NOOFALLOWANCES NUMBER(10,0) NULL	,
		W4ADDTLAMOUNT_CUR VARCHAR2(100) NULL	,
		W4ADDTLAMOUNT_AMT NUMBER(19,4) NULL	,
		W4WITHHOLDINGSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL	,
		VALUE VARCHAR2(100) NULL	,
		DE4TAXEXEMPT CHAR(1) NULL	,
		DE4NOOFALLOWANCES NUMBER(10,0) NULL	,
		DE4NOOFDEDUCTIONS NUMBER(10,0) NULL	,
		DE4ADDTLAMOUNT_CUR VARCHAR2(100) NULL	,
		DE4ADDTLAMOUNT_AMT NUMBER(19,4) NULL	,
		DE4WITHHOLDINGSTATUS VARCHAR2(100)  DEFAULT 'NOTSET' NULL		)
	/



    
    
    
    
    
    
    
    -- Functions
    
    
    
    
    CREATE or REPLACE TRIGGER "TAKEHOMECOMPANY_VT" 
    BEFORE INSERT OR UPDATE ON "TAKEHOMECOMPANY" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAKEHOMEWORKER_VT" 
    BEFORE INSERT OR UPDATE ON "TAKEHOMEWORKER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "TAXSERVICESTATE_VT" 
    BEFORE INSERT OR UPDATE ON "TAXSERVICESTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE PTSCONTACTPERSON 
	ADD CONSTRAINT PTSEMP_FK_PTSCONTACT 
	FOREIGN KEY (PTSEMPLOYER) 
	REFERENCES PTSEMPLOYER (ID)
/

ALTER TABLE PTSCONTACTPERSON 
	ADD CONSTRAINT PTSCONTACT_FK_EMPCONTACT 
	FOREIGN KEY (EMPLOYERCONTACT) 
	REFERENCES CONTACTPERSON (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSCONTACTPERSON_VT" 
    BEFORE INSERT OR UPDATE ON "PTSCONTACTPERSON" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PTSCANCELLEDPAYCHECK 
	ADD CONSTRAINT VOIDPROLLRSLT_VOIDPAYCHECK_FK 
	FOREIGN KEY (PTSVOIDPAYROLLRESULT) 
	REFERENCES PTSVOIDPAYROLLRESULT (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSCANCELLEDPAYCHECK_VT" 
    BEFORE INSERT OR UPDATE ON "PTSCANCELLEDPAYCHECK" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "PTSPAYROLLRUN_VT" 
    BEFORE INSERT OR UPDATE ON "PTSPAYROLLRUN" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
    
    CREATE or REPLACE TRIGGER "PTSVOIDPAYROLLRESULT_VT" 
    BEFORE INSERT OR UPDATE ON "PTSVOIDPAYROLLRESULT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PPSPTSINTERACTION 
	ADD CONSTRAINT PTSEMP_PPSINT_FK 
	FOREIGN KEY (PTSEMPLOYER) 
	REFERENCES PTSEMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "PPSPTSINTERACTION_VT" 
    BEFORE INSERT OR UPDATE ON "PPSPTSINTERACTION" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE PTSMESSAGE 
	ADD CONSTRAINT PTSMESSAGE_FK_NFST_FK_MESSAGE 
	FOREIGN KEY (NFST_FK_MESSAGE) 
	REFERENCES NOTIFICATIONSTATUSENTITY (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSMESSAGE_VT" 
    BEFORE INSERT OR UPDATE ON "PTSMESSAGE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    




ALTER TABLE PTSEMPLOYER 
	ADD CONSTRAINT PTSWFSTATE_FK_PTSEMP 
	FOREIGN KEY (PTSWORKFLOWSTATE) 
	REFERENCES PTSWORKFLOWSTATE (ID)
/

ALTER TABLE PTSEMPLOYER 
	ADD CONSTRAINT PTSEMPLOYER_FK_EMPLOYER 
	FOREIGN KEY (EMPLOYER) 
	REFERENCES EMPLOYER (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSEMPLOYER_VT" 
    BEFORE INSERT OR UPDATE ON "PTSEMPLOYER" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    


ALTER TABLE PTSWORKFLOWSTATE 
	ADD CONSTRAINT PTSWFSTATE_FK_PTSASSISTEDSTATE 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "PTSWORKFLOWSTATE_VT" 
    BEFORE INSERT OR UPDATE ON "PTSWORKFLOWSTATE" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE TAXCREDIT 
	ADD CONSTRAINT TAXCREDIT_FK_PTSPAYROLLRUN 
	FOREIGN KEY (PTSPAYROLLRUN) 
	REFERENCES PTSPAYROLLRUN (ID)
/

    
    CREATE or REPLACE TRIGGER "TAXCREDIT_VT" 
    BEFORE INSERT OR UPDATE ON "TAXCREDIT" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    
ALTER TABLE NOTIFICATIONSTATUSENTITY 
	ADD CONSTRAINT TAXSVCST_FK_NFST 
	FOREIGN KEY (TAXSERVICESTATE) 
	REFERENCES TAXSERVICESTATE (ID)
/

    
    CREATE or REPLACE TRIGGER "NOTIFICATIONSTATUSENTITY_VT" 
    BEFORE INSERT OR UPDATE ON "NOTIFICATIONSTATUSENTITY" 
    FOR EACH ROW 
    BEGIN 
            IF USER = UPPER('&&1') THEN RETURN; 
     END IF; 
     IF INSERTING THEN 
         :new.realm_id := SBCORE_VPD_POLICY_PKG.GET_REALM_ID_FROM_CTX; 
     ELSE 
         IF UPDATING THEN 
             IF :old.realm_id != :new.realm_id THEN 
                 :new.realm_id := :old.realm_id; 
             END IF; 
         END IF; 
     END IF; 

    END; 
  /	

    
    

    -- Synonyms
    
    -- Grants
    
	GRANT SELECT, INSERT, UPDATE, DELETE ON TAKEHOMECOMPANY TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAKEHOMEWORKER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAXSERVICESTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSCONTACTPERSON TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSCANCELLEDPAYCHECK TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSPAYROLLRUN TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSVOIDPAYROLLRESULT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PPSPTSINTERACTION TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSMESSAGE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSEMPLOYER TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON PTSWORKFLOWSTATE TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON TAXCREDIT TO &&2
	/


	GRANT SELECT, INSERT, UPDATE, DELETE ON NOTIFICATIONSTATUSENTITY TO &&2
	/


	GRANT SELECT ON HIBERNATE_SEQUENCE TO &&2
	/

  
    
	--
    -- Table permissions for the VPD internal-to-external mapping table
    --
    GRANT SELECT,INSERT,UPDATE ON SBCORE_VPD_TABLE TO &&2
    /
    --
    -- Permission for VPD SEQ
    --
    GRANT SELECT ON SBCORE_VPD_SEQ TO &&2
    /
        
 

    
DECLARE
  table_exists PLS_INTEGER;
  row_exists PLS_INTEGER;

  INSERT_CMD VARCHAR2(255);
  ROWCHECK_CMD VARCHAR2(255);
  UPDATE_CMD VARCHAR2(255);

BEGIN
  SELECT COUNT(*) INTO table_exists
  FROM "USER_TABLES"
  WHERE TABLE_NAME = 'PROJECT_VERSIONS_TABLE';
  IF table_exists = 1 THEN 
  
    SELECT 'SELECT COUNT(*)  FROM PROJECT_VERSIONS_TABLE WHERE PROJECT_ID=''_FY5ioOECEd2RxJXjYkjWBw'''   
    INTO ROWCHECK_CMD
    FROM DUAL;
    EXECUTE IMMEDIATE ROWCHECK_CMD INTO row_exists;   
   
    IF row_exists = 1 THEN    
        SELECT 'UPDATE PROJECT_VERSIONS_TABLE SET MODEL_VERSION='''',SCHEMA_VERSION=''1.0.28'',TIMESTAMP=''2009-07-02 10:41:24.165'' WHERE PROJECT_ID=''_FY5ioOECEd2RxJXjYkjWBw'''
        INTO UPDATE_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE UPDATE_CMD;
    ELSE
        SELECT 'INSERT INTO PROJECT_VERSIONS_TABLE (PROJECT_NAME,PROJECT_ID,MODEL_VERSION,SCHEMA_VERSION,TIMESTAMP) VALUES (''sb-payroll-entity-us'',''_FY5ioOECEd2RxJXjYkjWBw'','''',''1.0.28'',''2009-07-02 10:41:24.165'')' 
        INTO INSERT_CMD
        FROM DUAL;
        EXECUTE IMMEDIATE INSERT_CMD;
    END IF;   
  END IF;
END;
/

    