package com.intuit.sb.payroll.capability.common;


import java.util.Date;

import org.testng.annotations.BeforeClass;

import com.intuit.sb.payroll.ServiceFailureException;
import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.capability.employer.EmployerComponentTestUtils;
import com.intuit.sb.payroll.capability.worker.WorkerTestUtils;
import com.intuit.sb.payroll.entity.model.BankAccountTypeEnum;
import com.intuit.sb.payroll.entity.model.GlobalPostalAddress;
import com.intuit.sb.payroll.entity.model.PersonTaxId;
import com.intuit.sb.payroll.entity.model.PersonTaxIdEnum;
import com.intuit.sb.payroll.entity.model.Worker;
import com.intuit.sb.payroll.pts.entity.PPSPTSInteractionEAO;
import com.intuit.sb.payroll.pts.entity.PTSPayrollRunEAO;
import com.intuit.sb.payroll.services.common.BankAccount;
import com.intuit.sb.payroll.services.employer.EmployerServiceTestBase;
import com.intuit.sb.payroll.services.taxes.EmployerTaxSettingsService;
import com.intuit.sb.payroll.services.workerpayments.WorkerPaymentServiceTestBase;
import com.intuit.sb.payroll.task.TaskService;


public class PTSWorkerPaymentServiceTestBase extends WorkerPaymentServiceTestBase{
	protected static EmployerTaxSettingsService sEmployerTaxSettingsService;
	protected static TaskService sTaskService;	
	protected static PTSPayrollRunEAO ptsPayrollRunEAO;
	protected static PPSPTSInteractionEAO ppsPTSInteractionEAO;
	
	@BeforeClass
	public static void initialize()
	{	
		sTaskService = qaBootstrap.getEjbFromClass(TaskService.class);
		sEmployerTaxSettingsService = qaBootstrap.getEjbFromClass(EmployerTaxSettingsService.class);
		ptsPayrollRunEAO = qaBootstrap.getEjbFromClass(PTSPayrollRunEAO.class);
		ppsPTSInteractionEAO = qaBootstrap.getEjbFromClass(PPSPTSInteractionEAO.class);
		
	}
	
	
	protected void prepareCurrentEmployerForAssistedWithBank()throws ValidationException,ServiceFailureException,Exception{
		
		PTSEmployerServiceTestBase.prepareCurrentEmployerForAssisted(sEmployerService,sEmployerTaxSettingsService);
		createBankAccount();		
	}
		
	public static Worker createAssistedReadyEmployee(Worker worker, Date hireDate) throws Exception{
			//Save payroll-ready worker
	   	String firstName = "Jim";
	   	String workLocation = sSanFranciscoLocation;
	   	worker = WorkerTestUtils.createAPayrollReadyWorker(firstName, workLocation);
	   	PersonTaxId Emp1Id = new PersonTaxId();
	   	Emp1Id.setType(PersonTaxIdEnum.SSN);
	   	Emp1Id.setValue("567890123");
	   	worker.setPersonTaxId(Emp1Id);
	   	GlobalPostalAddress emp1Address = new GlobalPostalAddress();
	   	emp1Address = EmployerComponentTestUtils.createGlobalPostalAddress("123", "Boston", "CA", "14154");
	   	worker.setTaxResidenceAddress(emp1Address);
	   	worker.getEmploymentPeriod().setStartDate(hireDate);
	   	worker = sWorkerComponent.updateWorker(worker);
	   	return worker;
	   	
	   	//TODO should set other mandatory fields for Assisted ready once Dev side implementation is ready	    	
	}
	
	protected void createBankAccount() throws ValidationException, ServiceFailureException{
		//create a bank Account
		BankAccount[] bankAccounts=new BankAccount[1];		
		BankAccount bankAccount = EmployerServiceTestBase.createBankAccount(BankAccountTypeEnum.SAVINGS);
		bankAccounts[0] = bankAccount;
		
		//add bankAccount to the employer
		sEmployerService.addBankAccounts(bankAccounts);
	}
	
}
