package com.intuit.sb.payroll.capability.employer;

import java.util.List;

import org.testng.annotations.Test;

import com.intuit.sb.payroll.capability.common.BasicPTSTestBase;
import com.intuit.sb.payroll.capability.pts.adapter.PTSRequestInvoker;
import com.intuit.sb.payroll.capability.worker.WorkerTestUtils;
import com.intuit.sb.payroll.entity.model.PersonTaxId;
import com.intuit.sb.payroll.entity.model.WorkLocation;
import com.intuit.sb.payroll.entity.model.Worker;

public class PTSAddEmployeeTest extends BasicPTSTestBase {

	@Test(enabled=true, groups = {"ptsAddEmployeeTests"})
	public static void testAssistedAddEmployees() throws Exception{
		// Create an Assisted Ready worker
		List<WorkLocation> workLocations = sEmployerComponent.findAllWorkLocations();
		Worker worker = WorkerTestUtils.createASalaryPayrollReadyWorker("PTSReadyWorker", workLocations.get(0).getName());
		PersonTaxId personTaxId = WorkerTestUtils.generateRandomPersonTaxId();
		worker.setPersonTaxId(personTaxId);
		worker = sWorkerEAO.makeManaged(worker);
		PTSRequestInvoker.addWorkerInfotoPTS(sEmployerPTSWorkflowComponent.getPTSEmployer(),worker);
	}
	
	
	@Test
	public static void testNonAssistedReadyAddEmployees(){
		// Create an NonAssisted Ready worker
	}
}
