package com.intuit.sb.payroll.qa.webservice.client;


import com.intuit.sb.payroll.capability.pts.adapter.dtos.PTSNotificationDTO;

public class PTSNotificationAdapterServicerRequest {
	
	
	private String soapRequest = "";
	
	public PTSNotificationAdapterServicerRequest(PTSNotificationDTO ptNotificationDTO) {
		generateSOAPRequestFromDTO(ptNotificationDTO);
	
	}
	
	private void generateSOAPRequestFromDTO(PTSNotificationDTO ptNotificationDTO){
		
		
		StringBuffer sb = new StringBuffer();
		
		
		sb.append("<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:adap=\"http://adapter.pts.capability.payroll.sb.intuit.com/\">");
		sb.append("<soapenv:Header/>");
		sb.append("<soapenv:Body>");
		sb.append("<adap:updateCompanyActivationStatus>");
		sb.append("<ptsNotificationDTO>");
		
		if(ptNotificationDTO.getSourceCompanyId()== null){
			sb.append("<sourceCompanyId> </sourceCompanyId>");
		}
		else{
			
			sb.append("<sourceCompanyId>"+ptNotificationDTO.getSourceCompanyId()+" </sourceCompanyId>");
		}
		if(ptNotificationDTO.getNotificationType()== null){
			sb.append("<notificationType></notificationType>");
		}else{
			sb.append("<notificationType>"+ptNotificationDTO.getNotificationType()+"</notificationType>");
		}
		
		if(ptNotificationDTO.getNewNotificationStatus()==null){
			sb.append("<newNotificationStatus></newNotificationStatus>");
		}
		else{
			sb.append("<newNotificationStatus>"+ptNotificationDTO.getNewNotificationStatus()+"</newNotificationStatus>");
		}
		if(ptNotificationDTO.getOldNotificationStatus()==null){
			sb.append("<oldNotificationStatus></oldNotificationStatus>");
		}
		else{
			sb.append("<newNotificationStatus>"+ptNotificationDTO.getOldNotificationStatus()+"</newNotificationStatus>");
		}
		
		sb.append("<notificationChangeTimeStamp>");
		
		if(ptNotificationDTO.getNotificationChangeTimeStamp()!= null){
			
			sb.append("<day>"+ptNotificationDTO.getNotificationChangeTimeStamp().getDay()+"</day>");
			sb.append("<month>"+ptNotificationDTO.getNotificationChangeTimeStamp().getMonth()+"</month>");
			sb.append("<year>"+ptNotificationDTO.getNotificationChangeTimeStamp().getYear()+"</year>");
			sb.append("<hour>"+ptNotificationDTO.getNotificationChangeTimeStamp().getHour()+"</hour>");
			sb.append("<minute>"+ptNotificationDTO.getNotificationChangeTimeStamp().getMinute()+"</minute>");
			sb.append("<second>"+ptNotificationDTO.getNotificationChangeTimeStamp().getSecond()+"</second>");
		}
		else{
			
			sb.append("<day>0</day>");
			sb.append("<month>0</month>");
			sb.append("<year>0</year>");
			sb.append("<hour>0</hour>");
			sb.append("<minute>0</minute>");
			sb.append("<second>0</second>");
		}
		
		sb.append("</notificationChangeTimeStamp>");
		
		sb.append("<activationMessage>");
		
		if(ptNotificationDTO.getActivationMessage()!=null && (ptNotificationDTO.getActivationMessage().size()!=0)){
			
			sb.append("<messageDescription>"+ptNotificationDTO.getActivationMessage().get(0).getMessageDescription()+"</messageDescription>");
			sb.append("<messageId>"+ptNotificationDTO.getActivationMessage().get(0).getMessageId()+"</messageId>");
			
		}
		else{
			
			sb.append("<messageDescription></messageDescription>");
			sb.append("<messageId></messageId>");
		}
		
		
		
		sb.append("</activationMessage>");
		sb.append("<attributes>");
		
		if(ptNotificationDTO.getAttributes()!=null && (ptNotificationDTO.getAttributes().size()!=0)){
			sb.append("<name>"+ptNotificationDTO.getAttributes().get(0).getName()+"</name>");
			sb.append("<value>"+ptNotificationDTO.getAttributes().get(0).getValue()+"</value>");
		}
		else{
			sb.append("<name></name>");
			sb.append("<value></value>");

		}
		
		sb.append("</attributes>");
		
		sb.append("</ptsNotificationDTO></adap:updateCompanyActivationStatus></soapenv:Body></soapenv:Envelope>");
		
		this.soapRequest = sb.toString();
	}
	
	
	public String getSOAPRequest(){
		return soapRequest;
	}
	
	

}
