package com.intuit.sb.payroll.qa.services.workerpayments;

import org.testng.annotations.AfterClass;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.ValidationException;
import com.intuit.sb.payroll.services.workerpayments.WorkerPaymentServiceTestBase;

/**
 * Tests the createPayrollRun operation of the IPayEmployeeService.
 *
 * $Author$
 * $Revision$
 * $DateTime$
 *
 */
public class CreateAdhocPayrollRunTest extends WorkerPaymentServiceTestBase
{
/*    
    protected static String sReadyForPayWorkerId = null;
    private static GregorianCalendar now = new GregorianCalendar();
    private static Date sPayPeriodEndDate = now.getTime();
*/    
    
    @BeforeClass
    public static void setUpCreateAdhocPayrollRunTest()
    {
/*
        try
        {
            getUserTransaction().begin();
            if (null == sReadyForPayWorkerId)
            {
                sReadyForPayWorkerId = createPayrollReadyWorker();
            }
            getUserTransaction().commit();
        }
        catch (Throwable t)
        {
            sLogger.error(t.getMessage());
            try
            {
                getUserTransaction().rollback();
            }
            catch (Exception e)
            {
            }
            AssertJUnit.fail("Error in setUpCreateAdhocPayrollRunTest(): " + t.getMessage());
        }
*/        
    }
    
    @AfterClass
    public static void tearDownCreateAdhocPayrollRunTest()
    {
/*        
        try
        {
            getUserTransaction().begin();
            if (null != sReadyForPayWorkerId)
            {
                cleanUpEIWorker(sReadyForPayWorkerId);
                sReadyForPayWorkerId = null;
            }
            getUserTransaction().commit();
        }
        catch (Throwable t)
        {
            sLogger.error(t.getMessage());
            try
            {
                getUserTransaction().rollback();
            }
            catch (Exception e)
            {
            }
            AssertJUnit.fail("Error in tearDownCreateAdhocPayrollRunTest(): " + t.getMessage());
        }
*/        
    }
    
    /**
     * <P>Test ValidationException caused by null PayrollRunCreateRequest object</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a null PayrollRunCreateRequest object</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a ValidationException is thrown since the PayrollRunCreateRequest object is null
     * </UL>
     */
    @Test(enabled=false, groups={"broken"})
    public void testNullPayrollRunCreateRequest()
    {
/*      try
        {
            // Setup
            // Exercise
            sPayEmployeeService.createAdhocPayrollRun(null);
            AssertJUnit.fail("ValidationException was not thrown!");
        }
        // Verify
        catch (ValidationException ex)
        {
            AssertJUnit.assertTrue(ex.getMessage().contains("PayrollRunCreateRequest is null"));
        }
*/
    }

    /**
     * <P>Test ValidationException caused by null PayrollRunPeriod inside the PayrollRunCreateRequest object</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object, but with a null PayrollRunPeriod object inside it</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a ValidationException is thrown since the PayrollRunPeriod inside the PayrollRunCreateRequest object is null
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testNullPayrollRunPeriod()
    {
/*      try
        {
            // Setup
            String workers[] = {sReadyForPayWorkerId};
            PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
            payrollRunCreateRequest.setPeriod(null);
            payrollRunCreateRequest.setWorkerIds(workers);
            // Exercise
            sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
            AssertJUnit.fail("ValidationException was not thrown!");
        }
        // Verify
        catch (ValidationException ex)
        {
            AssertJUnit.assertTrue(ex.getMessage().contains("PayrollRunPeriod is null"));
        }
*/
    }

    /**
     * <P>Test ValidationException caused by periodStartDate is after the periodEndDate inside the PayrollRunPeriod object</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object, but with a periodStartDate after the periodEndDate in the PayrollRunPeriod object</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a ValidationException is thrown since the periodStartDate is after the periodEndDate in PayrollRunPeriod
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testPeriodStartDate_After_PeriodEndDate()
    {
/*      try
        {
            // Setup
            String workers[] = {sReadyForPayWorkerId};
            PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
            PayrollRunPeriod payrollRunPeriod = createBiweeklyPayrollRunPeriod(sPayPeriodEndDate);
            // Swap the PeriodStartDate and PeriodEndDate
            Date tempDate = payrollRunPeriod.getPeriodStartDate();
            payrollRunPeriod.setPeriodStartDate(payrollRunPeriod.getPeriodEndDate());
            payrollRunPeriod.setPeriodEndDate(tempDate);
            payrollRunCreateRequest.setPeriod(payrollRunPeriod);
            payrollRunCreateRequest.setWorkerIds(workers);
            // Exercise
            sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
            AssertJUnit.fail("ValidationException was not thrown!");
        }
        // Verify
        catch (ValidationException ex)
        {
            //TODO update the error message with the correct one
            AssertJUnit.assertTrue(ex.getMessage().contains("invalid pay period dates"));
        }
*/
    }

    /**
     * <P>Test ValidationException caused by payDate is before the periodStartDate inside the PayrollRunPeriod object</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object, but with a payDate before the periodStartDate in the PayrollRunPeriod object</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a ValidationException is thrown since the payDate is before the periodStartDate in PayrollRunPeriod
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testPayDate_Before_PeriodStartDate()
    {
/*     try
        {
            // Setup
            String workers[] = {sReadyForPayWorkerId};
            PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
            PayrollRunPeriod payrollRunPeriod = createBiweeklyPayrollRunPeriod(sPayPeriodEndDate);
            // Set the payDate to the day before the PeriodStartDate
            Date tempDate = payrollRunPeriod.getPeriodStartDate();
            payrollRunPeriod.setPayDate(addDays(tempDate, -1));
            payrollRunCreateRequest.setPeriod(payrollRunPeriod);
            payrollRunCreateRequest.setWorkerIds(workers);
            // Exercise
            sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
            AssertJUnit.fail("ValidationException was not thrown!");
        }
        // Verify
        catch (ValidationException ex)
        {
            //TODO update the error message with the correct one
            AssertJUnit.assertTrue(ex.getMessage().contains("invalid pay period dates"));
        }
*/
    }

    /**
     * <P>Test ValidationException caused by null workerIds array inside the PayrollRunCreateRequest object</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object, but with a null workerIds array inside it</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a ValidationException is thrown since the workerIds array inside the PayrollRunCreateRequest object is null
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testNullWorkerIds()
    {
/*      try
        {
            // Setup
            PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
            payrollRunCreateRequest.setPeriod(createBiweeklyPayrollRunPeriod(sPayPeriodEndDate));
            payrollRunCreateRequest.setWorkerIds(null);
            // Exercise
            sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
            AssertJUnit.fail("ValidationException was not thrown!");
        }
        // Verify
        catch (ValidationException ex)
        {
            AssertJUnit.assertTrue(ex.getMessage().contains("workerIds is null"));
        }
*/
    }

    /**
     * <P>Test ValidationException caused by null entry in workerIds array inside the PayrollRunCreateRequest object</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object, but with a null entry in the workerIds array</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a ValidationException is thrown since an entry in the workerIds array inside the PayrollRunCreateRequest object is null
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testNullEntryInWorkerIdsArray()
    {
/*      try
        {
            // Setup
            String workers[] = {null, sReadyForPayWorkerId};
            PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
            payrollRunCreateRequest.setPeriod(createBiweeklyPayrollRunPeriod(sPayPeriodEndDate));
            payrollRunCreateRequest.setWorkerIds(workers);
            // Exercise
            sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
            AssertJUnit.fail("ValidationException was not thrown!");
        }
        // Verify
        catch (ValidationException ex)
        {
            //TODO update the error message with the correct one
            AssertJUnit.assertTrue(ex.getMessage().contains("entry in workerIds is null"));
        }
*/
    }

    /**
     * <P>Test ValidationException caused by NotReadyForPay worker in workerIds array inside the PayrollRunCreateRequest object</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object, but with a NotReadyForPay worker in the workerIds array</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a ValidationException is thrown since a NotReadyForPay worker is in the workerIds array inside the PayrollRunCreateRequest object
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testNotReadyForPayWorkerInWorkerIdsArray()
    {
/*      SpcUniqueId notReadyForPayWorker = null;
        try
        {
            // Setup
            notReadyForPayWorker = createNotPayrollReadyWorker();
            String workers[] = {notReadyForPayWorker, sReadyForPayWorkerId};
            PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
            payrollRunCreateRequest.setPeriod(createBiweeklyPayrollRunPeriod(sPayPeriodEndDate));
            payrollRunCreateRequest.setWorkerIds(workers);
            // Exercise
            sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
            AssertJUnit.fail("ValidationException was not thrown!");
        }
        // Verify
        catch (ValidationException ex)
        {
            //TODO update the error message with the correct one
            AssertJUnit.assertTrue(ex.getMessage().contains("entry in workerIds is null"));
        }
        finally
        {
            // Cleanup
            if (null != notReadyForPayWorker)
            {
                cleanUpEIWorker(notReadyForPayWorker);
            }
        }
*/
    }

    /**
     * <P>Test successful creation of an adhoc PayrollRun</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a PayrollRun is successfully created
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testCreateAdhocPayrollRun() throws ValidationException
    {
/*      // Setup
        String workers[] = {sReadyForPayWorkerId};
        PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
        payrollRunCreateRequest.setPeriod(createBiweeklyPayrollRunPeriod(sPayPeriodEndDate));
        payrollRunCreateRequest.setWorkerIds(workers);
        // Exercise
        @SuppressWarnings("unused")
        PayrollRunResponse payrollRunResponse = sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
        // Verify
        //TODO Remove following assert statement and add actual verification logic here
        AssertJUnit.assertTrue(true);
*/
    }

    /**
     * <P>Test successful creation of an adhoc PayrollRun, using an empty workers array</P>
     *
     * <H3>Steps:</H3>
     * <OL>
     * <LI>Call IPayEmployeeService's createAdhocPayrollRun() with a valid PayrollRunCreateRequest object, and an empty workers array</LI>
     * </OL>
     *
     * <UL>
     * <LI>Verify that a PayrollRun is successfully created
     * </UL>
     */
//    @Test(enabled=false, groups={"broken"})
    public void testCreateAdhocPayrollRunWithEmptyWorkersArray() throws ValidationException
    {
/*      // Setup
        String workers[] = {};
        PayrollRunCreateRequest payrollRunCreateRequest = new PayrollRunCreateRequest();
        payrollRunCreateRequest.setPeriod(createBiweeklyPayrollRunPeriod(sPayPeriodEndDate));
        payrollRunCreateRequest.setWorkerIds(workers);
        // Exercise
        @SuppressWarnings("unused")
        PayrollRunResponse payrollRunResponse = sPayEmployeeService.createAdhocPayrollRun(payrollRunCreateRequest);
        // Verify
        //TODO Remove following assert statement and add actual verification logic here
        AssertJUnit.assertTrue(true);
*/
    }

}
