package com.intuit.sb.payroll.performance;

import java.math.BigDecimal;
import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.services.wages.CompensationItem;
import com.intuit.sb.payroll.services.wages.WageService;
import com.intuit.sb.payroll.services.worker.Worker;

/**
 * this servlet tests com.intuit.sb.payroll.services.wages.WageService.getCompensationItems(Long workerId) 
 * @author jzhong
 *
 */
public class GetCompenstationsServlet extends PerformanceTestServlet {

	private static final long serialVersionUID = 1L;
	
	private static WageService wageService = ServiceLocator.getInstance().getService(WageService.JNDI_NAME);
	
	public String performTest(String username)
	{
		StringBuffer compItems = new StringBuffer("Employee Compensation Items: <p>");
		
		try
		{
			//Get WorkerNames in the realm
			Worker [] workers = PayrollDataContainer.getReadyToPayWorkers(username);
			if ( workers != null && workers.length != 0)
			{
				Worker worker = workers[0];
				long workerUniqueId = worker.getObjectHandle().getId();
				//Get Compenstation Items for the employee
				compItems.append(worker.getFirstName() + " " + worker.getLastName() + ":<br>");
				CompensationItem[] compensationItems = wageService.getCompensationItems(workerUniqueId);
				for (CompensationItem item:compensationItems)
				{
					String compName = item.getName();
					BigDecimal rate = item.getRate();
					double units = item.getUnits();
					compItems.append(compName + " " + rate + " " + units + "<br>");
				}
			}
		}
		catch (Exception ex)
		{
			throw new RuntimeException(ex);
		}
		
		return compItems.toString();		
	}
	
}
