package com.intuit.sb.payroll.performance;

import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.services.workerpayments.PayrollSchedule;
import com.intuit.sb.payroll.services.workerpayments.WorkerPaymentService;

/**
 * this servlet tests com.intuit.sb.payroll.services.workerpayments.WorkerPaymentService.getPayrollSchedule()
 * @author jzhong
 *
 */
public class GetPayrollScheduleServlet extends PerformanceTestServlet {
	
	private static final long serialVersionUID = 1L;
	
	private static WorkerPaymentService workerPayService = ServiceLocator.getInstance().getService(WorkerPaymentService.JNDI_NAME);
	
	public String performTest(String username)
	{
		StringBuffer payScheuleBuffer = new StringBuffer();
		
		try
		{
		   PayrollSchedule paySchedule = workerPayService.getPayrollSchedule();
		   payScheuleBuffer.append("Payroll Schedule: " + paySchedule.getFrequency().name() + " Starting " + paySchedule.getPeriodStartDate() +  "<br>");
		}
		catch (Exception ex)
		{
			throw new RuntimeException(ex);
		}
		
		return payScheuleBuffer.toString();		
	}	
}
