package com.intuit.sb.payroll.performance;

import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.services.worker.Worker;
import com.intuit.sb.payroll.services.worker.WorkerService;

public class GetWorkerByIdServlet extends PerformanceTestServlet {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private static ServiceLocator serviceLocator = ServiceLocator.getInstance();
	private static WorkerService workerService = serviceLocator.getService(WorkerService.JNDI_NAME);

	/**
	 * Test API com.intuit.sb.payroll.composite.entityinterface.worker.IWorkerService.getWorkerById()
	 * Get a worker by its uniqueId
	 * @param realmId
	 */
	public String performTest(String username)
	{
		StringBuffer sb = new StringBuffer("Get WorkerById :");
		sb.append("<p>");

		Worker [] workers = PayrollDataContainer.getReadyToPayWorkers(username);
		if ( workers != null && workers.length != 0)
		{
			long workerId = workers[0].getObjectHandle().getId();
			try {
				Worker worker = workerService.getWorkerById(workerId);	
				sb.append("First Name " + worker.getFirstName() + "<br>");
				sb.append("Last Name " + worker.getLastName() + "<br>");
				sb.append("Job Title " + worker.getJobTitle() + "<br>");
			}
			catch (Exception ex)
			{
				throw new RuntimeException("Exception in getting worker ID", ex);
			}
			
		}
		return sb.toString();
	}
	
}
