package com.intuit.sb.payroll.performance;

import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.services.worker.GetWorkersFilter;
import com.intuit.sb.payroll.services.worker.Worker;
import com.intuit.sb.payroll.services.worker.WorkerService;

/**
 * this servlet tests WorkerService.getWorkerSummary(GetWorkersFilter filter)
 * @author jzhong
 *
 */
public class GetWorkersServlet extends PerformanceTestServlet {
	
	private static final long serialVersionUID = 1L;
	private static ServiceLocator serviceLocator = ServiceLocator.getInstance();
	private static WorkerService workerService = serviceLocator.getService(WorkerService.JNDI_NAME);


	/*
	 * Get Workers in the company
	 * @param username is the username to log into the company
	 */
	public String performTest(String username)
	{
		StringBuffer sb = new StringBuffer("Worker Names for user " + username + ":");
		Worker [] workers = null;
		try
		{
			workers = workerService.getWorkers(GetWorkersFilter.READY_FOR_PAYROLL);
		}
		catch (Exception ex)
		{
			throw new RuntimeException(ex);
		}
		PayrollDataContainer.setReadyToPayWorkersMap(username, workers);
		if ( workers != null && workers.length != 0)
		{
			for (Worker worker:workers)
			{
				sb.append("<br>");
				sb.append(worker.getFirstName() + " " + worker.getLastName());
			}
		}
		

		return sb.toString();
	}
	
}
