package com.intuit.sb.payroll.performance;

import java.text.MessageFormat;
import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.intuit.sb.payroll.common.ExceptionUtils;
import com.intuit.sb.payroll.performance.tools.RealmUser;

public class MockLoginUtil {

	public static InitialContext mockLogin(String username)
	{
		RealmUser realmUser = PayrollDataContainer.getRealmUser(username);
		if ( realmUser == null )
		{
			System.out.println(PayrollDataContainer.printUsers());
			throw new IllegalArgumentException("Username is not valid");
		}
		InitialContext jndi = null;
		//Log in as user "username"
		String  password = null;
		try
		{
			// Get the default JNDI context as configured in jndi.properties.
			// If a remote context is required it should be configured in jndi.properties.
			  Properties env = new Properties();
			  env.setProperty(Context.SECURITY_PRINCIPAL, username);
			  
			  password = getPassword(username);
			  env.setProperty(Context.SECURITY_CREDENTIALS, password);
			  env.setProperty(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.security.jndi.JndiLoginInitialContextFactory");
			  jndi = new InitialContext(env);
		}
		catch (NamingException ne)
		{
            String mesg = MessageFormat.format("Unable to access JNDI: {0}", new Object[] {ExceptionUtils.throwableMessageChain(ne)});
            throw new RuntimeException(mesg);
		}
		
		return jndi;
	}
	
	private static String getPassword(String userName)
	{
		return userName;
	}
}
