package com.intuit.sb.payroll.performance;

import com.intuit.sb.payroll.common.ServiceLocator;
import com.intuit.sb.payroll.services.common.EntityTestBaseHelper;
import com.intuit.sb.payroll.services.common.EntityTestBaseHelper.PayrollReadyWorker;
import com.intuit.sb.payroll.services.worker.Worker;
import com.intuit.sb.payroll.services.worker.WorkerService;

public class SaveWorkerServlet extends PerformanceTestServlet {

	private static final long serialVersionUID = -3036729585804961146L;
	private static ServiceLocator serviceLocator = ServiceLocator.getInstance();
	private static WorkerService workerService = serviceLocator.getService(WorkerService.JNDI_NAME);

	/**
	 * Test API com.intuit.sb.payroll.composite.entityinterface.worker.IWorkerService.saveWorker(SaveWorkerRequest saveWorkerRequest)
	 */
	public String performTest(String username)
	{
		StringBuffer sb = new StringBuffer("Save Worker in company : " + username);
		sb.append("<p>");
		try
        {
			PayrollReadyWorker payrollReadyWorker = null;
        	Worker worker = null;
			try 
			{
				payrollReadyWorker = EntityTestBaseHelper.createPayrollReadyWorkerInMemory();
				if ( payrollReadyWorker != null )
				{
					worker = workerService.saveWorker(payrollReadyWorker.getWorker());
				}
			}
			catch (Exception ex) 
			{
				throw new RuntimeException("Seed Worker failed", ex);
			}
        	sb.append("Worker " + worker.getFirstName() +  " " + worker.getLastName() + " saved " + "<br>");        	
        }
        catch (Exception ex)
        {
        	throw new RuntimeException("Fail to save a worker", ex);
        }

		return sb.toString();
	}
	
}
