package com.intuit.sb.payroll.vpd;

import java.util.Properties;

import javax.ejb.EJBAccessException;
import javax.naming.Context;

import org.testng.Assert;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.util.RemoteServiceLocator;

//@Test(groups = "serviceittests")
public class SecurityDomainTest {
	
	@Test
	/**
	 * Test with right username and password paul/paul
	 */
   public void testBHPIAMPositiveTest() 
   {	   
	  SimpleVpdRemoteEAO remoteDao = null;
      Properties env = RemoteServiceLocator.getEnv();
      env.setProperty(Context.SECURITY_CREDENTIALS, "paul");
      try {
        RemoteServiceLocator.setEnv(env);
      } catch (Exception ex)
      {
    	  throw new RuntimeException(ex);
      }

	  try {
        remoteDao = RemoteServiceLocator.getInstance().getServiceFromJndi("SimpleVpdBean");         
        String returnString = remoteDao.findNemo();     
    	System.out.println("Paul typed in right password ");
    	System.out.println("findNemo invocation returns " + returnString);
      }  catch (Throwable t) { 
        Assert.fail("Error in getting remote objects: ", t);     
      }
   }

   /**
    * Test with incorrect password
    * @param args
    * @throws Exception
    */
   @Test(expectedExceptions=EJBAccessException.class)
   public void testBHPIAMNegativeTest()
   {
	  SimpleVpdRemoteEAO remoteDao = null;
      Properties env = RemoteServiceLocator.getEnv();
      env.setProperty(Context.SECURITY_CREDENTIALS, "invalidpassword");
      try {
      RemoteServiceLocator.setEnv(env);
      }
      catch (Exception ex)
      {
    	  throw new RuntimeException(ex);
      }
     
       remoteDao = RemoteServiceLocator.getInstance().getServiceFromJndi("SimpleVpdBean"); 
       remoteDao.findNemo();
       Assert.fail("Should not be here");  
      
   }
   
   /**
    * reset the right log in credential. @AfterTest does not work in maven, use @AfterMethod
    */
   @AfterMethod
   public void afterTest()
   {
	      Properties env = RemoteServiceLocator.getEnv();
	      env.setProperty(Context.SECURITY_CREDENTIALS, "paul");
	      try {
	        RemoteServiceLocator.setEnv(env);
	      }
	      catch (Exception ex)
	      {
	        throw new RuntimeException(ex);
	      }
   }
}