package com.intuit.sb.payroll.worker;

import org.testng.Assert;
import org.testng.annotations.Test;

import com.intuit.sb.payroll.services.TestInitializer;
import com.intuit.sb.payroll.services.common.EntityTestBaseHelper;
import com.intuit.sb.payroll.services.common.EntityTestBaseHelper.PayrollReadyWorker;
import com.intuit.sb.payroll.services.worker.GetWorkersFilter;
import com.intuit.sb.payroll.services.worker.Worker;

/**
 * Test methods in class com.intuit.sb.payroll.services.worker
 * @author jzhong
 *
 */
@Test(groups = "serviceittests")
public class WorkServiceTest extends TestInitializer {
	
	@Test
	/**
	 * when a user logs in, the first service API gets called is WorkerService.getWorkers
	 * The test tests WorkerService.getWorkers(GetWorkersFilter filter) does not throw exception
	 */
	public void testGetWorkers()
	{
		//setUpBasicTestBase();
		try
		{
			workerService.getWorkers(GetWorkersFilter.ALL);
		}
		catch (Exception ex)
		{
			throw new RuntimeException(ex);
		}
	}
	
	//@Test
	/**
	 * Test add a worker. API to test: WorkerService.saveWorker
	 */
	public void testAddWorker()
	{
		try
		{
		PayrollReadyWorker payrollReadyWorker = EntityTestBaseHelper.createPayrollReadyWorkerInMemory();
		
		String firstName = "Thomas";
		payrollReadyWorker.getWorker().setFirstName(firstName);
		
		
		Worker [] workerSummariesBeforeAdd = getWorkerService().getWorkers(GetWorkersFilter.ALL);

		Worker worker = getWorkerService().saveWorker(payrollReadyWorker.getWorker());
		Assert.assertEquals(firstName, worker.getFirstName(), "Hey, the worker is not what is saved");
		Worker [] workerSummariesAfterAdd = getWorkerService().getWorkers(GetWorkersFilter.ALL);
		
		Assert.assertEquals(workerSummariesBeforeAdd.length + 1, workerSummariesAfterAdd.length, 
				"there should be one more worker after adding one worker");
			
		}
		catch (Exception ex)
		{
			throw new RuntimeException(ex);
		}
	}
	
}
