/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.generator.tuple.AbstractOperationTuple.java
 * 
 * Created: Nov 14, 2011 6:22:54 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.generator.tuple;

import com.intuit.sb.services.query.generator.tuple.ExpressionTuple.Precedence;
import com.intuit.sb.services.query.validator.context.Property;

/**
 *
 * @author gkesler
 */
public abstract class AbstractFilterTuple<T> implements FilterTuple<T> {
    protected Property path;
    protected T value;

    public Property getPath() {
        return path;
    }

    public T getValue() {
        return value;
    }

    public void setPath(Property path) {
        this.path = path;
    }

    public void addValue(T value) {
        this.value = value;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "{" + "path=" + path + ", value=" + value + '}';
    }

    public Precedence getPrecedence() {
        return Precedence.Filter;
    }
}
