/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.generator.tuple.BetweenTuple.java
 * 
 * Created: Nov 14, 2011 7:06:48 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.generator.tuple;

import com.intuit.sb.services.query.generator.tuple.ExpressionTuple.Precedence;
import com.intuit.sb.services.query.validator.context.Property;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 *
 * @author gkesler
 */
public class BetweenTuple implements FilterTuple<Object> {
    private Property path;
    private List<Object> bounds = new ArrayList<Object>(2);

    public Property getPath() {
        return path;
    }

    public Object getValue() {
        return bounds;
    }

    public Object getLower () {
        return bounds.get(0);
    }
    
    public Object getUpper () {
        return bounds.get(1);
    }

    public <T> T accept(TupleVisitor<T> visitor, T data) {
        return visitor.visit(this, data);
    }

    public void setPath(Property path) {
        this.path = path;
    }

    public void addValue(Object value) {
        this.bounds.add(value);
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "{" + "path=" + path + ", bounds=" + bounds + '}';
    }

    public Precedence getPrecedence() {
        return Precedence.Filter;
    }
}
