/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.generator.BinaryTuple.java
 * 
 * Created: Aug 16, 2011 10:11:37 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.generator.tuple;

import java.util.Stack;

/**
 *
 * @author gkesler
 */
public abstract class BinaryTuple extends UnaryTuple {  
    protected ExpressionTuple left;

    public ExpressionTuple getLeftOperand() {
        return left;
    }

    @Override
    public ConditionalTuple popChildren(Stack<ExpressionTuple> tuples) {
        super.popChildren(tuples);
        this.left = tuples.pop();
        
        return this;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "{" + "left=" + left + ", right=" + right + '}';
    }

    @Override
    public <T> T childrenAccept(TupleVisitor<T> visitor, T data) {
        left.accept(visitor, data);
        right.accept(visitor, data);
        
        return data;
    }
}
