/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.generator.UnaryTuple.java
 * 
 * Created: Aug 16, 2011 10:16:52 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.generator.tuple;

import java.util.Stack;

/**
 *
 * @author gkesler
 */
public abstract class UnaryTuple implements ConditionalTuple {
    protected ExpressionTuple right;
    
    public ExpressionTuple getRightOperand() {
        return right;
    }

    public ConditionalTuple popChildren(Stack<ExpressionTuple> tuples) {
        this.right = tuples.pop();
        
        return this;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() + "{" + "operand=" + right + '}';
    }
    
    public <T> T childrenAccept (TupleVisitor<T> visitor, T data) {
        right.accept(visitor, data);
        
        return data;
    }
}
