/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.validator.Boundaries.java
 * 
 * Created: Nov 8, 2011 3:11:17 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.validator;

/**
 *
 * @author gkesler
 */
final class Boundaries<T extends Comparable> {
    final T lower; 
    final T upper;

    Boundaries (Defaults<T> defaults) {
        this.lower = defaults.minValue();
        this.upper = defaults.maxValue();
    }
    
    Boundaries (T lower, T upper, Defaults<T> defaults) {
        T min = defaults.minValue();
        this.lower = lower == null 
                ? min
                : (lower.compareTo(min) > 0 ? lower : min);
        
        T max = defaults.maxValue();
        this.upper = upper == null
                ? max
                : (upper.compareTo(max) < 0 ? upper : max);
    }
    
    interface Defaults<T extends Comparable> {
        T minValue ();
        T maxValue ();
    }
}
