/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.validator.EnumValidator.java
 * 
 * Created: Aug 12, 2011 12:01:45 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.validator;

import java.lang.reflect.InvocationTargetException;

/**
 *
 * @author gkesler
 */
abstract class EnumValidator implements ValueValidator {
    protected abstract Enum valueOf (String name)
            throws IllegalAccessException, InvocationTargetException;

    public boolean validate(Object value) {
        try {
            valueOf(value.toString());
            return true;
        } catch (IllegalAccessException e) {
            return false;
        } catch (InvocationTargetException e) {
            return false;
        }        
    }    
}
