/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.validator.NumberValidator.java
 * 
 * Created: Aug 12, 2011 11:58:58 AM
 * Author: gkesler
 */
package com.intuit.sb.services.query.validator;

/**
 *
 * @author gkesler
 */
abstract class NumberValidator<T extends Number> implements ValueValidator {
    protected abstract T decode (String value) throws NumberFormatException;

    public boolean validate(Object value) {
        try {
            decode(value.toString());
            return true;
        } catch (NumberFormatException e) {
            return false;
        }
    }    
}
