/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.ValidatorException.java
 * 
 * Created: Jul 12, 2011 1:19:23 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query.validator;

import com.intuit.sb.services.query.parser.SimpleNode;

/**
 *
 * @author gkesler
 */
public class ValidatorException extends RuntimeException {
    private SimpleNode problemNode;

    /**
     * Creates a new instance of <code>ValidatorException</code> without detail message.
     */
    public ValidatorException() {
    }

    /**
     * Constructs an instance of <code>ValidatorException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public ValidatorException(String msg) {
        super(msg);
    }
    
    public ValidatorException(String msg, Throwable cause) {
        super(msg, cause);
    }
    
    public ValidatorException(Throwable cause) {
        super(cause);
    }
    
    public ValidatorException setProblemNode (SimpleNode problemNode) {
        this.problemNode = problemNode;
        return this;
    }
    
    public SimpleNode getProblemNode () {
        return problemNode;
    }
}
