/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.SimpleQueryTest.java
 * 
 * Created: Jun 29, 2011 3:02:23 PM
 * Author: gkesler
 */
package com.intuit.sb.services.query;

//import com.intuit.sb.services.query.optimizer.IncludeExcludeOptimizer;
import com.intuit.sb.services.query.parser.SimpleNode;
import com.intuit.sb.services.query.parser.ParseException;
import com.intuit.sb.services.query.parser.SimpleQueryParser;
import org.junit.Ignore;
import java.net.URL;
import java.util.UUID;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author gkesler
 */
public class SimpleQueryTest {

    public SimpleQueryTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    // TODO add test methods here.
    // The methods must be annotated with annotation @Test. For example:
    //
    
    @Test
    public void testAggregateFunction() throws Exception {
        System.out.println("testAggregateFunction");        
        Utils.parse("/aggregate.sq", SimpleQueryParser.SyntaxMode.RESTRICTED);
    }
    
    @Test
    public void testBasic() throws Exception {
        System.out.println("testBasic");
        System.out.println(UUID.randomUUID().toString());
        Utils.parse("/basic.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
    }

    @Test
    public void testBasicOptimizer() throws Exception {
        System.out.println("testBasic");
        System.out.println(UUID.randomUUID().toString());
        SimpleQueryParser parser = Utils.parse("/basic.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
        System.out.println("Original:");
        ((SimpleNode)parser.getRootNode()).dump("->");
//        
//        parser.getRootNode().jjtAccept(new VisitorStub() {
//            public Object visit(ASTSelectStatement node, Object data) {
//                IncludeExcludeOptimizer.getInstance().optimize(node, data);
//                return data;
//            }
//        }, null);
//        
//        System.out.println("Optimized:");
//        ((SimpleNode)parser.getRootNode()).dump(">>");
    }
    
    @Test
    public void testLineComments() throws Exception {
        System.out.println("testLineComments");
        Utils.parse("/withLineComments.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
    }

    @Test
    public void testMultiLineComments() throws Exception {
        System.out.println("testMultiLineComments");
        Utils.parse("/withMultiLineComments.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
    }

    @Test
    public void testRealMultiLineComments() throws Exception {
        System.out.println("testRealMultiLineComments");
        Utils.parse("/withRealMultiLineComments.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
    }

    @Test(expected = ParseException.class)
    public void testBogusAtTheEnd() throws Exception {
        System.out.println("testBogusAtTheEnd");
        Utils.parse("/bogusAtTheEnd.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
    }

    @Test(expected = ParseException.class)
    public void testBogusInTheMiddle() throws Exception {
        System.out.println("testBogusInTheMiddle");
        Utils.parse("/bogusInTheMiddle.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
    }

    @Test
    public void testCommentsInTheMiddle() throws Exception {
        System.out.println("testCommentsInTheMiddle");
        Utils.parse("/withCommentInTheMiddle.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
    }

    @Test
    public void testDump() throws Exception {
        System.out.println("testDump");
        SimpleQuery parser = Utils.parse("/basic.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
//        ((SimpleNode)parser.getRootNode()).dump("-->");
        DumpVisitor.dump(parser.getRootNode(), "-->");
    }
/*
    private abstract static class DumpVisitor implements SimpleQueryVisitor {
        protected int indent = 0;
        
        protected <T extends SimpleNode> void dumpNode(T node, String prefix) {
            StringBuffer buffer = new StringBuffer(prefix);
            for (int i = 0; i < indent; i++) {
                buffer.append(' ');
            }
            buffer.append(node.toString());
            buffer.append(", children=" + node.jjtGetNumChildren());

            if (node.jjtGetValue() != null) {
                buffer.append(", value=");
                buffer.append(node.jjtGetValue());
            }

            System.out.println(buffer.toString());
        }
        
        protected <T extends SimpleNode> Object visitNode (T node, Object data) {
            dumpNode(node, String.valueOf(data));
            
            indent++;
            node.childrenAccept(this, data);
            indent--;
            
            return null;
        }
    }
*/    
    @Test
    public void testDumpVisitor() throws Exception {
        System.out.println("testDumpVisitor");
        SimpleQuery parser = Utils.parse("/basic.sq", SimpleQueryParser.SyntaxMode.EXTENDED);
/*        
        root.jjtAccept(new DumpVisitor() {
            public Object visit(SimpleNode node, Object data) {
                return visitNode(node, data);
            }

//            public Object visit(ASTStatement node, Object data) {
//                return visitNode(node, data);
//            }
//
            public Object visit(ASTSelectStatement node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTSelectClause node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTFromClause node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTWhereClause node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTWithClause node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTOrderByClause node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTPaginationClause node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTPathExpression node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTPathElement node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTContextDeclaration node, Object data) {
                return visitNode(node, data);
            }

//            public Object visit(ASTConditionalExpression node, Object data) {
//                return visitNode(node, data);
//            }
//
            public Object visit(ASTConditionalFactor node, Object data) {
                return visitNode(node, data);
            }

//            public Object visit(ASTSimpleConditionalExpression node, Object data) {
//                return visitNode(node, data);
//            }
//
//            public Object visit(ASTSimpleConditionalFactor node, Object data) {
//                return visitNode(node, data);
//            }

            public Object visit(ASTExistsExpression node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTSubContextDeclaration node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTBetweenExpression node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTLikeExpression node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTInExpression node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTNullExpression node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTEmptyExpression node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTStringComparison node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTComparisonOperator node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTString node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTNumberComparison node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTNumber node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTDateTimeComparison node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTBooleanComparison node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTIdComparison node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTId node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTMetaDataComparison node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTMetaData node, Object data) {
                return visitNode(node, data);
            }

//            public Object visit(ASTSetItemsList node, Object data) {
//                return visitNode(node, data);
//            }
//
//            public Object visit(ASTSetItem node, Object data) {
//                return visitNode(node, data);
//            }
//
            public Object visit(ASTOrderByItem node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTPaginationItem node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTAggregateExpression node, Object data) {
                return visitNode(node, data);
            }

//            public Object visit(ASTLiteral node, Object data) {
//                return visitNode(node, data);
//            }
//
//            public Object visit(ASTRangeLiteral node, Object data) {
//                return visitNode(node, data);
//            }
//
            public Object visit(ASTDateTime node, Object data) {
                return visitNode(node, data);
            }

//            public Object visit(ASTCurrentDate node, Object data) {
//                return visitNode(node, data);
//            }
//
//            public Object visit(ASTCurrentTimeStamp node, Object data) {
//                return visitNode(node, data);
//            }
//
//            public Object visit(ASTCurrentTime node, Object data) {
//                return visitNode(node, data);
//            }
//
            public Object visit(ASTPatternLiteral node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTEscapeCharacter node, Object data) {
                return visitNode(node, data);
            }

            public Object visit(ASTBoolean node, Object data) {
                return visitNode(node, data);
            }
        }, "*** "); 
 */
    }
}
