/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.services.query.integration.IntegrationGeneratorTest.java
 * 
 * Created: Aug 18, 2011 1:35:29 AM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.integration.ids;

import com.intuit.sb.services.query.DumpVisitor;
import com.intuit.sb.services.query.validator.SimpleQueryValidator;
import com.intuit.sb.services.query.Utils;
import com.intuit.sb.services.query.SimpleQuery;
import com.intuit.sb.cdm.v2.CdmBase;
import com.intuit.sb.services.query.DumpGeneratorDelegate;
import com.intuit.sb.services.query.generator.SimpleQueryGenerator;
import com.intuit.sb.services.query.validator.context.Context;
import com.intuit.sb.services.query.validator.context.ContextFactory;
import com.intuit.sb.services.query.validator.context.MetadataProvider;
import com.intuit.sb.services.query.validator.context.MetadataProviderFactory;
import java.util.Map;
import java.util.HashMap;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;

/**
 *
 * @author gkesler
 */
public class IntegrationGeneratorTest {
    
    public IntegrationGeneratorTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }
    
    private Map<String, Object> createProperties() {
        return new HashMap<String, Object>() {
            {
                put(ContextFactory.CONTEXT_USER_ID, System.getProperty("user.name"));
                put(ContextFactory.CONTEXT_APP_ID, "SimpleQuery-console");
                put(ContextFactory.CONTEXT_PREFIX, CdmBase.class.getPackage().getName());
                put(ContextFactory.PAGE_MAX_LIMIT, Integer.valueOf(1024));
                put(ContextFactory.METADATA_PROVIDER_FACTORY, new MetadataProviderFactory() {
                    public MetadataProvider createMetadataProvider(Context context, Class contextType) {
                        return new IntegrationMetadataProvider(this, context, contextType);
                    }
                });
            }
        };
    }
    
    private final void generatorTest (String resourceName, SimpleQuery.SyntaxMode syntaxMode) throws Exception {
        DumpVisitor dumper = new DumpVisitor();

        System.out.println("resourceName=" + resourceName);
        SimpleQuery parser = Utils.parse(resourceName, createProperties(), syntaxMode);        
        dumper.dumpTree(parser.getRootNode(), "parsed -->");

        parser.validate();        
        dumper.dumpTree(parser.getRootNode(), "validated -->");
        
        parser.generate(new DumpGeneratorDelegate());
    }
    
    // TODO add test methods here.
    // The methods must be annotated with annotation @Test. For example:
    
    @Test
    public void testBasicGenerator() throws Exception {
        System.out.println("testBasicGenerator");
        generatorTest("/integration/basicInvoiceQuery.sq", SimpleQuery.SyntaxMode.RESTRICTED);
    }
}
