/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.datasync.query.rest.SimpleQueryParamUnmarshaller.java
 * 
 * Created: Nov 29, 2011 11:57:32 PM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.ws.rs.resteasy;

import com.intuit.sb.services.query.SimpleQuery;
import java.lang.annotation.Annotation;
import java.util.Arrays;
import javax.ws.rs.ext.Provider;
import javax.ws.rs.ext.Providers;
import javax.ws.rs.ext.RuntimeDelegate;
import org.apache.log4j.Logger;
import org.jboss.resteasy.spi.StringParameterUnmarshaller;

/**
 *
 * @author gkesler
 */
@Provider
public class SimpleQueryParamUnmarshaller extends SimpleQueryStringConverter 
        implements StringParameterUnmarshaller<SimpleQuery> { 
    private static final Logger logger = Logger.getLogger(SimpleQueryParamUnmarshaller.class);
    
    public void setAnnotations(Annotation[] annotations) {
        this.annotations = annotations;
    }

    @Override
    public SimpleQuery fromString(String string) {
        // Working around RESTEasy pre 2.3 bug with not injecting @Context
        // references into the StringConverter/StringUnmarshaller instances
        if (providers == null) {
            providers = (Providers)RuntimeDelegate.getInstance();
            logger.warn("Providers is not injected via @Context annotation, worked around:" + providers);
        }
        return super.fromString(string);
    }
}
