/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.datasync.query.ws.rs.resteasy.SyntaxModeProcessor.java
 * 
 * Created: Nov 30, 2011 1:41:25 PM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.ws.rs.resteasy;

import com.intuit.sb.datasync.query.ws.rs.ConfiguratorProcessor;
import com.intuit.sb.services.query.SimpleQuery;
import java.lang.annotation.Annotation;
import javax.ws.rs.core.MediaType;
import org.apache.log4j.Logger;

/**
 *
 * @author gkesler
 */
public class SyntaxModeProcessor implements ConfiguratorProcessor<SyntaxMode> {
    private static final Logger logger = Logger.getLogger(SyntaxModeProcessor.class);

    public void configure(SimpleQuery target, SyntaxMode configurator, Annotation[] annotations, MediaType mediaType) {
        SimpleQuery.SyntaxMode syntaxMode = configurator.value();
        target.setSyntaxMode(syntaxMode);
        logger.debug("syntaxMode=" + syntaxMode);
    }    
}
