/*
 * Copyright 2007 Intuit Inc. All rights reserved. Unauthorized reproduction
 * is a violation of applicable law. This material contains certain
 * confidential or proprietary information and trade secrets of Intuit Inc.
 * 
 * com.intuit.sb.datasync.query.rest.SimpleQueryContextResolverTest.java
 * 
 * Created: Nov 28, 2011 6:34:09 PM
 * Author: gkesler
 */
package com.intuit.sb.datasync.query.ws.rs;

import com.intuit.sb.services.query.SimpleQueryContext;
import com.intuit.spc.bhp.serviceapi.authentication.IBHPPrincipal;
import com.intuit.spc.bhp.serviceapi.authentication.ILoginSourceName;
import com.intuit.spc.bhp.serviceapi.entity.ICredential;
import com.intuit.spc.bhp.serviceapi.entity.IIdentity;
import com.intuit.spc.bhp.serviceapi.entity.IIdentity.SecurityLevel;
import com.intuit.spc.bhp.serviceapi.entity.IIdentity.UserType;
import com.intuit.spc.bhp.serviceapi.entity.IdentityLifecycleStatus;
import com.intuit.spc.bhp.serviceapi.entity.OfferingRole;
import com.intuit.spc.bhp.serviceapi.entity.OfferingWrapper;
import com.intuit.spc.bhp.serviceapi.entity.Permission;
import com.intuit.spc.bhp.serviceapi.entity.RealmRole;
import java.io.InputStream;
import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;
import java.security.Principal;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.servlet.RequestDispatcher;
import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.PathSegment;
import javax.ws.rs.core.UriBuilder;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.SecurityContext;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.ext.ContextResolver;
import javax.ws.rs.ext.ExceptionMapper;
import javax.ws.rs.ext.MessageBodyReader;
import javax.ws.rs.ext.MessageBodyWriter;
import javax.ws.rs.ext.Providers;
import org.apache.log4j.BasicConfigurator;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Assert;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 *
 * @author gkesler
 */
public class SimpleQueryContextResolverTest {
    private ServletContext servletContext;
    private UriInfo uriInfo;
    private SecurityContext securityContext;
    
    public SimpleQueryContextResolverTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }
    
    @Before
    public void setUp() {
        BasicConfigurator.configure();
        
        servletContext = new ServletContext() {
            Map<String, String> initParams = new HashMap<String, String>() {
                {
                    put(SimpleQueryConstants.CLASS_BASES, "v2:com.intuit.sb.cdm.v2.CdmBase;v1:com.intuit.sb.cdm.basetypes.CdmBase");
                }
            };

            public ServletContext getContext(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public String getContextPath() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public int getMajorVersion() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public int getMinorVersion() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public String getMimeType(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public Set getResourcePaths(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public URL getResource(String string) throws MalformedURLException {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public InputStream getResourceAsStream(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public RequestDispatcher getRequestDispatcher(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public RequestDispatcher getNamedDispatcher(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public Servlet getServlet(String string) throws ServletException {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public Enumeration getServlets() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public Enumeration getServletNames() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void log(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void log(Exception excptn, String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void log(String string, Throwable thrwbl) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public String getRealPath(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public String getServerInfo() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public String getInitParameter(String string) {
                return initParams.get(string);
            }

            public Enumeration getInitParameterNames() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public Object getAttribute(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public Enumeration getAttributeNames() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void setAttribute(String string, Object o) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void removeAttribute(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public String getServletContextName() {
                throw new UnsupportedOperationException("Not supported yet.");
            }
        };
        
        uriInfo = new UriInfo() {
            public String getPath() {
                return "/v2/12345678/invoice";
            }

            public String getPath(boolean bln) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public List<PathSegment> getPathSegments() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public List<PathSegment> getPathSegments(boolean bln) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public URI getRequestUri() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public UriBuilder getRequestUriBuilder() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public URI getAbsolutePath() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public UriBuilder getAbsolutePathBuilder() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public URI getBaseUri() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public UriBuilder getBaseUriBuilder() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public MultivaluedMap<String, String> getPathParameters() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public MultivaluedMap<String, String> getPathParameters(boolean bln) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public MultivaluedMap<String, String> getQueryParameters() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public MultivaluedMap<String, String> getQueryParameters(boolean bln) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public List<String> getMatchedURIs() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public List<String> getMatchedURIs(boolean bln) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public List<Object> getMatchedResources() {
                throw new UnsupportedOperationException("Not supported yet.");
            }
        };
        
        securityContext = new SecurityContext() {
            public Principal getUserPrincipal() {
                return new IBHPPrincipal() {
                    public boolean checkPermission(Permission permission) throws Exception {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public void setName(String string) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public IIdentity getIdentity() {
                        return new IIdentity() {
                            public String getAgentId() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setAgentId(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getAuthId() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setAuthId(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getAuthStatus() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setAuthStatus(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getCurrentRealmId() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setCurrentRealmId(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getEmail() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setEmail(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getLoginName() {
                                return "gkesler@sbcglobal.net";
                            }

                            public void setLoginName(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getNamespaceId() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setNamespaceId(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getRemoteIP() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setRemoteIP(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setPassword(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setSecurityAnswer(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public SecurityLevel getSecurityLevel() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setSecurityLevel(SecurityLevel sl) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public String getSecurityQuestion() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setSecurityQuestion(String string) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public UserType getUserType() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setUserType(UserType ut) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public ICredential getCredential() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setCredential(ICredential ic) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public ICredential getLongLivedCredential() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setLongLivedCredential(ICredential ic) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public IdentityLifecycleStatus getLifecycleStatus() {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }

                            public void setLifecycleStatus(IdentityLifecycleStatus ils) {
                                throw new UnsupportedOperationException("Not supported yet.");
                            }
                        };
                    }

                    public void setIdentity(IIdentity ii) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public String getCurrentOfferingId() {
                        return "Greg's test";
                    }

                    public void setCurrentOfferingId(String string) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public List<RealmRole> getCurrentRealmRoles() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public void setCurrentRealmRoles(List<RealmRole> list) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public List<OfferingRole> getCurrentOfferingRoles() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public void setCurrentOfferingRoles(List<OfferingRole> list) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public List<String> getRealmIds() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public void setRealmIds(List<String> list) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public List<Permission> getPermissions() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public void setPermissions(List<Permission> list) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public List<OfferingWrapper> getOfferingWrappers() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public void setOfferingWrappers(List<OfferingWrapper> list) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public ILoginSourceName getLoginSourceName() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public List<String> getAdditionalRole() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public void addAdditionalRole(String string) {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }

                    public String getName() {
                        throw new UnsupportedOperationException("Not supported yet.");
                    }
                };
            }

            public boolean isUserInRole(String string) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public boolean isSecure() {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public String getAuthenticationScheme() {
                throw new UnsupportedOperationException("Not supported yet.");
            }
        };
    }
    
    @After
    public void tearDown() {
    }
    
    // TODO add test methods here.
    // The methods must be annotated with annotation @Test. For example:
    //
    @Test
    public void testScanContexts() {
        System.out.println("testScanContexts");
        
        System.setProperty(SimpleQueryConstants.CLASS_BASES, "v2:com.intuit.sb.cdm.v2.CdmBase;v1:com.intuit.sb.cdm.basetypes.CdmBase");
        ContextMapContextResolver contextResolver = new ContextMapContextResolver();
        contextResolver.setServletContext(servletContext);
        
        ContextMap contextMap = contextResolver.getContext(ContextMap.class);        
        Assert.assertEquals("Customer contexts", new ContextMap.ContextDesc("com.intuit.sb.cdm.v2.Customer"), contextMap.getContextDesc("/customer/v2/12345"));
        Assert.assertEquals("Invoice contexts", new ContextMap.ContextDesc("com.intuit.sb.cdm.v2.Invoice"), contextMap.getContextDesc("/v2/12345/invoice"));
        Assert.assertEquals("Item contexts", new ContextMap.ContextDesc("com.intuit.sb.cdm.v2.Item"), contextMap.getContextDesc("/v2/12345/item"));
    }
    
    @Test
    public void testGetContext() {
        System.out.println("testGetContext");
        
        SimpleQueryContextResolver contextResolver = new SimpleQueryContextResolver();
        contextResolver.setProviders(new Providers() {
            final Map<Class, ContextResolver> contextResolvers = new HashMap<Class, ContextResolver>();
            {
                ContextMapContextResolver o = new ContextMapContextResolver();
                o.setServletContext(servletContext);
                contextResolvers.put(ContextMap.class, o);
            }

            public <T> MessageBodyReader<T> getMessageBodyReader(Class<T> type, Type type1, Annotation[] antns, MediaType mt) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public <T> MessageBodyWriter<T> getMessageBodyWriter(Class<T> type, Type type1, Annotation[] antns, MediaType mt) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public <T extends Throwable> ExceptionMapper<T> getExceptionMapper(Class<T> type) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public <T> ContextResolver<T> getContextResolver(Class<T> type, MediaType mt) {
                return contextResolvers.get(type);
            }
        });
        contextResolver.setUriInfo(uriInfo);
        contextResolver.setSecurityContext(securityContext);
        
        SimpleQueryContext context = contextResolver.getContext(SimpleQueryContext.class);
        Assert.assertNotNull(context);
        System.out.println(String.valueOf(context));
    }
}
